/*
 * This file was generated automatically by ExtUtils::ParseXS version 2.15 from the
 * contents of BerkeleyDB.xs. Do not edit this file, edit BerkeleyDB.xs instead.
 *
 *	ANY CHANGES MADE HERE WILL BE LOST! 
 *
 */

#line 1 "BerkeleyDB.xs"
/*

 BerkeleyDB.xs -- Perl 5 interface to Berkeley DB version 2, 3 & 4

 written by Paul Marquess <pmqs@cpan.org>

 All comments/suggestions/problems are welcome

     Copyright (c) 1997-2006 Paul Marquess. All rights reserved.
     This program is free software; you can redistribute it and/or
     modify it under the same terms as Perl itself.

     Please refer to the COPYRIGHT section in

 Changes:
        0.01 -  First Alpha Release
        0.02 -

*/



#ifdef __cplusplus
extern "C" {
#endif

#define PERL_POLLUTE
#include "EXTERN.h"
#include "perl.h"
#include "XSUB.h"
#include "ppport.h"


/* XSUB.h defines a macro called abort 				*/
/* This clashes with the txn abort method in Berkeley DB 4.x	*/
/* This is a problem with ActivePerl (at least)			*/

#ifdef _WIN32
#  ifdef abort
#    undef abort
#  endif
#  ifdef fopen
#    undef fopen
#  endif
#  ifdef fclose
#    undef fclose
#  endif
#  ifdef rename
#    undef rename
#  endif
#  ifdef open
#    undef open
#  endif
#endif

/* Being the Berkeley DB we prefer the <sys/cdefs.h> (which will be
 * shortly #included by the <db.h>) __attribute__ to the possibly
 * already defined __attribute__, for example by GNUC or by Perl. */

#undef __attribute__

#ifdef USE_PERLIO
#    define GetFILEptr(sv) PerlIO_findFILE(IoIFP(sv_2io(sv)))
#else
#    define GetFILEptr(sv) IoIFP(sv_2io(sv))
#endif

#include <db.h>

/* Check the version of Berkeley DB */

#ifndef DB_VERSION_MAJOR
#ifdef HASHMAGIC
#error db.h is from Berkeley DB 1.x - need at least Berkeley DB 2.6.4
#else
#error db.h is not for Berkeley DB at all.
#endif
#endif

#if (DB_VERSION_MAJOR == 2 && DB_VERSION_MINOR < 6) ||\
    (DB_VERSION_MAJOR == 2 && DB_VERSION_MINOR == 6 && DB_VERSION_PATCH < 4)
#  error db.h is from Berkeley DB 2.0-2.5 - need at least Berkeley DB 2.6.4
#endif


#if (DB_VERSION_MAJOR == 3 && DB_VERSION_MINOR == 0)
#  define IS_DB_3_0_x
#endif

#if DB_VERSION_MAJOR >= 3
#  define AT_LEAST_DB_3
#endif

#if DB_VERSION_MAJOR > 3 || (DB_VERSION_MAJOR == 3 && DB_VERSION_MINOR >= 1)
#  define AT_LEAST_DB_3_1
#endif

#if DB_VERSION_MAJOR > 3 || (DB_VERSION_MAJOR == 3 && DB_VERSION_MINOR >= 2)
#  define AT_LEAST_DB_3_2
#endif

#if DB_VERSION_MAJOR > 3 || \
    (DB_VERSION_MAJOR == 3 && DB_VERSION_MINOR > 2) ||\
    (DB_VERSION_MAJOR == 3 && DB_VERSION_MINOR == 2 && DB_VERSION_PATCH >= 6)
#  define AT_LEAST_DB_3_2_6
#endif

#if DB_VERSION_MAJOR > 3 || (DB_VERSION_MAJOR == 3 && DB_VERSION_MINOR >= 3)
#  define AT_LEAST_DB_3_3
#endif

#if DB_VERSION_MAJOR >= 4
#  define AT_LEAST_DB_4
#endif

#if DB_VERSION_MAJOR > 4 || (DB_VERSION_MAJOR == 4 && DB_VERSION_MINOR >= 1)
#  define AT_LEAST_DB_4_1
#endif

#if DB_VERSION_MAJOR > 4 || (DB_VERSION_MAJOR == 4 && DB_VERSION_MINOR >= 2)
#  define AT_LEAST_DB_4_2
#endif

#if DB_VERSION_MAJOR > 4 || (DB_VERSION_MAJOR == 4 && DB_VERSION_MINOR >= 3)
#  define AT_LEAST_DB_4_3
#endif

#if DB_VERSION_MAJOR > 4 || (DB_VERSION_MAJOR == 4 && DB_VERSION_MINOR >= 4)
#  define AT_LEAST_DB_4_4
#endif

#if DB_VERSION_MAJOR > 4 || (DB_VERSION_MAJOR == 4 && DB_VERSION_MINOR >= 5)
#  define AT_LEAST_DB_4_5
#endif

#ifdef __cplusplus
}
#endif

#define DBM_FILTERING
#define STRICT_CLOSE
/* #define ALLOW_RECNO_OFFSET */
/* #define TRACE */

#if DB_VERSION_MAJOR == 2 && ! defined(DB_LOCK_DEADLOCK)
#  define DB_LOCK_DEADLOCK	EAGAIN
#endif /* DB_VERSION_MAJOR == 2 */

#if DB_VERSION_MAJOR == 2
#  define DB_QUEUE		4
#endif /* DB_VERSION_MAJOR == 2 */

#if DB_VERSION_MAJOR == 2 
#  define BackRef	internal
#else
#  if DB_VERSION_MAJOR == 3 || (DB_VERSION_MAJOR == 4 && DB_VERSION_MINOR == 0)
#    define BackRef	cj_internal
#  else
#    define BackRef	api_internal
#  endif
#endif

#ifdef AT_LEAST_DB_3_2
#    define DB_callback	DB * db,
#    define getCurrentDB ((BerkeleyDB)db->BackRef) 
#    define saveCurrentDB(db) 
#else
#    define DB_callback
#    define getCurrentDB CurrentDB
#    define saveCurrentDB(db) CurrentDB = db
#endif

#if DB_VERSION_MAJOR > 2
typedef struct {
        int              db_lorder;
        size_t           db_cachesize;
        size_t           db_pagesize;


        void *(*db_malloc) __P((size_t));
        int (*dup_compare)
            __P((DB_callback const DBT *, const DBT *));

        u_int32_t        bt_maxkey;
        u_int32_t        bt_minkey;
        int (*bt_compare)
            __P((DB_callback const DBT *, const DBT *));
        size_t (*bt_prefix)
            __P((DB_callback const DBT *, const DBT *));

        u_int32_t        h_ffactor;
        u_int32_t        h_nelem;
        u_int32_t      (*h_hash)
            __P((DB_callback const void *, u_int32_t));

        int              re_pad;
        int              re_delim;
        u_int32_t        re_len;
        char            *re_source;

#define DB_DELIMITER            0x0001
#define DB_FIXEDLEN             0x0008
#define DB_PAD                  0x0010
        u_int32_t        flags;
        u_int32_t        q_extentsize;
} DB_INFO ;

#endif /* DB_VERSION_MAJOR > 2 */

typedef struct {
	int		Status ;
	/* char		ErrBuff[1000] ; */
	SV *		ErrPrefix ;
	SV *		ErrHandle ;
	DB_ENV *	Env ;
	int		open_dbs ;
	int		TxnMgrStatus ;
	int		active ;
	bool		txn_enabled ;
	bool		opened ;
	bool		cds_enabled;
	} BerkeleyDB_ENV_type ;


typedef struct {
        DBTYPE  	type ;
	bool		recno_or_queue ;
	char *		filename ;
	BerkeleyDB_ENV_type * parent_env ;
        DB *    	dbp ;
        SV *    	compare ;
        bool    	in_compare ;
        SV *    	dup_compare ;
        bool    	in_dup_compare ;
        SV *    	prefix ;
        bool    	in_prefix ;
        SV *   	 	hash ;
        bool    	in_hash ;
#ifdef AT_LEAST_DB_3_3
        SV *   	 	associated ;
        bool		secondary_db ;
#endif
        bool		primary_recno_or_queue ;
	int		Status ;
        DB_INFO *	info ;
        DBC *   	cursor ;
	DB_TXN *	txn ;
	int		open_cursors ;
	u_int32_t	partial ;
	u_int32_t	dlen ;
	u_int32_t	doff ;
	int		active ;
	bool		cds_enabled;
#ifdef ALLOW_RECNO_OFFSET
	int		array_base ;
#endif
#ifdef DBM_FILTERING
        SV *    filter_fetch_key ;
        SV *    filter_store_key ;
        SV *    filter_fetch_value ;
        SV *    filter_store_value ;
        int     filtering ;
#endif
        } BerkeleyDB_type;


typedef struct {
        DBTYPE  	type ;
	bool		recno_or_queue ;
	char *		filename ;
        DB *    	dbp ;
        SV *    	compare ;
        SV *    	dup_compare ;
        SV *    	prefix ;
        SV *   	 	hash ;
#ifdef AT_LEAST_DB_3_3
        SV *   	 	associated ;
	bool		secondary_db ;
#endif
	bool		primary_recno_or_queue ;
	int		Status ;
        DB_INFO *	info ;
        DBC *   	cursor ;
	DB_TXN *	txn ;
	BerkeleyDB_type *		parent_db ;
	u_int32_t	partial ;
	u_int32_t	dlen ;
	u_int32_t	doff ;
	int		active ;
	bool		cds_enabled;
#ifdef ALLOW_RECNO_OFFSET
	int		array_base ;
#endif
#ifdef DBM_FILTERING
        SV *    filter_fetch_key ;
        SV *    filter_store_key ;
        SV *    filter_fetch_value ;
        SV *    filter_store_value ;
        int     filtering ;
#endif
        } BerkeleyDB_Cursor_type;

typedef struct {
	BerkeleyDB_ENV_type *	env ;
	} BerkeleyDB_TxnMgr_type ;

#if 1
typedef struct {
	int		Status ;
	DB_TXN *	txn ;
	int		active ;
	} BerkeleyDB_Txn_type ;
#else
typedef DB_TXN                BerkeleyDB_Txn_type ;
#endif

typedef BerkeleyDB_ENV_type *	BerkeleyDB__Env ;
typedef BerkeleyDB_ENV_type *	BerkeleyDB__Env__Raw ;
typedef BerkeleyDB_ENV_type *	BerkeleyDB__Env__Inner ;
typedef BerkeleyDB_type * 	BerkeleyDB ;
typedef void * 			BerkeleyDB__Raw ;
typedef BerkeleyDB_type *	BerkeleyDB__Common ;
typedef BerkeleyDB_type *	BerkeleyDB__Common__Raw ;
typedef BerkeleyDB_type *	BerkeleyDB__Common__Inner ;
typedef BerkeleyDB_type * 	BerkeleyDB__Hash ;
typedef BerkeleyDB_type * 	BerkeleyDB__Hash__Raw ;
typedef BerkeleyDB_type * 	BerkeleyDB__Btree ;
typedef BerkeleyDB_type * 	BerkeleyDB__Btree__Raw ;
typedef BerkeleyDB_type * 	BerkeleyDB__Recno ;
typedef BerkeleyDB_type * 	BerkeleyDB__Recno__Raw ;
typedef BerkeleyDB_type * 	BerkeleyDB__Queue ;
typedef BerkeleyDB_type * 	BerkeleyDB__Queue__Raw ;
typedef BerkeleyDB_Cursor_type   	BerkeleyDB__Cursor_type ;
typedef BerkeleyDB_Cursor_type * 	BerkeleyDB__Cursor ;
typedef BerkeleyDB_Cursor_type * 	BerkeleyDB__Cursor__Raw ;
typedef BerkeleyDB_TxnMgr_type * BerkeleyDB__TxnMgr ;
typedef BerkeleyDB_TxnMgr_type * BerkeleyDB__TxnMgr__Raw ;
typedef BerkeleyDB_TxnMgr_type * BerkeleyDB__TxnMgr__Inner ;
typedef BerkeleyDB_Txn_type *	BerkeleyDB__Txn ;
typedef BerkeleyDB_Txn_type *	BerkeleyDB__Txn__Raw ;
typedef BerkeleyDB_Txn_type *	BerkeleyDB__Txn__Inner ;
#if 0
typedef DB_LOG *      		BerkeleyDB__Log ;
typedef DB_LOCKTAB *  		BerkeleyDB__Lock ;
#endif
typedef DBT 			DBTKEY ;
typedef DBT 			DBT_OPT ;
typedef DBT 			DBT_B ;
typedef DBT 			DBTKEY_B ;
typedef DBT 			DBTKEY_Br ;
typedef DBT 			DBTKEY_Bpr ;
typedef DBT 			DBTVALUE ;
typedef void *	      		PV_or_NULL ;
typedef PerlIO *      		IO_or_NULL ;
typedef int			DualType ;
typedef SV          SVnull;

static void
hash_delete(char * hash, char * key);

#ifdef TRACE
#  define Trace(x)	printf x
#else
#  define Trace(x)
#endif

#ifdef ALLOW_RECNO_OFFSET
#  define RECNO_BASE	db->array_base
#else
#  define RECNO_BASE	1
#endif

#if DB_VERSION_MAJOR == 2
#  define flagSet_DB2(i, f) i |= f
#else
#  define flagSet_DB2(i, f)
#endif

#if DB_VERSION_MAJOR == 2 && DB_VERSION_MINOR < 5
#  define flagSet(bitmask)        (flags & (bitmask))
#else
#  define flagSet(bitmask)	((flags & DB_OPFLAGS_MASK) == (bitmask))
#endif


#define ERR_BUFF "BerkeleyDB::Error"

#define ZMALLOC(to, typ) ((to = (typ *)safemalloc(sizeof(typ))), \
				Zero(to,1,typ))

#define DBT_clear(x)	Zero(&x, 1, DBT) ;

#if 1
#define getInnerObject(x) (*av_fetch((AV*)SvRV(x), 0, FALSE))
#else
#define getInnerObject(x) ((SV*)SvRV(sv))
#endif

#define my_sv_setpvn(sv, d, s) (s ? sv_setpvn(sv, d, s) : sv_setpv(sv, "") )

#define GetValue_iv(h,k) (((sv = readHash(h, k)) && sv != &PL_sv_undef) \
				? SvIV(sv) : 0)
#define SetValue_iv(i, k) if ((sv = readHash(hash, k)) && sv != &PL_sv_undef) \
				i = SvIV(sv)
#define SetValue_io(i, k) if ((sv = readHash(hash, k)) && sv != &PL_sv_undef) \
				i = GetFILEptr(sv)
#define SetValue_sv(i, k) if ((sv = readHash(hash, k)) && sv != &PL_sv_undef) \
				i = sv
#define SetValue_pv(i, k,t) if ((sv = readHash(hash, k)) && sv != &PL_sv_undef) \
				i = (t)SvPV(sv,PL_na)
#define SetValue_pvx(i, k, t) if ((sv = readHash(hash, k)) && sv != &PL_sv_undef) \
				i = (t)SvPVX(sv)
#define SetValue_ov(i,k,t) if ((sv = readHash(hash, k)) && sv != &PL_sv_undef) {\
				IV tmp = SvIV(getInnerObject(sv)) ;	\
				i = INT2PTR(t, tmp) ;			\
			  }

#define SetValue_ovx(i,k,t) if ((sv = readHash(hash, k)) && sv != &PL_sv_undef) {\
				HV * hv = (HV *)GetInternalObject(sv);		\
				SV ** svp = hv_fetch(hv, "db", 2, FALSE);\
				IV tmp = SvIV(*svp);			\
				i = INT2PTR(t, tmp) ;				\
			  }

#define SetValue_ovX(i,k,t) if ((sv = readHash(hash, k)) && sv != &PL_sv_undef) {\
				IV tmp = SvIV(GetInternalObject(sv));\
				i = INT2PTR(t, tmp) ;				\
			  }

#define LastDBerror DB_RUNRECOVERY

#define setDUALerrno(var, err)					\
		sv_setnv(var, (double)err) ;			\
		sv_setpv(var, ((err) ? db_strerror(err) : "")) ;\
		SvNOK_on(var);

#define OutputValue(arg, name)                                  \
        { if (RETVAL == 0) {                                    \
              my_sv_setpvn(arg, name.data, name.size) ;         \
              DBM_ckFilter(arg, filter_fetch_value,"filter_fetch_value") ;            \
          }                                                     \
        }

#define OutputValue_B(arg, name)                                  \
        { if (RETVAL == 0) {                                    \
		if (db->type == DB_BTREE && 			\
			flagSet(DB_GET_RECNO)){			\
                    sv_setiv(arg, (I32)(*(I32*)name.data) - RECNO_BASE); \
                }                                               \
                else {                                          \
                    my_sv_setpvn(arg, name.data, name.size) ;   \
                }                                               \
                DBM_ckFilter(arg, filter_fetch_value, "filter_fetch_value");          \
          }                                                     \
        }

#define OutputKey(arg, name)                                    \
        { if (RETVAL == 0) 					\
          {                                                     \
                if (!db->recno_or_queue) {                     	\
                    my_sv_setpvn(arg, name.data, name.size);    \
                }                                               \
                else                                            \
                    sv_setiv(arg, (I32)*(I32*)name.data - RECNO_BASE);   \
                DBM_ckFilter(arg, filter_fetch_key, "filter_fetch_key") ;            \
          }                                                     \
        }

#define OutputKey_B(arg, name)                                  \
        { if (RETVAL == 0) 					\
          {                                                     \
                if (db->recno_or_queue 	                        \
			|| (db->type == DB_BTREE && 		\
			    flagSet(DB_GET_RECNO))){		\
                    sv_setiv(arg, (I32)(*(I32*)name.data) - RECNO_BASE); \
                }                                               \
                else {                                          \
                    my_sv_setpvn(arg, name.data, name.size);    \
                }                                               \
                DBM_ckFilter(arg, filter_fetch_key, "filter_fetch_key") ;            \
          }                                                     \
        }

#define OutputKey_Br(arg, name)                                  \
        { if (RETVAL == 0) 					\
          {                                                     \
                if (db->recno_or_queue || db->primary_recno_or_queue	\
			|| (db->type == DB_BTREE && 		\
			    flagSet(DB_GET_RECNO))){		\
                    sv_setiv(arg, (I32)(*(I32*)name.data) - RECNO_BASE); \
                }                                               \
                else {                                          \
                    my_sv_setpvn(arg, name.data, name.size);    \
                }                                               \
                DBM_ckFilter(arg, filter_fetch_key, "filter_fetch_key") ;            \
          }                                                     \
        }

#define OutputKey_Bpr(arg, name)                                  \
        { if (RETVAL == 0) 					\
          {                                                     \
                if (db->primary_recno_or_queue	\
			|| (db->type == DB_BTREE && 		\
			    flagSet(DB_GET_RECNO))){		\
                    sv_setiv(arg, (I32)(*(I32*)name.data) - RECNO_BASE); \
                }                                               \
                else {                                          \
                    my_sv_setpvn(arg, name.data, name.size);    \
                }                                               \
                DBM_ckFilter(arg, filter_fetch_key, "filter_fetch_key") ;            \
          }                                                     \
        }

#define SetPartial(data,db) 					\
	data.flags = db->partial ;				\
	data.dlen  = db->dlen ;					\
	data.doff  = db->doff ;

#define ckActive(active, type) 					\
    {								\
	if (!active)						\
	    softCrash("%s is already closed", type) ;		\
    }

#define ckActive_Environment(a)	ckActive(a, "Environment")
#define ckActive_TxnMgr(a)	ckActive(a, "Transaction Manager")
#define ckActive_Transaction(a) ckActive(a, "Transaction")
#define ckActive_Database(a) 	ckActive(a, "Database")
#define ckActive_Cursor(a) 	ckActive(a, "Cursor")

#define dieIfEnvOpened(e, m) if (e->opened) softCrash("Cannot call method BerkeleyDB::Env::%s after environment has been opened", m);	

#define isSTDOUT_ERR(f) ((f) == stdout || (f) == stderr)

/* Internal Global Data */
static db_recno_t Value ;
static db_recno_t zero = 0 ;
static BerkeleyDB	CurrentDB ;

static DBTKEY	empty ;
#if 0
static char	ErrBuff[1000] ;
#endif

#ifdef AT_LEAST_DB_3_3
#    if PERL_REVISION == 5 && PERL_VERSION <= 4

/* saferealloc in perl5.004 will croak if it is given a NULL pointer*/
void *
MyRealloc(void * ptr, size_t size)
{
    if (ptr == NULL ) 
        return safemalloc(size) ; 
    else
        return saferealloc(ptr, size) ;
}

#    else
#        define MyRealloc saferealloc
#    endif
#endif

static char *
my_strdup(const char *s)
{
    if (s == NULL)
        return NULL ;

    {
        MEM_SIZE l = strlen(s) + 1;
        char *s1 = (char *)safemalloc(l);

        Copy(s, s1, (MEM_SIZE)l, char);
        return s1;
    }
}

#if DB_VERSION_MAJOR == 2
static char *
db_strerror(int err)
{
    if (err == 0)
        return "" ;

    if (err > 0)
        return Strerror(err) ;

    switch (err) {
	case DB_INCOMPLETE:
		return ("DB_INCOMPLETE: Sync was unable to complete");
	case DB_KEYEMPTY:
		return ("DB_KEYEMPTY: Non-existent key/data pair");
	case DB_KEYEXIST:
		return ("DB_KEYEXIST: Key/data pair already exists");
	case DB_LOCK_DEADLOCK:
		return (
		    "DB_LOCK_DEADLOCK: Locker killed to resolve a deadlock");
	case DB_LOCK_NOTGRANTED:
		return ("DB_LOCK_NOTGRANTED: Lock not granted");
	case DB_LOCK_NOTHELD:
		return ("DB_LOCK_NOTHELD: Lock not held by locker");
	case DB_NOTFOUND:
		return ("DB_NOTFOUND: No matching key/data pair found");
	case DB_RUNRECOVERY:
		return ("DB_RUNRECOVERY: Fatal error, run database recovery");
	default:
		return "Unknown Error" ;

    }
}
#endif 	/* DB_VERSION_MAJOR == 2 */

#ifdef TRACE
#if DB_VERSION_MAJOR > 2
static char *
my_db_strerror(int err)
{
    static char buffer[1000] ;
    SV * sv = perl_get_sv(ERR_BUFF, FALSE) ;
    sprintf(buffer, "%d: %s", err, db_strerror(err)) ;
    if (err && sv) {
        strcat(buffer, ", ") ;
	strcat(buffer, SvPVX(sv)) ;
    }
    return buffer;
}
#endif
#endif

static void
close_everything(void)
{
    dTHR;
    Trace(("close_everything\n")) ;
    /* Abort All Transactions */
    {
	BerkeleyDB__Txn__Raw 	tid ;
	HE * he ;
	I32 len ;
	HV * hv = perl_get_hv("BerkeleyDB::Term::Txn", TRUE);
	int  all = 0 ;
	int  closed = 0 ;
	(void)hv_iterinit(hv) ;
	Trace(("BerkeleyDB::Term::close_all_txns dirty=%d\n", PL_dirty)) ;
	while ( (he = hv_iternext(hv)) ) {
	    tid = * (BerkeleyDB__Txn__Raw *) hv_iterkey(he, &len) ;
	    Trace(("  Aborting Transaction [%d] in [%d] Active [%d]\n", tid->txn, tid, tid->active));
	    if (tid->active) {
#ifdef AT_LEAST_DB_4
	    tid->txn->abort(tid->txn) ;
#else
	        txn_abort(tid->txn);
#endif
		++ closed ;
	    }
	    tid->active = FALSE ;
	    ++ all ;
	}
	Trace(("End of BerkeleyDB::Term::close_all_txns aborted %d of %d transactios\n",closed, all)) ;
    }

    /* Close All Cursors */
    {
	BerkeleyDB__Cursor db ;
	HE * he ;
	I32 len ;
	HV * hv = perl_get_hv("BerkeleyDB::Term::Cursor", TRUE);
	int  all = 0 ;
	int  closed = 0 ;
	(void) hv_iterinit(hv) ;
	Trace(("BerkeleyDB::Term::close_all_cursors \n")) ;
	while ( (he = hv_iternext(hv)) ) {
	    db = * (BerkeleyDB__Cursor*) hv_iterkey(he, &len) ;
	    Trace(("  Closing Cursor [%d] in [%d] Active [%d]\n", db->cursor, db, db->active));
	    if (db->active) {
    	        ((db->cursor)->c_close)(db->cursor) ;
		++ closed ;
	    }
	    db->active = FALSE ;
	    ++ all ;
	}
	Trace(("End of BerkeleyDB::Term::close_all_cursors closed %d of %d cursors\n",closed, all)) ;
    }

    /* Close All Databases */
    {
	BerkeleyDB db ;
	HE * he ;
	I32 len ;
	HV * hv = perl_get_hv("BerkeleyDB::Term::Db", TRUE);
	int  all = 0 ;
	int  closed = 0 ;
	(void)hv_iterinit(hv) ;
	Trace(("BerkeleyDB::Term::close_all_dbs\n" )) ;
	while ( (he = hv_iternext(hv)) ) {
	    db = * (BerkeleyDB*) hv_iterkey(he, &len) ;
	    Trace(("  Closing Database [%d] in [%d] Active [%d]\n", db->dbp, db, db->active));
	    if (db->active) {
	        (db->dbp->close)(db->dbp, 0) ;
		++ closed ;
	    }
	    db->active = FALSE ;
	    ++ all ;
	}
	Trace(("End of BerkeleyDB::Term::close_all_dbs closed %d of %d dbs\n",closed, all)) ;
    }

    /* Close All Environments */
    {
	BerkeleyDB__Env env ;
	HE * he ;
	I32 len ;
	HV * hv = perl_get_hv("BerkeleyDB::Term::Env", TRUE);
	int  all = 0 ;
	int  closed = 0 ;
	(void)hv_iterinit(hv) ;
	Trace(("BerkeleyDB::Term::close_all_envs\n")) ;
	while ( (he = hv_iternext(hv)) ) {
	    env = * (BerkeleyDB__Env*) hv_iterkey(he, &len) ;
	    Trace(("  Closing Environment [%d] in [%d] Active [%d]\n", env->Env, env, env->active));
	    if (env->active) {
#if DB_VERSION_MAJOR == 2
                db_appexit(env->Env) ;
#else
	        (env->Env->close)(env->Env, 0) ;
#endif
		++ closed ;
	    }
	    env->active = FALSE ;
	    ++ all ;
	}
	Trace(("End of BerkeleyDB::Term::close_all_envs closed %d of %d dbs\n",closed, all)) ;
    }

    Trace(("end close_everything\n")) ;

}

static void
destroyDB(BerkeleyDB db)
{
    dTHR;
    if (! PL_dirty && db->active) {
	if (db->parent_env && db->parent_env->open_dbs)
	    -- db->parent_env->open_dbs ;
      	-- db->open_cursors ;
	((db->dbp)->close)(db->dbp, 0) ;
    }
    if (db->hash)
       	  SvREFCNT_dec(db->hash) ;
    if (db->compare)
       	  SvREFCNT_dec(db->compare) ;
    if (db->dup_compare)
       	  SvREFCNT_dec(db->dup_compare) ;
#ifdef AT_LEAST_DB_3_3
    if (db->associated && !db->secondary_db)
       	  SvREFCNT_dec(db->associated) ;
#endif
    if (db->prefix)
       	  SvREFCNT_dec(db->prefix) ;
#ifdef DBM_FILTERING
    if (db->filter_fetch_key)
          SvREFCNT_dec(db->filter_fetch_key) ;
    if (db->filter_store_key)
          SvREFCNT_dec(db->filter_store_key) ;
    if (db->filter_fetch_value)
          SvREFCNT_dec(db->filter_fetch_value) ;
    if (db->filter_store_value)
          SvREFCNT_dec(db->filter_store_value) ;
#endif
    hash_delete("BerkeleyDB::Term::Db", (char *)db) ;
    if (db->filename)
             Safefree(db->filename) ;
    Safefree(db) ;
}

static int
softCrash(const char *pat, ...)
{
    char buffer1 [500] ;
    char buffer2 [500] ;
    va_list args;
    va_start(args, pat);

    Trace(("softCrash: %s\n", pat)) ;

#define ABORT_PREFIX "BerkeleyDB Aborting: "

    /* buffer = (char*) safemalloc(strlen(pat) + strlen(ABORT_PREFIX) + 1) ; */
    strcpy(buffer1, ABORT_PREFIX) ;
    strcat(buffer1, pat) ;

    vsprintf(buffer2, buffer1, args) ;

    croak(buffer2);

    /* NOTREACHED */
    va_end(args);
    return 1 ;
}


static I32
GetArrayLength(BerkeleyDB db)
{
    DBT		key ;
    DBT		value ;
    int		RETVAL = 0 ;
    DBC *   	cursor ;

    DBT_clear(key) ;
    DBT_clear(value) ;
#if DB_VERSION_MAJOR == 2 && DB_VERSION_MINOR < 6
    if ( ((db->dbp)->cursor)(db->dbp, db->txn, &cursor) == 0 )
#else
    if ( ((db->dbp)->cursor)(db->dbp, db->txn, &cursor, 0) == 0 )
#endif
    {
        RETVAL = cursor->c_get(cursor, &key, &value, DB_LAST) ;
        if (RETVAL == 0)
            RETVAL = *(I32 *)key.data ;
        else /* No key means empty file */
            RETVAL = 0 ;
        cursor->c_close(cursor) ;
    }

    Trace(("GetArrayLength got %d\n", RETVAL)) ;
    return ((I32)RETVAL) ;
}

#if 0

#define GetRecnoKey(db, value)  _GetRecnoKey(db, value)

static db_recno_t
_GetRecnoKey(BerkeleyDB db, I32 value)
{
    Trace(("GetRecnoKey start value = %d\n", value)) ;
    if (db->recno_or_queue && value < 0) {
	/* Get the length of the array */
	I32 length = GetArrayLength(db) ;

	/* check for attempt to write before start of array */
	if (length + value + RECNO_BASE <= 0)
	    softCrash("Modification of non-creatable array value attempted, subscript %ld", (long)value) ;

	value = length + value + RECNO_BASE ;
    }
    else
        ++ value ;

    Trace(("GetRecnoKey end value = %d\n", value)) ;

    return value ;
}

#else /* ! 0 */

#if 0
#ifdef ALLOW_RECNO_OFFSET
#define GetRecnoKey(db, value) _GetRecnoKey(db, value)

static db_recno_t
_GetRecnoKey(BerkeleyDB db, I32 value)
{
    if (value + RECNO_BASE < 1)
	softCrash("key value %d < base (%d)", (value), RECNO_BASE?0:1) ;
    return value + RECNO_BASE ;
}

#else
#endif /* ALLOW_RECNO_OFFSET */
#endif /* 0 */

#define GetRecnoKey(db, value) ((value) + RECNO_BASE )

#endif /* 0 */

#if 0
static SV *
GetInternalObject(SV * sv)
{
    SV * info = (SV*) NULL ;
    SV * s ;
    MAGIC * mg ;

    Trace(("in GetInternalObject %d\n", sv)) ;
    if (sv == NULL || !SvROK(sv))
        return NULL ;

    s = SvRV(sv) ;
    if (SvMAGICAL(s))
    {
        if (SvTYPE(s) == SVt_PVHV || SvTYPE(s) == SVt_PVAV)
            mg = mg_find(s, 'P') ;
        else
            mg = mg_find(s, 'q') ;

	 /* all this testing is probably overkill, but till I know more
	    about global destruction it stays.
	 */
        /* if (mg && mg->mg_obj && SvRV(mg->mg_obj) && SvPVX(SvRV(mg->mg_obj))) */
        if (mg && mg->mg_obj && SvRV(mg->mg_obj) )
            info = SvRV(mg->mg_obj) ;
	else
	    info = s ;
    }

    Trace(("end of GetInternalObject %d\n", info)) ;
    return info ;
}
#endif

static int
btree_compare(DB_callback const DBT * key1, const DBT * key2 )
{
    dSP ;
    char * data1, * data2 ;
    int retval ;
    int count ;
    BerkeleyDB	keepDB = CurrentDB ;

    data1 = (char*) key1->data ;
    data2 = (char*) key2->data ;

#ifndef newSVpvn
    /* As newSVpv will assume that the data pointer is a null terminated C
       string if the size parameter is 0, make sure that data points to an
       empty string if the length is 0
    */
    if (key1->size == 0)
        data1 = "" ;
    if (key2->size == 0)
        data2 = "" ;
#endif

    ENTER ;
    SAVETMPS;

    PUSHMARK(SP) ;
    EXTEND(SP,2) ;
    PUSHs(sv_2mortal(newSVpvn(data1,key1->size)));
    PUSHs(sv_2mortal(newSVpvn(data2,key2->size)));
    PUTBACK ;

    count = perl_call_sv(getCurrentDB->compare, G_SCALAR);

    SPAGAIN ;

    if (count != 1)
        softCrash ("in btree_compare - expected 1 return value from compare sub, got %d", count) ;

    retval = POPi ;

    PUTBACK ;
    FREETMPS ;
    LEAVE ;
    CurrentDB = keepDB ;
    return (retval) ;

}

static int
dup_compare(DB_callback const DBT * key1, const DBT * key2 )
{
    dSP ;
    char * data1, * data2 ;
    int retval ;
    int count ;
    BerkeleyDB	keepDB = CurrentDB ;

    Trace(("In dup_compare \n")) ;
    if (!getCurrentDB)
	softCrash("Internal Error - No CurrentDB in dup_compare") ;
    if (getCurrentDB->dup_compare == NULL)


        softCrash("in dup_compare: no callback specified for database '%s'", getCurrentDB->filename) ;

    data1 = (char*) key1->data ;
    data2 = (char*) key2->data ;

#ifndef newSVpvn
    /* As newSVpv will assume that the data pointer is a null terminated C
       string if the size parameter is 0, make sure that data points to an
       empty string if the length is 0
    */
    if (key1->size == 0)
        data1 = "" ;
    if (key2->size == 0)
        data2 = "" ;
#endif

    ENTER ;
    SAVETMPS;

    PUSHMARK(SP) ;
    EXTEND(SP,2) ;
    PUSHs(sv_2mortal(newSVpvn(data1,key1->size)));
    PUSHs(sv_2mortal(newSVpvn(data2,key2->size)));
    PUTBACK ;

    count = perl_call_sv(getCurrentDB->dup_compare, G_SCALAR);

    SPAGAIN ;

    if (count != 1)
        softCrash ("dup_compare: expected 1 return value from compare sub, got %d", count) ;

    retval = POPi ;

    PUTBACK ;
    FREETMPS ;
    LEAVE ;
    CurrentDB = keepDB ;
    return (retval) ;

}

static size_t
btree_prefix(DB_callback const DBT * key1, const DBT * key2 )
{
    dSP ;
    char * data1, * data2 ;
    int retval ;
    int count ;
    BerkeleyDB	keepDB = CurrentDB ;

    data1 = (char*) key1->data ;
    data2 = (char*) key2->data ;

#ifndef newSVpvn
    /* As newSVpv will assume that the data pointer is a null terminated C
       string if the size parameter is 0, make sure that data points to an
       empty string if the length is 0
    */
    if (key1->size == 0)
        data1 = "" ;
    if (key2->size == 0)
        data2 = "" ;
#endif

    ENTER ;
    SAVETMPS;

    PUSHMARK(SP) ;
    EXTEND(SP,2) ;
    PUSHs(sv_2mortal(newSVpvn(data1,key1->size)));
    PUSHs(sv_2mortal(newSVpvn(data2,key2->size)));
    PUTBACK ;

    count = perl_call_sv(getCurrentDB->prefix, G_SCALAR);

    SPAGAIN ;

    if (count != 1)
        softCrash ("btree_prefix: expected 1 return value from prefix sub, got %d", count) ;

    retval = POPi ;

    PUTBACK ;
    FREETMPS ;
    LEAVE ;
    CurrentDB = keepDB ;

    return (retval) ;
}

static u_int32_t
hash_cb(DB_callback const void * data, u_int32_t size)
{
    dSP ;
    int retval ;
    int count ;
    BerkeleyDB	keepDB = CurrentDB ;

#ifndef newSVpvn
    if (size == 0)
        data = "" ;
#endif

    ENTER ;
    SAVETMPS;

    PUSHMARK(SP) ;

    XPUSHs(sv_2mortal(newSVpvn((char*)data,size)));
    PUTBACK ;

    count = perl_call_sv(getCurrentDB->hash, G_SCALAR);

    SPAGAIN ;

    if (count != 1)
        softCrash ("hash_cb: expected 1 return value from hash sub, got %d", count) ;

    retval = POPi ;

    PUTBACK ;
    FREETMPS ;
    LEAVE ;
    CurrentDB = keepDB ;

    return (retval) ;
}

#ifdef AT_LEAST_DB_3_3

static int
associate_cb(DB_callback const DBT * pkey, const DBT * pdata, DBT * skey)
{
    dSP ;
    char * pk_dat, * pd_dat ;
    /* char *sk_dat ; */
    int retval ;
    int count ;
    SV * skey_SV ;
    STRLEN skey_len;
    char * skey_ptr ;

    Trace(("In associate_cb \n")) ;
    if (getCurrentDB->associated == NULL){
        Trace(("No Callback registered\n")) ;
        return EINVAL ;
    }

    skey_SV = newSVpv("",0);


    pk_dat = (char*) pkey->data ;
    pd_dat = (char*) pdata->data ;

#ifndef newSVpvn
    /* As newSVpv will assume that the data pointer is a null terminated C
       string if the size parameter is 0, make sure that data points to an
       empty string if the length is 0
    */
    if (pkey->size == 0)
        pk_dat = "" ;
    if (pdata->size == 0)
        pd_dat = "" ;
#endif

    ENTER ;
    SAVETMPS;

    PUSHMARK(SP) ;
    EXTEND(SP,2) ;
    PUSHs(sv_2mortal(newSVpvn(pk_dat,pkey->size)));
    PUSHs(sv_2mortal(newSVpvn(pd_dat,pdata->size)));
    PUSHs(sv_2mortal(skey_SV));
    PUTBACK ;

    Trace(("calling associated cb\n"));
    count = perl_call_sv(getCurrentDB->associated, G_SCALAR);
    Trace(("called associated cb\n"));

    SPAGAIN ;

    if (count != 1)
        softCrash ("associate: expected 1 return value from prefix sub, got %d", count) ;

    retval = POPi ;

    PUTBACK ;
    
    /* retrieve the secondary key */
    DBT_clear(*skey);

    skey_ptr = SvPV(skey_SV, skey_len);
    skey->flags = DB_DBT_APPMALLOC;
    /* skey->size = SvCUR(skey_SV); */
    /* skey->data = (char*)safemalloc(skey->size); */
    skey->size = skey_len;
    skey->data = (char*)safemalloc(skey_len);
    memcpy(skey->data, skey_ptr, skey_len);
    Trace(("key is %d -- %.*s\n", skey->size, skey->size, skey->data));

    FREETMPS ;
    LEAVE ;

    return (retval) ;
}

static int
associate_cb_recno(DB_callback const DBT * pkey, const DBT * pdata, DBT * skey)
{
    dSP ;
    char * pk_dat, * pd_dat ;
    /* char *sk_dat ; */
    int retval ;
    int count ;
    SV * skey_SV ;
    STRLEN skey_len;
    char * skey_ptr ;
    db_recno_t Value;

    Trace(("In associate_cb_recno \n")) ;
    if (getCurrentDB->associated == NULL){
        Trace(("No Callback registered\n")) ;
        return EINVAL ;
    }

    skey_SV = newSVpv("",0);


    pk_dat = (char*) pkey->data ;
    pd_dat = (char*) pdata->data ;

#ifndef newSVpvn
    /* As newSVpv will assume that the data pointer is a null terminated C
       string if the size parameter is 0, make sure that data points to an
       empty string if the length is 0
    */
    if (pkey->size == 0)
        pk_dat = "" ;
    if (pdata->size == 0)
        pd_dat = "" ;
#endif

    ENTER ;
    SAVETMPS;

    PUSHMARK(SP) ;
    EXTEND(SP,2) ;
    PUSHs(sv_2mortal(newSVpvn(pk_dat,pkey->size)));
    PUSHs(sv_2mortal(newSVpvn(pd_dat,pdata->size)));
    PUSHs(sv_2mortal(skey_SV));
    PUTBACK ;

    Trace(("calling associated cb\n"));
    count = perl_call_sv(getCurrentDB->associated, G_SCALAR);
    Trace(("called associated cb\n"));

    SPAGAIN ;

    if (count != 1)
        softCrash ("associate: expected 1 return value from prefix sub, got %d", count) ;

    retval = POPi ;

    PUTBACK ;
    
    /* retrieve the secondary key */
    DBT_clear(*skey);

    Value = GetRecnoKey(getCurrentDB, SvIV(skey_SV)) ; 
    skey->flags = DB_DBT_APPMALLOC;
    skey->size = (int)sizeof(db_recno_t);
    skey->data = (char*)safemalloc(skey->size);
    memcpy(skey->data, &Value, skey->size);

    FREETMPS ;
    LEAVE ;

    return (retval) ;
}

#endif /* AT_LEAST_DB_3_3 */

static void
#ifdef AT_LEAST_DB_4_3
db_errcall_cb(const DB_ENV* dbenv, const char * db_errpfx, const char * buffer)
#else
db_errcall_cb(const char * db_errpfx, char * buffer)
#endif
{
#if 0

    if (db_errpfx == NULL)
	db_errpfx = "" ;
    if (buffer == NULL )
	buffer = "" ;
    ErrBuff[0] = '\0';
    if (strlen(db_errpfx) + strlen(buffer) + 3 <= 1000) {
	if (*db_errpfx != '\0') {
	    strcat(ErrBuff, db_errpfx) ;
	    strcat(ErrBuff, ": ") ;
	}
	strcat(ErrBuff, buffer) ;
    }

#endif

    SV * sv = perl_get_sv(ERR_BUFF, FALSE) ;
    if (sv) {
        if (db_errpfx)
	    sv_setpvf(sv, "%s: %s", db_errpfx, buffer) ;
        else
            sv_setpv(sv, buffer) ;
    }
}

static SV *
readHash(HV * hash, char * key)
{
    SV **       svp;
    svp = hv_fetch(hash, key, strlen(key), FALSE);
    if (svp && SvOK(*svp))
        return *svp ;
    return NULL ;
}

static void
hash_delete(char * hash, char * key)
{
    HV * hv = perl_get_hv(hash, TRUE);
    (void) hv_delete(hv, (char*)&key, sizeof(key), G_DISCARD);
}

static void
hash_store_iv(char * hash, char * key, IV value)
{
    HV * hv = perl_get_hv(hash, TRUE);
    (void)hv_store(hv, (char*)&key, sizeof(key), newSViv(value), 0);
    /* printf("hv_store returned %d\n", ret) ; */
}

static void
hv_store_iv(HV * hash, char * key, IV value)
{
    hv_store(hash, key, strlen(key), newSViv(value), 0);
}

#if 0
static void
hv_store_uv(HV * hash, char * key, UV value)
{
    hv_store(hash, key, strlen(key), newSVuv(value), 0);
}
#endif

static void
GetKey(BerkeleyDB_type * db, SV * sv, DBTKEY * key)
{
    if (db->recno_or_queue) {
        Value = GetRecnoKey(db, SvIV(sv)) ; 
        key->data = & Value; 
        key->size = (int)sizeof(db_recno_t);
    }
    else {
        key->data = SvPV(sv, PL_na);
        key->size = (int)PL_na;
    }
}

static BerkeleyDB
my_db_open(
		BerkeleyDB	db ,
		SV * 		ref,
		SV *		ref_dbenv ,
		BerkeleyDB__Env	dbenv ,
    	    	BerkeleyDB__Txn txn, 
		const char *	file,
		const char *	subname,
		DBTYPE		type,
		int		flags,
		int		mode,
		DB_INFO * 	info,
		char *		password,
		int		enc_flags
	)
{
    DB_ENV *	env    = NULL ;
    BerkeleyDB 	RETVAL = NULL ;
    DB *	dbp ;
    int		Status ;
    DB_TXN* 	txnid = NULL ;

    Trace(("_db_open(dbenv[%p] ref_dbenv [%p] file[%s] subname [%s] type[%d] flags[%d] mode[%d]\n",
		dbenv, ref_dbenv, file, subname, type, flags, mode)) ;

    CurrentDB = db ;
    
    if (dbenv)
	env = dbenv->Env ;

    if (txn)
        txnid = txn->txn;

    Trace(("_db_open(dbenv[%p] ref_dbenv [%p] txn [%p] file[%s] subname [%s] type[%d] flags[%d] mode[%d]\n",
		dbenv, ref_dbenv, txn, file, subname, type, flags, mode)) ;

#if DB_VERSION_MAJOR == 2
    if (subname)
        softCrash("Subname needs Berkeley DB 3 or better") ;
#endif

#ifndef AT_LEAST_DB_4_1
	    if (password)
	        softCrash("-Encrypt needs Berkeley DB 4.x or better") ;
#endif /* ! AT_LEAST_DB_4_1 */

#if DB_VERSION_MAJOR > 2
    Status = db_create(&dbp, env, 0) ;
    Trace(("db_create returned %s\n", my_db_strerror(Status))) ;
    if (Status)
        return RETVAL ;

#ifdef AT_LEAST_DB_3_2
	dbp->BackRef = db;
#endif

#ifdef AT_LEAST_DB_3_3
    if (! env) {
	dbp->set_alloc(dbp, safemalloc, MyRealloc, safefree) ;
	dbp->set_errcall(dbp, db_errcall_cb) ;
    }
#endif

#ifdef AT_LEAST_DB_4_1
    /* set encryption */
    if (password)
    {
        Status = dbp->set_encrypt(dbp, password, enc_flags);
        Trace(("DB->set_encrypt passwd = %s, flags %d returned %s\n", 
			      		password, enc_flags,
  					my_db_strerror(Status))) ;
         if (Status)
              return RETVAL ;
    }
#endif	  

    if (info->re_source) {
        Status = dbp->set_re_source(dbp, info->re_source) ;
	Trace(("set_re_source [%s] returned %s\n",
		info->re_source, my_db_strerror(Status)));
        if (Status)
            return RETVAL ;
    }

    if (info->db_cachesize) {
        Status = dbp->set_cachesize(dbp, 0, info->db_cachesize, 0) ;
	Trace(("set_cachesize [%d] returned %s\n",
		info->db_cachesize, my_db_strerror(Status)));
        if (Status)
            return RETVAL ;
    }

    if (info->db_lorder) {
        Status = dbp->set_lorder(dbp, info->db_lorder) ;
	Trace(("set_lorder [%d] returned %s\n",
		info->db_lorder, my_db_strerror(Status)));
        if (Status)
            return RETVAL ;
    }

    if (info->db_pagesize) {
        Status = dbp->set_pagesize(dbp, info->db_pagesize) ;
	Trace(("set_pagesize [%d] returned %s\n",
		info->db_pagesize, my_db_strerror(Status)));
        if (Status)
            return RETVAL ;
    }

    if (info->h_ffactor) {
        Status = dbp->set_h_ffactor(dbp, info->h_ffactor) ;
	Trace(("set_h_ffactor [%d] returned %s\n",
		info->h_ffactor, my_db_strerror(Status)));
        if (Status)
            return RETVAL ;
    }

    if (info->h_nelem) {
        Status = dbp->set_h_nelem(dbp, info->h_nelem) ;
	Trace(("set_h_nelem [%d] returned %s\n",
		info->h_nelem, my_db_strerror(Status)));
        if (Status)
            return RETVAL ;
    }

    if (info->bt_minkey) {
        Status = dbp->set_bt_minkey(dbp, info->bt_minkey) ;
	Trace(("set_bt_minkey [%d] returned %s\n",
		info->bt_minkey, my_db_strerror(Status)));
        if (Status)
            return RETVAL ;
    }

    if (info->bt_compare) {
        Status = dbp->set_bt_compare(dbp, info->bt_compare) ;
	Trace(("set_bt_compare [%p] returned %s\n",
		info->bt_compare, my_db_strerror(Status)));
        if (Status)
            return RETVAL ;
    }

    if (info->h_hash) {
        Status = dbp->set_h_hash(dbp, info->h_hash) ;
	Trace(("set_h_hash [%d] returned %s\n",
		info->h_hash, my_db_strerror(Status)));
        if (Status)
            return RETVAL ;
    }

    if (info->dup_compare) {
        Status = dbp->set_dup_compare(dbp, info->dup_compare) ;
	Trace(("set_dup_compare [%d] returned %s\n",
		info->dup_compare, my_db_strerror(Status)));
        if (Status)
            return RETVAL ;
    }

    if (info->bt_prefix) {
        Status = dbp->set_bt_prefix(dbp, info->bt_prefix) ;
	Trace(("set_bt_prefix [%d] returned %s\n",
		info->bt_prefix, my_db_strerror(Status)));
        if (Status)
            return RETVAL ;
    }

    if (info->re_len) {
        Status = dbp->set_re_len(dbp, info->re_len) ;
	Trace(("set_re_len [%d] returned %s\n",
		info->re_len, my_db_strerror(Status)));
        if (Status)
            return RETVAL ;
    }

    if (info->re_delim) {
        Status = dbp->set_re_delim(dbp, info->re_delim) ;
	Trace(("set_re_delim [%d] returned %s\n",
		info->re_delim, my_db_strerror(Status)));
        if (Status)
            return RETVAL ;
    }

    if (info->re_pad) {
        Status = dbp->set_re_pad(dbp, info->re_pad) ;
	Trace(("set_re_pad [%d] returned %s\n",
		info->re_pad, my_db_strerror(Status)));
        if (Status)
            return RETVAL ;
    }

    if (info->flags) {
        Status = dbp->set_flags(dbp, info->flags) ;
	Trace(("set_flags [%d] returned %s\n",
		info->flags, my_db_strerror(Status)));
        if (Status)
            return RETVAL ;
    }

    if (info->q_extentsize) {
#ifdef AT_LEAST_DB_3_2
        Status = dbp->set_q_extentsize(dbp, info->q_extentsize) ;
	Trace(("set_q_extentsize [%d] returned %s\n",
		info->q_extentsize, my_db_strerror(Status)));
        if (Status)
            return RETVAL ;
#else
        softCrash("-ExtentSize needs at least Berkeley DB 3.2.x") ;
#endif
    }

    /* In-memory database need DB_CREATE from 4.4 */
    if (! file)
        flags |= DB_CREATE;


#ifdef AT_LEAST_DB_4_1
    if ((Status = (dbp->open)(dbp, txnid, file, subname, type, flags, mode)) == 0) {
#else
    if ((Status = (dbp->open)(dbp, file, subname, type, flags, mode)) == 0) {
#endif /* AT_LEAST_DB_4_1 */
#else /* DB_VERSION_MAJOR == 2 */
    if ((Status = db_open(file, type, flags, mode, env, info, &dbp)) == 0) {
#endif /* DB_VERSION_MAJOR == 2 */

	Trace(("db_opened ok\n"));
	RETVAL = db ;
	RETVAL->dbp  = dbp ;
	RETVAL->txn  = txnid ;
#if DB_VERSION_MAJOR == 2
    	RETVAL->type = dbp->type ;
#else /* DB_VERSION_MAJOR > 2 */
#ifdef AT_LEAST_DB_3_3
    	dbp->get_type(dbp, &RETVAL->type) ;
#else /* DB 3.0 -> 3.2 */
    	RETVAL->type = dbp->get_type(dbp) ;
#endif
#endif /* DB_VERSION_MAJOR > 2 */
    	RETVAL->primary_recno_or_queue = FALSE;
    	RETVAL->recno_or_queue = (RETVAL->type == DB_RECNO ||
	                          RETVAL->type == DB_QUEUE) ;
	RETVAL->filename = my_strdup(file) ;
	RETVAL->Status = Status ;
	RETVAL->active = TRUE ;
	hash_store_iv("BerkeleyDB::Term::Db", (char *)RETVAL, 1) ;
	Trace(("  storing %p %p in BerkeleyDB::Term::Db\n", RETVAL, dbp)) ;
	if (dbenv) {
	    RETVAL->cds_enabled = dbenv->cds_enabled ;
	    RETVAL->parent_env = dbenv ;
	    dbenv->Status = Status ;
	    ++ dbenv->open_dbs ;
	}
    }
    else {
#if DB_VERSION_MAJOR > 2
	(dbp->close)(dbp, 0) ;
#endif
	destroyDB(db) ;
        Trace(("db open returned %s\n", my_db_strerror(Status))) ;
    }

    return RETVAL ;
}


#include "constants.h"

#ifndef PERL_UNUSED_VAR
#  define PERL_UNUSED_VAR(var) if (0) var = var
#endif

#line 1626 "BerkeleyDB.c"

/* INCLUDE:  Including 'constants.xs' from 'BerkeleyDB.xs' */


XS(XS_BerkeleyDB_constant); /* prototype to pass -Wmissing-prototypes */
XS(XS_BerkeleyDB_constant)
{
    dXSARGS;
    if (items != 1)
	Perl_croak(aTHX_ "Usage: BerkeleyDB::constant(sv)");
    PERL_UNUSED_VAR(cv); /* -W */
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
#line 4 "BerkeleyDB.xs"
#ifdef dXSTARG
	dXSTARG; /* Faster if we have it.  */
#else
	dTARGET;
#endif
	STRLEN		len;
        int		type;
	IV		iv;
	/* NV		nv;	Uncomment this if you need to return NVs */
	const char	*pv;
#line 1652 "BerkeleyDB.c"
	SV *	sv = ST(0);
	const char *	s = SvPV(sv, len);
#line 18 "BerkeleyDB.xs"
        /* Change this to constant(aTHX_ s, len, &iv, &nv);
           if you need to return both NVs and IVs */
	type = constant(aTHX_ s, len, &iv, &pv);
      /* Return 1 or 2 items. First is error message, or undef if no error.
           Second, if present, is found value */
        switch (type) {
        case PERL_constant_NOTFOUND:
          sv = sv_2mortal(newSVpvf("%s is not a valid BerkeleyDB macro", s));
          PUSHs(sv);
          break;
        case PERL_constant_NOTDEF:
          sv = sv_2mortal(newSVpvf(
	    "Your vendor has not defined BerkeleyDB macro %s, used", s));
          PUSHs(sv);
          break;
        case PERL_constant_ISIV:
          EXTEND(SP, 1);
          PUSHs(&PL_sv_undef);
          PUSHi(iv);
          break;
	/* Uncomment this if you need to return NOs
        case PERL_constant_ISNO:
          EXTEND(SP, 1);
          PUSHs(&PL_sv_undef);
          PUSHs(&PL_sv_no);
          break; */
	/* Uncomment this if you need to return NVs
        case PERL_constant_ISNV:
          EXTEND(SP, 1);
          PUSHs(&PL_sv_undef);
          PUSHn(nv);
          break; */
        case PERL_constant_ISPV:
          EXTEND(SP, 1);
          PUSHs(&PL_sv_undef);
          PUSHp(pv, strlen(pv));
          break;
	/* Uncomment this if you need to return PVNs
        case PERL_constant_ISPVN:
          EXTEND(SP, 1);
          PUSHs(&PL_sv_undef);
          PUSHp(pv, iv);
          break; */
	/* Uncomment this if you need to return SVs
        case PERL_constant_ISSV:
          EXTEND(SP, 1);
          PUSHs(&PL_sv_undef);
          PUSHs(sv);
          break; */
	/* Uncomment this if you need to return UNDEFs
        case PERL_constant_ISUNDEF:
          break; */
	/* Uncomment this if you need to return UVs
        case PERL_constant_ISUV:
          EXTEND(SP, 1);
          PUSHs(&PL_sv_undef);
          PUSHu((UV)iv);
          break; */
	/* Uncomment this if you need to return YESs
        case PERL_constant_ISYES:
          EXTEND(SP, 1);
          PUSHs(&PL_sv_undef);
          PUSHs(&PL_sv_yes);
          break; */
        default:
          sv = sv_2mortal(newSVpvf(
	    "Unexpected return type %d while processing BerkeleyDB macro %s, used",
               type, s));
          PUSHs(sv);
        }
#line 1726 "BerkeleyDB.c"
	PUTBACK;
	return;
    }
}


/* INCLUDE: Returning to 'BerkeleyDB.xs' from 'constants.xs' */

#define env_db_version(maj, min, patch) 	db_version(&maj, &min, &patch)

XS(XS_BerkeleyDB_db_version); /* prototype to pass -Wmissing-prototypes */
XS(XS_BerkeleyDB_db_version)
{
    dXSARGS;
    if (items != 3)
	Perl_croak(aTHX_ "Usage: BerkeleyDB::db_version(maj, min, patch)");
    PERL_UNUSED_VAR(cv); /* -W */
    {
	int	maj = (int)SvIV(ST(0));
	int	min = (int)SvIV(ST(1));
	int	patch = (int)SvIV(ST(2));
	char *	RETVAL;
	dXSTARG;

	RETVAL = env_db_version(maj, min, patch);
	sv_setiv(ST(0), (IV)maj);
	SvSETMAGIC(ST(0));
	sv_setiv(ST(1), (IV)min);
	SvSETMAGIC(ST(1));
	sv_setiv(ST(2), (IV)patch);
	SvSETMAGIC(ST(2));
	sv_setpv(TARG, RETVAL); XSprePUSH; PUSHTARG;
    }
    XSRETURN(1);
}


XS(XS_BerkeleyDB_db_value_set); /* prototype to pass -Wmissing-prototypes */
XS(XS_BerkeleyDB_db_value_set)
{
    dXSARGS;
    if (items != 2)
	Perl_croak(aTHX_ "Usage: BerkeleyDB::db_value_set(value, which)");
    PERL_UNUSED_VAR(cv); /* -W */
    {
	int	value = (int)SvIV(ST(0));
	int	which = (int)SvIV(ST(1));

	Perl_croak(aTHX_ "BerkeleyDB::db_value_set: not implemented yet");
    }
    XSRETURN(1);
}


XS(XS_BerkeleyDB__db_remove); /* prototype to pass -Wmissing-prototypes */
XS(XS_BerkeleyDB__db_remove)
{
    dXSARGS;
    if (items != 1)
	Perl_croak(aTHX_ "Usage: BerkeleyDB::_db_remove(ref)");
    PERL_UNUSED_VAR(cv); /* -W */
    {
	SV *	ref = ST(0);
	DualType	RETVAL;
#line 1639 "BerkeleyDB.xs"
	{
#if DB_VERSION_MAJOR == 2
	    softCrash("BerkeleyDB::db_remove needs Berkeley DB 3.x or better") ;
#else
	    HV *		hash ;
    	    DB *		dbp ;
	    SV * 		sv ;
	    const char *	db = NULL ;
	    const char *	subdb 	= NULL ;
	    BerkeleyDB__Env	env 	= NULL ;
	    BerkeleyDB__Txn	txn 	= NULL ;
    	    DB_ENV *		dbenv   = NULL ;
	    u_int32_t		flags	= 0 ;

	    hash = (HV*) SvRV(ref) ;
	    SetValue_pv(db,    "Filename", char *) ;
	    SetValue_pv(subdb, "Subname", char *) ;
	    SetValue_iv(flags, "Flags") ;
	    SetValue_ov(env, "Env", BerkeleyDB__Env) ;
            if (txn) {
#ifdef AT_LEAST_DB_4_1
                if (!env)
                    softCrash("transactional db_remove requires an environment");
                RETVAL = env->Status = env->Env->dbremove(env->Env, txn->txn, db, subdb, flags);
#else
                softCrash("transactional db_remove requires Berkeley DB 4.1 or better");
#endif                
            } else {
                if (env)
                    dbenv = env->Env ;
                RETVAL = db_create(&dbp, dbenv, 0) ;
                if (RETVAL == 0) {
                    RETVAL = dbp->remove(dbp, db, subdb, flags) ;
            }
        }
#endif
	}
#line 1829 "BerkeleyDB.c"
	ST(0) = sv_newmortal();
	setDUALerrno(ST(0), RETVAL) ;

    }
    XSRETURN(1);
}


XS(XS_BerkeleyDB__db_verify); /* prototype to pass -Wmissing-prototypes */
XS(XS_BerkeleyDB__db_verify)
{
    dXSARGS;
    if (items != 1)
	Perl_croak(aTHX_ "Usage: BerkeleyDB::_db_verify(ref)");
    PERL_UNUSED_VAR(cv); /* -W */
    {
	SV *	ref = ST(0);
	DualType	RETVAL;
#line 1683 "BerkeleyDB.xs"
	{
#ifndef AT_LEAST_DB_3_1
	    softCrash("BerkeleyDB::db_verify needs Berkeley DB 3.1.x or better") ;
#else
	    HV *		hash ;
    	    DB *		dbp ;
	    SV * 		sv ;
	    const char *	db = NULL ;
	    const char *	subdb 	= NULL ;
	    const char *	outfile	= NULL ;
	    FILE *		ofh = NULL;
	    BerkeleyDB__Env	env 	= NULL ;
    	    DB_ENV *		dbenv   = NULL ;
	    u_int32_t		flags	= 0 ;

	    hash = (HV*) SvRV(ref) ;
	    SetValue_pv(db,    "Filename", char *) ;
	    SetValue_pv(subdb, "Subname", char *) ;
	    SetValue_pv(outfile, "Outfile", char *) ;
	    SetValue_iv(flags, "Flags") ;
	    SetValue_ov(env, "Env", BerkeleyDB__Env) ;
            RETVAL = 0;
            if (outfile){
	        ofh = fopen(outfile, "w");
                if (! ofh)
                    RETVAL = errno;
            }
            if (! RETVAL) {
    	        if (env)
		    dbenv = env->Env ;
                RETVAL = db_create(&dbp, dbenv, 0) ;
	        if (RETVAL == 0) {
	            RETVAL = dbp->verify(dbp, db, subdb, ofh, flags) ;
	        }
	        if (outfile) 
                    fclose(ofh);
            }
#endif
	}
#line 1888 "BerkeleyDB.c"
	ST(0) = sv_newmortal();
	setDUALerrno(ST(0), RETVAL) ;

    }
    XSRETURN(1);
}


XS(XS_BerkeleyDB__db_rename); /* prototype to pass -Wmissing-prototypes */
XS(XS_BerkeleyDB__db_rename)
{
    dXSARGS;
    if (items != 1)
	Perl_croak(aTHX_ "Usage: BerkeleyDB::_db_rename(ref)");
    PERL_UNUSED_VAR(cv); /* -W */
    {
	SV *	ref = ST(0);
	DualType	RETVAL;
#line 1729 "BerkeleyDB.xs"
	{
#ifndef AT_LEAST_DB_3_1
	    softCrash("BerkeleyDB::db_rename needs Berkeley DB 3.1.x or better") ;
#else
	    HV *		hash ;
    	    DB *		dbp ;
	    SV * 		sv ;
	    const char *	db = NULL ;
	    const char *	subdb 	= NULL ;
	    const char *	newname	= NULL ;
	    BerkeleyDB__Env	env 	= NULL ;
	    BerkeleyDB__Txn	txn 	= NULL ;
    	    DB_ENV *		dbenv   = NULL ;
	    u_int32_t		flags	= 0 ;

	    hash = (HV*) SvRV(ref) ;
	    SetValue_pv(db,    "Filename", char *) ;
	    SetValue_pv(subdb, "Subname", char *) ;
	    SetValue_pv(newname, "Newname", char *) ;
	    SetValue_iv(flags, "Flags") ;
	    SetValue_ov(env, "Env", BerkeleyDB__Env) ;
            SetValue_ov(txn, "Txn", BerkeleyDB__Txn) ;
            if (txn) {
#ifdef AT_LEAST_DB_4_1
                if (!env)
                    softCrash("transactional db_rename requires an environment");
                RETVAL = env->Status = env->Env->dbrename(env->Env, txn->txn, db, subdb, newname, flags);
#else
                softCrash("transactional db_rename requires Berkeley DB 4.1 or better");
#endif
            } else {
                if (env)
                    dbenv = env->Env ;
                RETVAL = db_create(&dbp, dbenv, 0) ;
                if (RETVAL == 0) {
                    RETVAL = (dbp->rename)(dbp, db, subdb, newname, flags) ;
            }
        }
#endif
	}
#line 1948 "BerkeleyDB.c"
	ST(0) = sv_newmortal();
	setDUALerrno(ST(0), RETVAL) ;

    }
    XSRETURN(1);
}


XS(XS_BerkeleyDB__Env_create); /* prototype to pass -Wmissing-prototypes */
XS(XS_BerkeleyDB__Env_create)
{
    dXSARGS;
    if (items < 0 || items > 1)
	Perl_croak(aTHX_ "Usage: BerkeleyDB::Env::create(flags=0)");
    PERL_UNUSED_VAR(cv); /* -W */
    {
	u_int32_t	flags;
	BerkeleyDB__Env__Raw	RETVAL;
	dXSTARG;

	if (items < 1)
	    flags = 0;
	else {
	flags = SvUV(ST(0));
	}
#line 1778 "BerkeleyDB.xs"
	{
#ifndef AT_LEAST_DB_4_1
	    softCrash("$env->create needs Berkeley DB 4.1 or better") ;
#else
	    DB_ENV *	env ;
	    int    status;
	    RETVAL = NULL;
	    Trace(("in BerkeleyDB::Env::create flags=%d\n",  flags)) ;
	    status = db_env_create(&env, flags) ;
	    Trace(("db_env_create returned %s\n", my_db_strerror(status))) ;
	    if (status == 0) {
	        ZMALLOC(RETVAL, BerkeleyDB_ENV_type) ;
		RETVAL->Env = env ;
	        RETVAL->active = TRUE ;
	        RETVAL->opened = FALSE;
	        env->set_alloc(env, safemalloc, MyRealloc, safefree) ;
	        env->set_errcall(env, db_errcall_cb) ;
	    }
#endif	    
	}
#line 1995 "BerkeleyDB.c"
	XSprePUSH; PUSHi(PTR2IV(RETVAL));
    }
    XSRETURN(1);
}


XS(XS_BerkeleyDB__Env_open); /* prototype to pass -Wmissing-prototypes */
XS(XS_BerkeleyDB__Env_open)
{
    dXSARGS;
    if (items < 1 || items > 4)
	Perl_croak(aTHX_ "Usage: BerkeleyDB::Env::open(env, db_home=NULL, flags=0, mode=0777)");
    PERL_UNUSED_VAR(cv); /* -W */
    {
	BerkeleyDB__Env	env;
	char *	db_home;
	u_int32_t	flags;
	int	mode;
	int	RETVAL;
	dXSTARG;

        if (ST(0) == &PL_sv_undef || ST(0) == NULL)
            env = NULL ;
        else if (sv_derived_from(ST(0), "BerkeleyDB::Env")) {
            IV tmp = SvIV(getInnerObject(ST(0))) ;
            env = INT2PTR(BerkeleyDB__Env, tmp);
        }
        else
            croak("env is not of type BerkeleyDB::Env");

	if (items < 2)
	    db_home = NULL;
	else {
	    db_home = (char *)SvPV_nolen(ST(1));
	}

	if (items < 3)
	    flags = 0;
	else {
	flags = SvUV(ST(2));
	}

	if (items < 4)
	    mode = 0777;
	else {
	    mode = (int)SvIV(ST(3));
	}
#line 1808 "BerkeleyDB.xs"
#ifndef AT_LEAST_DB_4_1
	    softCrash("$env->create needs Berkeley DB 4.1 or better") ;
#else
        RETVAL = env->Env->open(env->Env, db_home, flags, mode);
	env->opened = TRUE;
#endif
#line 2050 "BerkeleyDB.c"
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS(XS_BerkeleyDB__Env_cds_enabled); /* prototype to pass -Wmissing-prototypes */
XS(XS_BerkeleyDB__Env_cds_enabled)
{
    dXSARGS;
    if (items != 1)
	Perl_croak(aTHX_ "Usage: BerkeleyDB::Env::cds_enabled(env)");
    PERL_UNUSED_VAR(cv); /* -W */
    {
	BerkeleyDB__Env	env;
	bool	RETVAL;

        if (ST(0) == &PL_sv_undef || ST(0) == NULL)
            env = NULL ;
        else if (sv_derived_from(ST(0), "BerkeleyDB::Env")) {
            IV tmp = SvIV(getInnerObject(ST(0))) ;
            env = INT2PTR(BerkeleyDB__Env, tmp);
        }
        else
            croak("env is not of type BerkeleyDB::Env");
#line 1821 "BerkeleyDB.xs"
	    RETVAL = env->cds_enabled ;
#line 2078 "BerkeleyDB.c"
	ST(0) = boolSV(RETVAL);
	sv_2mortal(ST(0));
    }
    XSRETURN(1);
}


XS(XS_BerkeleyDB__Env_set_encrypt); /* prototype to pass -Wmissing-prototypes */
XS(XS_BerkeleyDB__Env_set_encrypt)
{
    dXSARGS;
    if (items != 3)
	Perl_croak(aTHX_ "Usage: BerkeleyDB::Env::set_encrypt(env, passwd, flags)");
    PERL_UNUSED_VAR(cv); /* -W */
    {
	BerkeleyDB__Env	env;
	const char *	passwd;
	u_int32_t        flags = SvUV(ST(2));
	int	RETVAL;
	dXSTARG;

        if (ST(0) == &PL_sv_undef || ST(0) == NULL)
            env = NULL ;
        else if (sv_derived_from(ST(0), "BerkeleyDB::Env")) {
            IV tmp = SvIV(getInnerObject(ST(0))) ;
            env = INT2PTR(BerkeleyDB__Env, tmp);
        }
        else
            croak("env is not of type BerkeleyDB::Env");

	if (ST(1) == &PL_sv_undef)
	    passwd = NULL ;
	else {
            passwd = (const char *)SvPV(ST(1),PL_na) ;
	    if (PL_na == 0)
		passwd = NULL ;
	};
#line 1832 "BerkeleyDB.xs"
#ifndef AT_LEAST_DB_4_1
	    softCrash("$env->set_encrypt needs Berkeley DB 4.1 or better") ;
#else
        dieIfEnvOpened(env, "set_encrypt");
        RETVAL = env->Env->set_encrypt(env->Env, passwd, flags);
	env->opened = TRUE;
#endif
#line 2124 "BerkeleyDB.c"
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS(XS_BerkeleyDB__Env__db_appinit); /* prototype to pass -Wmissing-prototypes */
XS(XS_BerkeleyDB__Env__db_appinit)
{
    dXSARGS;
    if (items < 2 || items > 3)
	Perl_croak(aTHX_ "Usage: BerkeleyDB::Env::_db_appinit(self, ref, errfile=NULL)");
    PERL_UNUSED_VAR(cv); /* -W */
    {
	char *	self = (char *)SvPV_nolen(ST(0));
	SV *	ref = ST(1);
	SV *	errfile;
	BerkeleyDB__Env__Raw	RETVAL;
	dXSTARG;

	if (items < 3)
	    errfile = NULL;
	else {
	    errfile = ST(2);
	}
#line 1851 "BerkeleyDB.xs"
	{
	    HV *	hash ;
	    SV *	sv ;
	    char *	enc_passwd = NULL ;
	    int		enc_flags = 0 ;
	    char *	home = NULL ;
	    char * 	server = NULL ;
	    char **	config = NULL ;
	    int		flags = 0 ;
	    int		setflags = 0 ;
	    int		cachesize = 0 ;
	    int		lk_detect = 0 ;
	    long	shm_key = 0 ;
	    SV *	errprefix = NULL;
	    DB_ENV *	env ;
	    int status ;

	    Trace(("in _db_appinit [%s] %d\n", self, ref)) ;
	    hash = (HV*) SvRV(ref) ;
	    SetValue_pv(home,      "Home", char *) ;
	    SetValue_pv(enc_passwd,"Enc_Passwd", char *) ;
	    SetValue_iv(enc_flags, "Enc_Flags") ;
	    SetValue_pv(config,    "Config", char **) ;
	    SetValue_sv(errprefix, "ErrPrefix") ;
	    SetValue_iv(flags,     "Flags") ;
	    SetValue_iv(setflags,  "SetFlags") ;
	    SetValue_pv(server,    "Server", char *) ;
	    SetValue_iv(cachesize, "Cachesize") ;
	    SetValue_iv(lk_detect, "LockDetect") ;
	    SetValue_iv(shm_key,   "SharedMemKey") ;
#ifndef AT_LEAST_DB_3_2
	    if (setflags)
	        softCrash("-SetFlags needs Berkeley DB 3.x or better") ;
#endif /* ! AT_LEAST_DB_3 */
#ifndef AT_LEAST_DB_3_1
	    if (shm_key)
	        softCrash("-SharedMemKey needs Berkeley DB 3.1 or better") ;
	    if (server)
	        softCrash("-Server needs Berkeley DB 3.1 or better") ;
#endif /* ! AT_LEAST_DB_3_1 */
#ifndef AT_LEAST_DB_4_1
	    if (enc_passwd)
	        softCrash("-Encrypt needs Berkeley DB 4.x or better") ;
#endif /* ! AT_LEAST_DB_4_1 */
	    Trace(("_db_appinit(config=[%d], home=[%s],errprefix=[%s],flags=[%d]\n",
			config, home, errprefix, flags)) ;
#ifdef TRACE
	    if (config) {
	       int i ;
	      for (i = 0 ; i < 10 ; ++ i) {
		if (config[i] == NULL) {
		    printf("    End\n") ;
		    break ;
		}
	        printf("    config = [%s]\n", config[i]) ;
	      }
	    }
#endif /* TRACE */
	    ZMALLOC(RETVAL, BerkeleyDB_ENV_type) ;
	    if (flags & DB_INIT_TXN)
	        RETVAL->txn_enabled = TRUE ;
#if DB_VERSION_MAJOR == 2
	  ZMALLOC(RETVAL->Env, DB_ENV) ;
	  env = RETVAL->Env ;
	  {
	    /* Take a copy of the error prefix */
	    if (errprefix) {
	        Trace(("copying errprefix\n" )) ;
		RETVAL->ErrPrefix = newSVsv(errprefix) ;
		SvPOK_only(RETVAL->ErrPrefix) ;
	    } 
	    if (RETVAL->ErrPrefix)
	        RETVAL->Env->db_errpfx = SvPVX(RETVAL->ErrPrefix) ;

	    if (SvGMAGICAL(errfile))
		    mg_get(errfile);
	    if (SvOK(errfile)) {
	        FILE * ef = GetFILEptr(errfile) ;
	    	if (! ef)
		    croak("Cannot open file ErrFile", Strerror(errno));
		RETVAL->ErrHandle = newSVsv(errfile) ;
	    	env->db_errfile = ef;
	    }
	    SetValue_iv(env->db_verbose, "Verbose") ;
	    env->db_errcall = db_errcall_cb ;
	    RETVAL->active = TRUE ;
	    RETVAL->opened = TRUE;
	    RETVAL->cds_enabled = ((flags & DB_INIT_CDB) != 0 ? TRUE : FALSE) ;
	    status = db_appinit(home, config, env, flags) ;
	    printf("  status = %d errno %d \n", status, errno) ;
	    Trace(("  status = %d env %d Env %d\n", status, RETVAL, env)) ;
	    if (status == 0)
	        hash_store_iv("BerkeleyDB::Term::Env", (char *)RETVAL, 1) ;
	    else {

                if (RETVAL->ErrHandle)
                    SvREFCNT_dec(RETVAL->ErrHandle) ;
                if (RETVAL->ErrPrefix)
                    SvREFCNT_dec(RETVAL->ErrPrefix) ;
                Safefree(RETVAL->Env) ;
                Safefree(RETVAL) ;
		RETVAL = NULL ;
	    }
	  }
#else /* DB_VERSION_MAJOR > 2 */
#ifndef AT_LEAST_DB_3_1
#    define DB_CLIENT	0
#endif
#ifdef AT_LEAST_DB_4_2
#    define DB_CLIENT	DB_RPCCLIENT
#endif
	  status = db_env_create(&RETVAL->Env, server ? DB_CLIENT : 0) ;
	  Trace(("db_env_create flags = %d returned %s\n", flags,
	  					my_db_strerror(status))) ;
	  env = RETVAL->Env ;
#ifdef AT_LEAST_DB_3_3
	  env->set_alloc(env, safemalloc, MyRealloc, safefree) ;
#endif
#ifdef AT_LEAST_DB_3_1
	  if (status == 0 && shm_key) {
	      status = env->set_shm_key(env, shm_key) ;
	      Trace(("set_shm_key [%d] returned %s\n", shm_key,
			my_db_strerror(status)));
	  }
#endif	  
	  if (status == 0 && cachesize) {
	      status = env->set_cachesize(env, 0, cachesize, 0) ;
	      Trace(("set_cachesize [%d] returned %s\n",
			cachesize, my_db_strerror(status)));
	  }

	  if (status == 0 && lk_detect) {
	      status = env->set_lk_detect(env, lk_detect) ;
	      Trace(("set_lk_detect [%d] returned %s\n",
	              lk_detect, my_db_strerror(status)));
	  }
#ifdef AT_LEAST_DB_4_1
	  /* set encryption */
	  if (enc_passwd && status == 0)
	  {
	      status = env->set_encrypt(env, enc_passwd, enc_flags);
	      Trace(("ENV->set_encrypt passwd = %s, flags %d returned %s\n", 
				      		enc_passwd, enc_flags,
	  					my_db_strerror(status))) ;
	  }
#endif	  
#ifdef AT_LEAST_DB_4
	  /* set the server */
	  if (server && status == 0)
	  {
	      status = env->set_rpc_server(env, NULL, server, 0, 0, 0);
	      Trace(("ENV->set_rpc_server server = %s returned %s\n", server,
	  					my_db_strerror(status))) ;
	  }
#else
#  if defined(AT_LEAST_DB_3_1) && ! defined(AT_LEAST_DB_4)
	  /* set the server */
	  if (server && status == 0)
	  {
	      status = env->set_server(env, server, 0, 0, 0);
	      Trace(("ENV->set_server server = %s returned %s\n", server,
	  					my_db_strerror(status))) ;
	  }
#  endif
#endif
#ifdef AT_LEAST_DB_3_2
	  if (setflags && status == 0)
	  {
	      status = env->set_flags(env, setflags, 1);
	      Trace(("ENV->set_flags value = %d returned %s\n", setflags,
	  					my_db_strerror(status))) ;
	  }
#endif
	  if (status == 0)
	  {
	    int		mode = 0 ;
	    /* Take a copy of the error prefix */
	    if (errprefix) {
	        Trace(("copying errprefix\n" )) ;
		RETVAL->ErrPrefix = newSVsv(errprefix) ;
		SvPOK_only(RETVAL->ErrPrefix) ;
	    }
	    if (RETVAL->ErrPrefix)
	        env->set_errpfx(env, SvPVX(RETVAL->ErrPrefix)) ;

	    if (SvGMAGICAL(errfile))
		    mg_get(errfile);
	    if (SvOK(errfile)) {
	        FILE * ef = GetFILEptr(errfile);
	    	if (! ef)
		    croak("Cannot open file ErrFile", Strerror(errno));
		RETVAL->ErrHandle = newSVsv(errfile) ;
	    	env->set_errfile(env, ef) ;

	    }

	    SetValue_iv(mode, "Mode") ;
	    env->set_errcall(env, db_errcall_cb) ;
	    RETVAL->active = TRUE ;
	    RETVAL->cds_enabled = ((flags & DB_INIT_CDB) != 0 ? TRUE : FALSE) ; 
#ifdef IS_DB_3_0_x
	    status = (env->open)(env, home, config, flags, mode) ;
#else /* > 3.0 */
	    status = (env->open)(env, home, flags, mode) ;
#endif
	    Trace(("ENV->open(env=%s,home=%s,flags=%d,mode=%d)\n",env,home,flags,mode)) ;
	    Trace(("ENV->open returned %s\n", my_db_strerror(status))) ;
	  }

	  if (status == 0)
	      hash_store_iv("BerkeleyDB::Term::Env", (char *)RETVAL, 1) ;
	  else {
	      (env->close)(env, 0) ;
              if (RETVAL->ErrHandle)
                  SvREFCNT_dec(RETVAL->ErrHandle) ;
              if (RETVAL->ErrPrefix)
                  SvREFCNT_dec(RETVAL->ErrPrefix) ;
              Safefree(RETVAL) ;
	      RETVAL = NULL ;
	  }
#endif /* DB_VERSION_MAJOR > 2 */
	  {
	      SV * sv_err = perl_get_sv(ERR_BUFF, FALSE);
	      sv_setpv(sv_err, db_strerror(status));
	  }
	}
#line 2377 "BerkeleyDB.c"
	XSprePUSH; PUSHi(PTR2IV(RETVAL));
    }
    XSRETURN(1);
}


XS(XS_BerkeleyDB__Env_DB_ENV); /* prototype to pass -Wmissing-prototypes */
XS(XS_BerkeleyDB__Env_DB_ENV)
{
    dXSARGS;
    if (items != 1)
	Perl_croak(aTHX_ "Usage: BerkeleyDB::Env::DB_ENV(env)");
    PERL_UNUSED_VAR(cv); /* -W */
    {
	BerkeleyDB__Env	env;
	DB_ENV *	RETVAL;
	dXSTARG;

        if (ST(0) == &PL_sv_undef || ST(0) == NULL)
            env = NULL ;
        else if (sv_derived_from(ST(0), "BerkeleyDB::Env")) {
            IV tmp = SvIV(getInnerObject(ST(0))) ;
            env = INT2PTR(BerkeleyDB__Env, tmp);
        }
        else
            croak("env is not of type BerkeleyDB::Env");
#line 2084 "BerkeleyDB.xs"
	    if (env->active)
	        RETVAL = env->Env ;
	    else
	        RETVAL = NULL;
#line 2409 "BerkeleyDB.c"
    }
    XSRETURN(1);
}


XS(XS_BerkeleyDB__Env_log_archive); /* prototype to pass -Wmissing-prototypes */
XS(XS_BerkeleyDB__Env_log_archive)
{
    dXSARGS;
    if (items < 1 || items > 2)
	Perl_croak(aTHX_ "Usage: BerkeleyDB::Env::log_archive(env, flags=0)");
    PERL_UNUSED_VAR(cv); /* -W */
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	u_int32_t	flags;
	BerkeleyDB__Env	env;

	if (items < 2)
	    flags = 0;
	else {
	flags = SvUV(ST(1));
	}

        if (ST(0) == &PL_sv_undef || ST(0) == NULL)
            env = NULL ;
        else if (sv_derived_from(ST(0), "BerkeleyDB::Env")) {
            IV tmp = SvIV(getInnerObject(ST(0))) ;
            env = INT2PTR(BerkeleyDB__Env, tmp);
        }
        else
            croak("env is not of type BerkeleyDB::Env");
#line 2095 "BerkeleyDB.xs"
	{
	  char ** list;
	  char ** file;
	  AV    * av;
#ifndef AT_LEAST_DB_3
          softCrash("log_archive needs at least Berkeley DB 3.x.x");
#else
#  ifdef AT_LEAST_DB_4
	  env->Status = env->Env->log_archive(env->Env, &list, flags) ;
#  else
#    ifdef AT_LEAST_DB_3_3
	  env->Status = log_archive(env->Env, &list, flags) ;
#    else
	  env->Status = log_archive(env->Env, &list, flags, safemalloc) ;
#    endif
#  endif
#ifdef DB_ARCH_REMOVE
	  if (env->Status == 0 && list != NULL && flags != DB_ARCH_REMOVE)
#else
	  if (env->Status == 0 && list != NULL )
#endif
          {
	      for (file = list; *file != NULL; ++file)
	      {
	        XPUSHs(sv_2mortal(newSVpv(*file, 0))) ;
	      }
	      safefree(list);
	  }
#endif
	}
#line 2473 "BerkeleyDB.c"
	PUTBACK;
	return;
    }
}


XS(XS_BerkeleyDB__Env__txn_begin); /* prototype to pass -Wmissing-prototypes */
XS(XS_BerkeleyDB__Env__txn_begin)
{
    dXSARGS;
    if (items < 1 || items > 3)
	Perl_croak(aTHX_ "Usage: BerkeleyDB::Env::_txn_begin(env, pid=NULL, flags=0)");
    PERL_UNUSED_VAR(cv); /* -W */
    {
	u_int32_t	flags;
	BerkeleyDB__Env	env;
	BerkeleyDB__Txn	pid;
	BerkeleyDB__Txn__Raw	RETVAL;
	dXSTARG;

	if (items < 3)
	    flags = 0;
	else {
	flags = SvUV(ST(2));
	}

        if (ST(0) == &PL_sv_undef || ST(0) == NULL)
            env = NULL ;
        else if (sv_derived_from(ST(0), "BerkeleyDB::Env")) {
            IV tmp = SvIV(getInnerObject(ST(0))) ;
            env = INT2PTR(BerkeleyDB__Env, tmp);
        }
        else
            croak("env is not of type BerkeleyDB::Env");

	if (items < 2)
	    pid = NULL;
	else {
	if (ST(1) == &PL_sv_undef || ST(1) == NULL)
	    pid = NULL ;
	else if (sv_derived_from(ST(1), "BerkeleyDB::Txn")) {
	    IV tmp = SvIV(getInnerObject(ST(1))) ;
	    pid = INT2PTR(BerkeleyDB__Txn, tmp);
	}
	else
	    croak("pid is not of type BerkeleyDB::Txn");
	}
#line 2132 "BerkeleyDB.xs"
	{
	    DB_TXN *txn ;
	    DB_TXN *p_id = NULL ;
	    Trace(("txn_begin pid %d, flags %d\n", pid, flags)) ;
#if DB_VERSION_MAJOR == 2
	    if (env->Env->tx_info == NULL)
		softCrash("Transaction Manager not enabled") ;
#endif
	    if (!env->txn_enabled)
		softCrash("Transaction Manager not enabled") ;
	    if (pid)
		p_id = pid->txn ;
	    env->TxnMgrStatus =
#if DB_VERSION_MAJOR == 2
	    	txn_begin(env->Env->tx_info, p_id, &txn) ;
#else
#  ifdef AT_LEAST_DB_4
	    	env->Env->txn_begin(env->Env, p_id, &txn, flags) ;
#  else
	    	txn_begin(env->Env, p_id, &txn, flags) ;
#  endif
#endif
	    if (env->TxnMgrStatus == 0) {
	      ZMALLOC(RETVAL, BerkeleyDB_Txn_type) ;
	      RETVAL->txn  = txn ;
	      RETVAL->active = TRUE ;
	      Trace(("_txn_begin created txn [%p] in [%p]\n", txn, RETVAL));
	      hash_store_iv("BerkeleyDB::Term::Txn", (char *)RETVAL, 1) ;
	    }
	    else
		RETVAL = NULL ;
	}
#line 2554 "BerkeleyDB.c"
	XSprePUSH; PUSHi(PTR2IV(RETVAL));
    }
    XSRETURN(1);
}

#if DB_VERSION_MAJOR == 2
#  define env_txn_checkpoint(e,k,m,f) txn_checkpoint(e->Env->tx_info, k, m)
#else /* DB 3.0 or better */
#  ifdef AT_LEAST_DB_4 
#    define env_txn_checkpoint(e,k,m,f) e->Env->txn_checkpoint(e->Env, k, m, f)
#  else
#    ifdef AT_LEAST_DB_3_1
#      define env_txn_checkpoint(e,k,m,f) txn_checkpoint(e->Env, k, m, 0)
#    else
#      define env_txn_checkpoint(e,k,m,f) txn_checkpoint(e->Env, k, m)
#    endif
#  endif
#endif

XS(XS_BerkeleyDB__Env_txn_checkpoint); /* prototype to pass -Wmissing-prototypes */
XS(XS_BerkeleyDB__Env_txn_checkpoint)
{
    dXSARGS;
    if (items < 3 || items > 4)
	Perl_croak(aTHX_ "Usage: BerkeleyDB::Env::txn_checkpoint(env, kbyte, min, flags=0)");
    PERL_UNUSED_VAR(cv); /* -W */
    {
	BerkeleyDB__Env	env;
	long	kbyte = (long)SvIV(ST(1));
	long	min = (long)SvIV(ST(2));
	u_int32_t	flags;
	DualType	RETVAL;

        if (ST(0) == &PL_sv_undef || ST(0) == NULL)
            env = NULL ;
        else if (sv_derived_from(ST(0), "BerkeleyDB::Env")) {
            IV tmp = SvIV(getInnerObject(ST(0))) ;
            env = INT2PTR(BerkeleyDB__Env, tmp);
        }
        else
            croak("env is not of type BerkeleyDB::Env");

	if (items < 4)
	    flags = 0;
	else {
	flags = SvUV(ST(3));
	}

	RETVAL = env_txn_checkpoint(env, kbyte, min, flags);
	ST(0) = sv_newmortal();
	setDUALerrno(ST(0), RETVAL) ;

    }
    XSRETURN(1);
}


XS(XS_BerkeleyDB__Env_txn_stat); /* prototype to pass -Wmissing-prototypes */
XS(XS_BerkeleyDB__Env_txn_stat)
{
    dXSARGS;
    if (items != 1)
	Perl_croak(aTHX_ "Usage: BerkeleyDB::Env::txn_stat(env)");
    PERL_UNUSED_VAR(cv); /* -W */
    {
	BerkeleyDB__Env	env;
	HV *	RETVAL = NULL ;

        if (ST(0) == &PL_sv_undef || ST(0) == NULL)
            env = NULL ;
        else if (sv_derived_from(ST(0), "BerkeleyDB::Env")) {
            IV tmp = SvIV(getInnerObject(ST(0))) ;
            env = INT2PTR(BerkeleyDB__Env, tmp);
        }
        else
            croak("env is not of type BerkeleyDB::Env");
#line 2193 "BerkeleyDB.xs"
	{
	    DB_TXN_STAT *	stat ;
#ifdef AT_LEAST_DB_4
	    if(env->Env->txn_stat(env->Env, &stat, 0) == 0) {
#else
#  ifdef AT_LEAST_DB_3_3
	    if(txn_stat(env->Env, &stat) == 0) {
#  else
#    if DB_VERSION_MAJOR == 2
	    if(txn_stat(env->Env->tx_info, &stat, safemalloc) == 0) {
#    else
	    if(txn_stat(env->Env, &stat, safemalloc) == 0) {
#    endif
#  endif
#endif
	    	RETVAL = (HV*)sv_2mortal((SV*)newHV()) ;
		hv_store_iv(RETVAL, "st_time_ckp", stat->st_time_ckp) ;
		hv_store_iv(RETVAL, "st_last_txnid", stat->st_last_txnid) ;
		hv_store_iv(RETVAL, "st_maxtxns", stat->st_maxtxns) ;
		hv_store_iv(RETVAL, "st_naborts", stat->st_naborts) ;
		hv_store_iv(RETVAL, "st_nbegins", stat->st_nbegins) ;
		hv_store_iv(RETVAL, "st_ncommits", stat->st_ncommits) ;
		hv_store_iv(RETVAL, "st_nactive", stat->st_nactive) ;
#if DB_VERSION_MAJOR > 2
		hv_store_iv(RETVAL, "st_maxnactive", stat->st_maxnactive) ;
		hv_store_iv(RETVAL, "st_regsize", stat->st_regsize) ;
		hv_store_iv(RETVAL, "st_region_wait", stat->st_region_wait) ;
		hv_store_iv(RETVAL, "st_region_nowait", stat->st_region_nowait) ;
#endif
		safefree(stat) ;
	    }
	}
#line 2664 "BerkeleyDB.c"
	ST(0) = newRV((SV*)RETVAL);
	sv_2mortal(ST(0));
    }
    XSRETURN(1);
}

#define EnDis(x)	((x) ? "Enabled" : "Disabled")

XS(XS_BerkeleyDB__Env_printEnv); /* prototype to pass -Wmissing-prototypes */
XS(XS_BerkeleyDB__Env_printEnv)
{
    dXSARGS;
    if (items != 1)
	Perl_croak(aTHX_ "Usage: BerkeleyDB::Env::printEnv(env)");
    PERL_UNUSED_VAR(cv); /* -W */
    {
	BerkeleyDB__Env	env;

        if (ST(0) == &PL_sv_undef || ST(0) == NULL)
            env = NULL ;
        else if (sv_derived_from(ST(0), "BerkeleyDB::Env")) {
            IV tmp = SvIV(getInnerObject(ST(0))) ;
            env = INT2PTR(BerkeleyDB__Env, tmp);
        }
        else
            croak("env is not of type BerkeleyDB::Env");
#line 2233 "BerkeleyDB.xs"
	    ckActive_Environment(env->active) ;
#line 2693 "BerkeleyDB.c"
#line 2235 "BerkeleyDB.xs"
#if 0
	  printf("env             [0x%X]\n", env) ;
	  printf("  ErrPrefix     [%s]\n", env->ErrPrefix
				           ? SvPVX(env->ErrPrefix) : 0) ;
	  printf("  DB_ENV\n") ;
	  printf("    db_lorder   [%d]\n", env->Env.db_lorder) ;
	  printf("    db_home     [%s]\n", env->Env.db_home) ;
	  printf("    db_data_dir [%s]\n", env->Env.db_data_dir) ;
	  printf("    db_log_dir  [%s]\n", env->Env.db_log_dir) ;
	  printf("    db_tmp_dir  [%s]\n", env->Env.db_tmp_dir) ;
	  printf("    lk_info     [%s]\n", EnDis(env->Env.lk_info)) ;
	  printf("    lk_max      [%d]\n", env->Env.lk_max) ;
	  printf("    lg_info     [%s]\n", EnDis(env->Env.lg_info)) ;
	  printf("    lg_max      [%d]\n", env->Env.lg_max) ;
	  printf("    mp_info     [%s]\n", EnDis(env->Env.mp_info)) ;
	  printf("    mp_size     [%d]\n", env->Env.mp_size) ;
	  printf("    tx_info     [%s]\n", EnDis(env->Env.tx_info)) ;
	  printf("    tx_max      [%d]\n", env->Env.tx_max) ;
	  printf("    flags       [%d]\n", env->Env.flags) ;
	  printf("\n") ;
#endif
#line 2716 "BerkeleyDB.c"
    }
    XSRETURN_EMPTY;
}


XS(XS_BerkeleyDB__Env_errPrefix); /* prototype to pass -Wmissing-prototypes */
XS(XS_BerkeleyDB__Env_errPrefix)
{
    dXSARGS;
    if (items != 2)
	Perl_croak(aTHX_ "Usage: BerkeleyDB::Env::errPrefix(env, prefix)");
    PERL_UNUSED_VAR(cv); /* -W */
    {
	BerkeleyDB__Env	env;
	SV *	prefix = ST(1);
	SV *	RETVAL;

        if (ST(0) == &PL_sv_undef || ST(0) == NULL)
            env = NULL ;
        else if (sv_derived_from(ST(0), "BerkeleyDB::Env")) {
            IV tmp = SvIV(getInnerObject(ST(0))) ;
            env = INT2PTR(BerkeleyDB__Env, tmp);
        }
        else
            croak("env is not of type BerkeleyDB::Env");
#line 2262 "BerkeleyDB.xs"
	    ckActive_Environment(env->active) ;
#line 2744 "BerkeleyDB.c"
#line 2264 "BerkeleyDB.xs"
	  if (env->ErrPrefix) {
	      RETVAL = newSVsv(env->ErrPrefix) ;
              SvPOK_only(RETVAL) ;
	      sv_setsv(env->ErrPrefix, prefix) ;
	  }
	  else {
	      RETVAL = NULL ;
	      env->ErrPrefix = newSVsv(prefix) ;
	  }
	  SvPOK_only(env->ErrPrefix) ;
#if DB_VERSION_MAJOR == 2
	  env->Env->db_errpfx = SvPVX(env->ErrPrefix) ;
#else
	  env->Env->set_errpfx(env->Env, SvPVX(env->ErrPrefix)) ;
#endif
#line 2761 "BerkeleyDB.c"
	ST(0) = RETVAL;
	sv_2mortal(ST(0));
    }
    XSRETURN(1);
}


XS(XS_BerkeleyDB__Env_status); /* prototype to pass -Wmissing-prototypes */
XS(XS_BerkeleyDB__Env_status)
{
    dXSARGS;
    if (items != 1)
	Perl_croak(aTHX_ "Usage: BerkeleyDB::Env::status(env)");
    PERL_UNUSED_VAR(cv); /* -W */
    {
	BerkeleyDB__Env	env;
	DualType	RETVAL;

        if (ST(0) == &PL_sv_undef || ST(0) == NULL)
            env = NULL ;
        else if (sv_derived_from(ST(0), "BerkeleyDB::Env")) {
            IV tmp = SvIV(getInnerObject(ST(0))) ;
            env = INT2PTR(BerkeleyDB__Env, tmp);
        }
        else
            croak("env is not of type BerkeleyDB::Env");
#line 2286 "BerkeleyDB.xs"
	    RETVAL =  env->Status ;
#line 2790 "BerkeleyDB.c"
	ST(0) = sv_newmortal();
	setDUALerrno(ST(0), RETVAL) ;

    }
    XSRETURN(1);
}


XS(XS_BerkeleyDB__Env_db_appexit); /* prototype to pass -Wmissing-prototypes */
XS(XS_BerkeleyDB__Env_db_appexit)
{
    dXSARGS;
    dXSI32;
    if (items != 1)
       Perl_croak(aTHX_ "Usage: %s(env)", GvNAME(CvGV(cv)));
    PERL_UNUSED_VAR(cv); /* -W */
    {
	BerkeleyDB__Env	env;
	DualType	RETVAL;

        if (ST(0) == &PL_sv_undef || ST(0) == NULL)
            env = NULL ;
        else if (sv_derived_from(ST(0), "BerkeleyDB::Env")) {
            IV tmp = SvIV(getInnerObject(ST(0))) ;
            env = INT2PTR(BerkeleyDB__Env, tmp);
        }
        else
            croak("env is not of type BerkeleyDB::Env");
#line 2297 "BerkeleyDB.xs"
	    ckActive_Environment(env->active) ;
#line 2821 "BerkeleyDB.c"
#line 2299 "BerkeleyDB.xs"
#ifdef STRICT_CLOSE
	    if (env->open_dbs)
		softCrash("attempted to close an environment with %d open database(s)",
			env->open_dbs) ;
#endif /* STRICT_CLOSE */
#if DB_VERSION_MAJOR == 2
	    RETVAL = db_appexit(env->Env) ;
#else
	    RETVAL = (env->Env->close)(env->Env, 0) ;
#endif
	    env->active = FALSE ;
	    hash_delete("BerkeleyDB::Term::Env", (char *)env) ;
#line 2835 "BerkeleyDB.c"
	ST(0) = sv_newmortal();
	setDUALerrno(ST(0), RETVAL) ;

    }
    XSRETURN(1);
}


XS(XS_BerkeleyDB__Env__DESTROY); /* prototype to pass -Wmissing-prototypes */
XS(XS_BerkeleyDB__Env__DESTROY)
{
    dXSARGS;
    if (items != 1)
	Perl_croak(aTHX_ "Usage: BerkeleyDB::Env::_DESTROY(env)");
    PERL_UNUSED_VAR(cv); /* -W */
    {
	BerkeleyDB__Env	env;
	int	RETVAL = 0 ;

        if (ST(0) == &PL_sv_undef || ST(0) == NULL)
            env = NULL ;
        else if (sv_derived_from(ST(0), "BerkeleyDB::Env")) {
            IV tmp = SvIV(getInnerObject(ST(0))) ;
            env = INT2PTR(BerkeleyDB__Env, tmp);
        }
        else
            croak("env is not of type BerkeleyDB::Env");
#line 2320 "BerkeleyDB.xs"
	  Trace(("In BerkeleyDB::Env::DESTROY\n"));
	  Trace(("    env %ld Env %ld dirty %d\n", env, &env->Env, PL_dirty)) ;
	  if (env->active)
#if DB_VERSION_MAJOR == 2
              db_appexit(env->Env) ;
#else
	      (env->Env->close)(env->Env, 0) ;
#endif
          if (env->ErrHandle)
              SvREFCNT_dec(env->ErrHandle) ;
          if (env->ErrPrefix)
              SvREFCNT_dec(env->ErrPrefix) ;
#if DB_VERSION_MAJOR == 2
          Safefree(env->Env) ;
#endif
          Safefree(env) ;
	  hash_delete("BerkeleyDB::Term::Env", (char *)env) ;
	  Trace(("End of BerkeleyDB::Env::DESTROY %d\n", RETVAL)) ;
#line 2882 "BerkeleyDB.c"
    }
    XSRETURN_EMPTY;
}


XS(XS_BerkeleyDB__Env__TxnMgr); /* prototype to pass -Wmissing-prototypes */
XS(XS_BerkeleyDB__Env__TxnMgr)
{
    dXSARGS;
    if (items != 1)
	Perl_croak(aTHX_ "Usage: BerkeleyDB::Env::_TxnMgr(env)");
    PERL_UNUSED_VAR(cv); /* -W */
    {
	BerkeleyDB__Env	env;
	BerkeleyDB__TxnMgr__Raw	RETVAL;
	dXSTARG;

        if (ST(0) == &PL_sv_undef || ST(0) == NULL)
            env = NULL ;
        else if (sv_derived_from(ST(0), "BerkeleyDB::Env")) {
            IV tmp = SvIV(getInnerObject(ST(0))) ;
            env = INT2PTR(BerkeleyDB__Env, tmp);
        }
        else
            croak("env is not of type BerkeleyDB::Env");
#line 2343 "BerkeleyDB.xs"
	    ckActive_Environment(env->active) ;
	    if (!env->txn_enabled)
		softCrash("Transaction Manager not enabled") ;
#line 2912 "BerkeleyDB.c"
#line 2347 "BerkeleyDB.xs"
	    ZMALLOC(RETVAL, BerkeleyDB_TxnMgr_type) ;
	    RETVAL->env  = env ;
	    /* hash_store_iv("BerkeleyDB::Term::TxnMgr", (char *)txn, 1) ; */
#line 2917 "BerkeleyDB.c"
	XSprePUSH; PUSHi(PTR2IV(RETVAL));
    }
    XSRETURN(1);
}


XS(XS_BerkeleyDB__Env_get_shm_key); /* prototype to pass -Wmissing-prototypes */
XS(XS_BerkeleyDB__Env_get_shm_key)
{
    dXSARGS;
    if (items != 2)
	Perl_croak(aTHX_ "Usage: BerkeleyDB::Env::get_shm_key(env, id)");
    PERL_UNUSED_VAR(cv); /* -W */
    {
	BerkeleyDB__Env	env;
	long	id;
	int	RETVAL;
	dXSTARG;

        if (ST(0) == &PL_sv_undef || ST(0) == NULL)
            env = NULL ;
        else if (sv_derived_from(ST(0), "BerkeleyDB::Env")) {
            IV tmp = SvIV(getInnerObject(ST(0))) ;
            env = INT2PTR(BerkeleyDB__Env, tmp);
        }
        else
            croak("env is not of type BerkeleyDB::Env");
#line 2358 "BerkeleyDB.xs"
	  ckActive_Database(env->active) ;
#line 2947 "BerkeleyDB.c"
#line 2360 "BerkeleyDB.xs"
#ifndef AT_LEAST_DB_4_2
	    softCrash("$env->get_shm_key needs Berkeley DB 4.2 or better") ;
#else
	    RETVAL = env->Env->get_shm_key(env->Env, &id);
#endif	    
#line 2954 "BerkeleyDB.c"
	sv_setiv(ST(1), (IV)id);
	SvSETMAGIC(ST(1));
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS(XS_BerkeleyDB__Env_set_lg_dir); /* prototype to pass -Wmissing-prototypes */
XS(XS_BerkeleyDB__Env_set_lg_dir)
{
    dXSARGS;
    if (items != 2)
	Perl_croak(aTHX_ "Usage: BerkeleyDB::Env::set_lg_dir(env, dir)");
    PERL_UNUSED_VAR(cv); /* -W */
    {
	BerkeleyDB__Env	env;
	char *	dir = (char *)SvPV_nolen(ST(1));
	int	RETVAL;
	dXSTARG;

        if (ST(0) == &PL_sv_undef || ST(0) == NULL)
            env = NULL ;
        else if (sv_derived_from(ST(0), "BerkeleyDB::Env")) {
            IV tmp = SvIV(getInnerObject(ST(0))) ;
            env = INT2PTR(BerkeleyDB__Env, tmp);
        }
        else
            croak("env is not of type BerkeleyDB::Env");
#line 2375 "BerkeleyDB.xs"
	  ckActive_Database(env->active) ;
#line 2986 "BerkeleyDB.c"
#line 2377 "BerkeleyDB.xs"
#ifndef AT_LEAST_DB_3_1
	    softCrash("$env->set_lg_dir needs Berkeley DB 3.1 or better") ;
#else
	    RETVAL = env->Status = env->Env->set_lg_dir(env->Env, dir);
#endif
#line 2993 "BerkeleyDB.c"
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS(XS_BerkeleyDB__Env_set_lg_bsize); /* prototype to pass -Wmissing-prototypes */
XS(XS_BerkeleyDB__Env_set_lg_bsize)
{
    dXSARGS;
    if (items != 2)
	Perl_croak(aTHX_ "Usage: BerkeleyDB::Env::set_lg_bsize(env, bsize)");
    PERL_UNUSED_VAR(cv); /* -W */
    {
	BerkeleyDB__Env	env;
	u_int32_t        bsize = SvUV(ST(1));
	int	RETVAL;
	dXSTARG;

        if (ST(0) == &PL_sv_undef || ST(0) == NULL)
            env = NULL ;
        else if (sv_derived_from(ST(0), "BerkeleyDB::Env")) {
            IV tmp = SvIV(getInnerObject(ST(0))) ;
            env = INT2PTR(BerkeleyDB__Env, tmp);
        }
        else
            croak("env is not of type BerkeleyDB::Env");
#line 2390 "BerkeleyDB.xs"
	  ckActive_Database(env->active) ;
#line 3023 "BerkeleyDB.c"
#line 2392 "BerkeleyDB.xs"
#ifndef AT_LEAST_DB_3
	    softCrash("$env->set_lg_bsize needs Berkeley DB 3.0.55 or better") ;
#else
	    RETVAL = env->Status = env->Env->set_lg_bsize(env->Env, bsize);
#endif
#line 3030 "BerkeleyDB.c"
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS(XS_BerkeleyDB__Env_set_lg_max); /* prototype to pass -Wmissing-prototypes */
XS(XS_BerkeleyDB__Env_set_lg_max)
{
    dXSARGS;
    if (items != 2)
	Perl_croak(aTHX_ "Usage: BerkeleyDB::Env::set_lg_max(env, lg_max)");
    PERL_UNUSED_VAR(cv); /* -W */
    {
	BerkeleyDB__Env	env;
	u_int32_t        lg_max = SvUV(ST(1));
	int	RETVAL;
	dXSTARG;

        if (ST(0) == &PL_sv_undef || ST(0) == NULL)
            env = NULL ;
        else if (sv_derived_from(ST(0), "BerkeleyDB::Env")) {
            IV tmp = SvIV(getInnerObject(ST(0))) ;
            env = INT2PTR(BerkeleyDB__Env, tmp);
        }
        else
            croak("env is not of type BerkeleyDB::Env");
#line 2405 "BerkeleyDB.xs"
	  ckActive_Database(env->active) ;
#line 3060 "BerkeleyDB.c"
#line 2407 "BerkeleyDB.xs"
#ifndef AT_LEAST_DB_3
	    softCrash("$env->set_lg_max needs Berkeley DB 3.0.55 or better") ;
#else
	    RETVAL = env->Status = env->Env->set_lg_max(env->Env, lg_max);
#endif
#line 3067 "BerkeleyDB.c"
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS(XS_BerkeleyDB__Env_set_data_dir); /* prototype to pass -Wmissing-prototypes */
XS(XS_BerkeleyDB__Env_set_data_dir)
{
    dXSARGS;
    if (items != 2)
	Perl_croak(aTHX_ "Usage: BerkeleyDB::Env::set_data_dir(env, dir)");
    PERL_UNUSED_VAR(cv); /* -W */
    {
	BerkeleyDB__Env	env;
	char *	dir = (char *)SvPV_nolen(ST(1));
	int	RETVAL;
	dXSTARG;

        if (ST(0) == &PL_sv_undef || ST(0) == NULL)
            env = NULL ;
        else if (sv_derived_from(ST(0), "BerkeleyDB::Env")) {
            IV tmp = SvIV(getInnerObject(ST(0))) ;
            env = INT2PTR(BerkeleyDB__Env, tmp);
        }
        else
            croak("env is not of type BerkeleyDB::Env");
#line 2420 "BerkeleyDB.xs"
	  ckActive_Database(env->active) ;
#line 3097 "BerkeleyDB.c"
#line 2422 "BerkeleyDB.xs"
#ifndef AT_LEAST_DB_3_1
	    softCrash("$env->set_data_dir needs Berkeley DB 3.1 or better") ;
#else
            dieIfEnvOpened(env, "set_data_dir");
	    RETVAL = env->Status = env->Env->set_data_dir(env->Env, dir);
#endif
#line 3105 "BerkeleyDB.c"
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS(XS_BerkeleyDB__Env_set_tmp_dir); /* prototype to pass -Wmissing-prototypes */
XS(XS_BerkeleyDB__Env_set_tmp_dir)
{
    dXSARGS;
    if (items != 2)
	Perl_croak(aTHX_ "Usage: BerkeleyDB::Env::set_tmp_dir(env, dir)");
    PERL_UNUSED_VAR(cv); /* -W */
    {
	BerkeleyDB__Env	env;
	char *	dir = (char *)SvPV_nolen(ST(1));
	int	RETVAL;
	dXSTARG;

        if (ST(0) == &PL_sv_undef || ST(0) == NULL)
            env = NULL ;
        else if (sv_derived_from(ST(0), "BerkeleyDB::Env")) {
            IV tmp = SvIV(getInnerObject(ST(0))) ;
            env = INT2PTR(BerkeleyDB__Env, tmp);
        }
        else
            croak("env is not of type BerkeleyDB::Env");
#line 2436 "BerkeleyDB.xs"
	  ckActive_Database(env->active) ;
#line 3135 "BerkeleyDB.c"
#line 2438 "BerkeleyDB.xs"
#ifndef AT_LEAST_DB_3_1
	    softCrash("$env->set_tmp_dir needs Berkeley DB 3.1 or better") ;
#else
	    RETVAL = env->Status = env->Env->set_tmp_dir(env->Env, dir);
#endif
#line 3142 "BerkeleyDB.c"
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS(XS_BerkeleyDB__Env_set_mutexlocks); /* prototype to pass -Wmissing-prototypes */
XS(XS_BerkeleyDB__Env_set_mutexlocks)
{
    dXSARGS;
    if (items != 2)
	Perl_croak(aTHX_ "Usage: BerkeleyDB::Env::set_mutexlocks(env, do_lock)");
    PERL_UNUSED_VAR(cv); /* -W */
    {
	BerkeleyDB__Env	env;
	int	do_lock = (int)SvIV(ST(1));
	int	RETVAL;
	dXSTARG;

        if (ST(0) == &PL_sv_undef || ST(0) == NULL)
            env = NULL ;
        else if (sv_derived_from(ST(0), "BerkeleyDB::Env")) {
            IV tmp = SvIV(getInnerObject(ST(0))) ;
            env = INT2PTR(BerkeleyDB__Env, tmp);
        }
        else
            croak("env is not of type BerkeleyDB::Env");
#line 2451 "BerkeleyDB.xs"
	  ckActive_Database(env->active) ;
#line 3172 "BerkeleyDB.c"
#line 2453 "BerkeleyDB.xs"
#ifndef AT_LEAST_DB_3
	    softCrash("$env->set_setmutexlocks needs Berkeley DB 3.0 or better") ;
#else
#  ifdef AT_LEAST_DB_4
	    RETVAL = env->Status = env->Env->set_flags(env->Env, DB_NOLOCKING, !do_lock);
#  else
#    if defined(AT_LEAST_DB_3_2_6) || defined(IS_DB_3_0_x)
	    RETVAL = env->Status = env->Env->set_mutexlocks(env->Env, do_lock);
#    else /* DB 3.1 or 3.2.3 */
	    RETVAL = env->Status = db_env_set_mutexlocks(do_lock);
#    endif
#  endif
#endif
#line 3187 "BerkeleyDB.c"
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS(XS_BerkeleyDB__Env_set_verbose); /* prototype to pass -Wmissing-prototypes */
XS(XS_BerkeleyDB__Env_set_verbose)
{
    dXSARGS;
    if (items != 3)
	Perl_croak(aTHX_ "Usage: BerkeleyDB::Env::set_verbose(env, which, onoff)");
    PERL_UNUSED_VAR(cv); /* -W */
    {
	BerkeleyDB__Env	env;
	u_int32_t        which = SvUV(ST(1));
	int	onoff = (int)SvIV(ST(2));
	int	RETVAL;
	dXSTARG;

        if (ST(0) == &PL_sv_undef || ST(0) == NULL)
            env = NULL ;
        else if (sv_derived_from(ST(0), "BerkeleyDB::Env")) {
            IV tmp = SvIV(getInnerObject(ST(0))) ;
            env = INT2PTR(BerkeleyDB__Env, tmp);
        }
        else
            croak("env is not of type BerkeleyDB::Env");
#line 2475 "BerkeleyDB.xs"
	  ckActive_Database(env->active) ;
#line 3218 "BerkeleyDB.c"
#line 2477 "BerkeleyDB.xs"
#ifndef AT_LEAST_DB_3
	    softCrash("$env->set_verbose needs Berkeley DB 3.x or better") ;
#else
	    RETVAL = env->Status = env->Env->set_verbose(env->Env, which, onoff);
#endif
#line 3225 "BerkeleyDB.c"
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS(XS_BerkeleyDB__Env_set_flags); /* prototype to pass -Wmissing-prototypes */
XS(XS_BerkeleyDB__Env_set_flags)
{
    dXSARGS;
    if (items != 3)
	Perl_croak(aTHX_ "Usage: BerkeleyDB::Env::set_flags(env, flags, onoff)");
    PERL_UNUSED_VAR(cv); /* -W */
    {
	BerkeleyDB__Env	env;
	u_int32_t        flags = SvUV(ST(1));
	int	onoff = (int)SvIV(ST(2));
	int	RETVAL;
	dXSTARG;

        if (ST(0) == &PL_sv_undef || ST(0) == NULL)
            env = NULL ;
        else if (sv_derived_from(ST(0), "BerkeleyDB::Env")) {
            IV tmp = SvIV(getInnerObject(ST(0))) ;
            env = INT2PTR(BerkeleyDB__Env, tmp);
        }
        else
            croak("env is not of type BerkeleyDB::Env");
#line 2491 "BerkeleyDB.xs"
	  ckActive_Database(env->active) ;
#line 3256 "BerkeleyDB.c"
#line 2493 "BerkeleyDB.xs"
#ifndef AT_LEAST_DB_3_2
	    softCrash("$env->set_flags needs Berkeley DB 3.2.x or better") ;
#else
	    RETVAL = env->Status = env->Env->set_flags(env->Env, flags, onoff);
#endif
#line 3263 "BerkeleyDB.c"
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS(XS_BerkeleyDB__Term_close_everything); /* prototype to pass -Wmissing-prototypes */
XS(XS_BerkeleyDB__Term_close_everything)
{
    dXSARGS;
    if (items != 0)
	Perl_croak(aTHX_ "Usage: BerkeleyDB::Term::close_everything()");
    PERL_UNUSED_VAR(cv); /* -W */
    {

	close_everything();
    }
    XSRETURN_EMPTY;
}

#define safeCroak(string)	softCrash(string)

XS(XS_BerkeleyDB__Term_safeCroak); /* prototype to pass -Wmissing-prototypes */
XS(XS_BerkeleyDB__Term_safeCroak)
{
    dXSARGS;
    if (items != 1)
	Perl_croak(aTHX_ "Usage: BerkeleyDB::Term::safeCroak(string)");
    PERL_UNUSED_VAR(cv); /* -W */
    {
	char *	string = (char *)SvPV_nolen(ST(0));

	safeCroak(string);
    }
    XSRETURN_EMPTY;
}


XS(XS_BerkeleyDB__Hash__db_open_hash); /* prototype to pass -Wmissing-prototypes */
XS(XS_BerkeleyDB__Hash__db_open_hash)
{
    dXSARGS;
    if (items != 2)
	Perl_croak(aTHX_ "Usage: BerkeleyDB::Hash::_db_open_hash(self, ref)");
    PERL_UNUSED_VAR(cv); /* -W */
    {
	char *	self = (char *)SvPV_nolen(ST(0));
	SV *	ref = ST(1);
	BerkeleyDB__Hash__Raw	RETVAL;
	dXSTARG;
#line 2519 "BerkeleyDB.xs"
	{
	    HV *		hash ;
	    SV * 		sv ;
	    DB_INFO 		info ;
	    BerkeleyDB__Env	dbenv = NULL;
	    SV *		ref_dbenv = NULL;
	    const char *	file = NULL ;
	    const char *	subname = NULL ;
	    int			flags = 0 ;
	    int			mode = 0 ;
    	    BerkeleyDB 		db ;
    	    BerkeleyDB__Txn 	txn = NULL ;
	    char *	enc_passwd = NULL ;
	    int		enc_flags = 0 ;

    	    Trace(("_db_open_hash start\n")) ;
	    hash = (HV*) SvRV(ref) ;
	    SetValue_pv(file, "Filename", char *) ;
	    SetValue_pv(subname, "Subname", char *) ;
	    SetValue_ov(txn, "Txn", BerkeleyDB__Txn) ;
	    SetValue_ov(dbenv, "Env", BerkeleyDB__Env) ;
	    ref_dbenv = sv ;
	    SetValue_iv(flags, "Flags") ;
	    SetValue_iv(mode, "Mode") ;
	    SetValue_pv(enc_passwd,"Enc_Passwd", char *) ;
	    SetValue_iv(enc_flags, "Enc_Flags") ;

       	    Zero(&info, 1, DB_INFO) ;
	    SetValue_iv(info.db_cachesize, "Cachesize") ;
	    SetValue_iv(info.db_lorder, "Lorder") ;
	    SetValue_iv(info.db_pagesize, "Pagesize") ;
	    SetValue_iv(info.h_ffactor, "Ffactor") ;
	    SetValue_iv(info.h_nelem, "Nelem") ;
	    SetValue_iv(info.flags, "Property") ;
	    ZMALLOC(db, BerkeleyDB_type) ;
	    if ((sv = readHash(hash, "Hash")) && sv != &PL_sv_undef) {
		info.h_hash = hash_cb ;
		db->hash = newSVsv(sv) ;
	    }
	    /* DB_DUPSORT was introduced in DB 2.5.9 */
	    if ((sv = readHash(hash, "DupCompare")) && sv != &PL_sv_undef) {
#ifdef DB_DUPSORT
		info.dup_compare = dup_compare ;
		db->dup_compare = newSVsv(sv) ;
		info.flags |= DB_DUP|DB_DUPSORT ;
#else
	        croak("DupCompare needs Berkeley DB 2.5.9 or later") ;
#endif
	    }
	    RETVAL = my_db_open(db, ref, ref_dbenv, dbenv, txn, file, subname, DB_HASH, flags, mode, &info, enc_passwd, enc_flags) ;
    	    Trace(("_db_open_hash end\n")) ;
	}
#line 3367 "BerkeleyDB.c"
	XSprePUSH; PUSHi(PTR2IV(RETVAL));
    }
    XSRETURN(1);
}


XS(XS_BerkeleyDB__Hash_db_stat); /* prototype to pass -Wmissing-prototypes */
XS(XS_BerkeleyDB__Hash_db_stat)
{
    dXSARGS;
    if (items < 1 || items > 2)
	Perl_croak(aTHX_ "Usage: BerkeleyDB::Hash::db_stat(db, flags=0)");
    PERL_UNUSED_VAR(cv); /* -W */
    {
	int	flags;
	BerkeleyDB__Common	db;
	HV *	RETVAL = NULL ;

	if (items < 2)
	    flags = 0;
	else {
	    flags = (int)SvIV(ST(1));
	}

        if (ST(0) == &PL_sv_undef || ST(0) == NULL)
            db = NULL ;
        else if (sv_derived_from(ST(0), "BerkeleyDB::Common")) {
            IV tmp = SvIV(getInnerObject(ST(0))) ;
            db = INT2PTR(BerkeleyDB__Common, tmp);
        }
        else
            croak("db is not of type BerkeleyDB::Common");
#line 2581 "BerkeleyDB.xs"
	  ckActive_Database(db->active) ;
#line 3402 "BerkeleyDB.c"
#line 2583 "BerkeleyDB.xs"
	{
#if DB_VERSION_MAJOR == 2
	    softCrash("$db->db_stat for a Hash needs Berkeley DB 3.x or better") ;
#else
	    DB_HASH_STAT *	stat ;
#ifdef AT_LEAST_DB_4_3
	    db->Status = ((db->dbp)->stat)(db->dbp, db->txn, &stat, flags) ;
#else        
#ifdef AT_LEAST_DB_3_3
	    db->Status = ((db->dbp)->stat)(db->dbp, &stat, flags) ;
#else
	    db->Status = ((db->dbp)->stat)(db->dbp, &stat, safemalloc, flags) ;
#endif
#endif
	    if (db->Status == 0) {
	    	RETVAL = (HV*)sv_2mortal((SV*)newHV()) ;
		hv_store_iv(RETVAL, "hash_magic", stat->hash_magic) ;
		hv_store_iv(RETVAL, "hash_version", stat->hash_version);
		hv_store_iv(RETVAL, "hash_pagesize", stat->hash_pagesize);
#ifdef AT_LEAST_DB_3_1
		hv_store_iv(RETVAL, "hash_nkeys", stat->hash_nkeys);
		hv_store_iv(RETVAL, "hash_ndata", stat->hash_ndata);
#else
		hv_store_iv(RETVAL, "hash_nrecs", stat->hash_nrecs);
#endif
#ifndef AT_LEAST_DB_3_1
		hv_store_iv(RETVAL, "hash_nelem", stat->hash_nelem);
#endif
		hv_store_iv(RETVAL, "hash_ffactor", stat->hash_ffactor);
		hv_store_iv(RETVAL, "hash_buckets", stat->hash_buckets);
		hv_store_iv(RETVAL, "hash_free", stat->hash_free);
		hv_store_iv(RETVAL, "hash_bfree", stat->hash_bfree);
		hv_store_iv(RETVAL, "hash_bigpages", stat->hash_bigpages);
		hv_store_iv(RETVAL, "hash_big_bfree", stat->hash_big_bfree);
		hv_store_iv(RETVAL, "hash_overflows", stat->hash_overflows);
		hv_store_iv(RETVAL, "hash_ovfl_free", stat->hash_ovfl_free);
		hv_store_iv(RETVAL, "hash_dup", stat->hash_dup);
		hv_store_iv(RETVAL, "hash_dup_free", stat->hash_dup_free);
#if DB_VERSION_MAJOR >= 3
		hv_store_iv(RETVAL, "hash_metaflags", stat->hash_metaflags);
#endif
		safefree(stat) ;
	    }
#endif
	}
#line 3449 "BerkeleyDB.c"
	ST(0) = newRV((SV*)RETVAL);
	sv_2mortal(ST(0));
    }
    XSRETURN(1);
}


XS(XS_BerkeleyDB__Unknown__db_open_unknown); /* prototype to pass -Wmissing-prototypes */
XS(XS_BerkeleyDB__Unknown__db_open_unknown)
{
    dXSARGS;
    if (items != 1)
	Perl_croak(aTHX_ "Usage: BerkeleyDB::Unknown::_db_open_unknown(ref)");
    PERL_UNUSED_VAR(cv); /* -W */
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	SV *	ref = ST(0);
#line 2638 "BerkeleyDB.xs"
	{
	    HV *		hash ;
	    SV * 		sv ;
	    DB_INFO 		info ;
	    BerkeleyDB__Env	dbenv = NULL;
	    SV *		ref_dbenv = NULL;
	    const char *	file = NULL ;
	    const char *	subname = NULL ;
	    int			flags = 0 ;
	    int			mode = 0 ;
    	    BerkeleyDB 		db ;
	    BerkeleyDB		RETVAL ;
    	    BerkeleyDB__Txn 	txn = NULL ;
	    static char * 		Names[] = {"", "Btree", "Hash", "Recno"} ;
	    char *	enc_passwd = NULL ;
	    int		enc_flags = 0 ;

	    hash = (HV*) SvRV(ref) ;
	    SetValue_pv(file, "Filename", char *) ;
	    SetValue_pv(subname, "Subname", char *) ;
	    SetValue_ov(txn, "Txn", BerkeleyDB__Txn) ;
	    SetValue_ov(dbenv, "Env", BerkeleyDB__Env) ;
	    ref_dbenv = sv ;
	    SetValue_iv(flags, "Flags") ;
	    SetValue_iv(mode, "Mode") ;
	    SetValue_pv(enc_passwd,"Enc_Passwd", char *) ;
	    SetValue_iv(enc_flags, "Enc_Flags") ;

       	    Zero(&info, 1, DB_INFO) ;
	    SetValue_iv(info.db_cachesize, "Cachesize") ;
	    SetValue_iv(info.db_lorder, "Lorder") ;
	    SetValue_iv(info.db_pagesize, "Pagesize") ;
	    SetValue_iv(info.h_ffactor, "Ffactor") ;
	    SetValue_iv(info.h_nelem, "Nelem") ;
	    SetValue_iv(info.flags, "Property") ;
	    ZMALLOC(db, BerkeleyDB_type) ;

	    RETVAL = my_db_open(db, ref, ref_dbenv, dbenv, txn, file, subname, DB_UNKNOWN, flags, mode, &info, enc_passwd, enc_flags) ;
	    XPUSHs(sv_2mortal(newSViv(PTR2IV(RETVAL))));
	    if (RETVAL)
	        XPUSHs(sv_2mortal(newSVpv(Names[RETVAL->type], 0))) ;
	    else
	        XPUSHs(sv_2mortal(newSViv((IV)NULL)));
	}
#line 3513 "BerkeleyDB.c"
	PUTBACK;
	return;
    }
}


XS(XS_BerkeleyDB__Btree__db_open_btree); /* prototype to pass -Wmissing-prototypes */
XS(XS_BerkeleyDB__Btree__db_open_btree)
{
    dXSARGS;
    if (items != 2)
	Perl_croak(aTHX_ "Usage: BerkeleyDB::Btree::_db_open_btree(self, ref)");
    PERL_UNUSED_VAR(cv); /* -W */
    {
	char *	self = (char *)SvPV_nolen(ST(0));
	SV *	ref = ST(1);
	BerkeleyDB__Btree__Raw	RETVAL;
	dXSTARG;
#line 2692 "BerkeleyDB.xs"
	{
	    HV *		hash ;
	    SV * 		sv ;
	    DB_INFO 		info ;
	    BerkeleyDB__Env	dbenv = NULL;
	    SV *		ref_dbenv = NULL;
	    const char *	file = NULL ;
	    const char *	subname = NULL ;
	    int			flags = 0 ;
	    int			mode = 0 ;
    	    BerkeleyDB  	db ;
    	    BerkeleyDB__Txn 	txn = NULL ;
	    char *	enc_passwd = NULL ;
	    int		enc_flags = 0 ;

	    Trace(("In _db_open_btree\n"));
	    hash = (HV*) SvRV(ref) ;
	    SetValue_pv(file, "Filename", char*) ;
	    SetValue_pv(subname, "Subname", char *) ;
	    SetValue_ov(txn, "Txn", BerkeleyDB__Txn) ;
	    SetValue_ov(dbenv, "Env", BerkeleyDB__Env) ;
	    ref_dbenv = sv ;
	    SetValue_iv(flags, "Flags") ;
	    SetValue_iv(mode, "Mode") ;
	    SetValue_pv(enc_passwd,"Enc_Passwd", char *) ;
	    SetValue_iv(enc_flags, "Enc_Flags") ;

       	    Zero(&info, 1, DB_INFO) ;
	    SetValue_iv(info.db_cachesize, "Cachesize") ;
	    SetValue_iv(info.db_lorder, "Lorder") ;
	    SetValue_iv(info.db_pagesize, "Pagesize") ;
	    SetValue_iv(info.bt_minkey, "Minkey") ;
	    SetValue_iv(info.flags, "Property") ;
	    ZMALLOC(db, BerkeleyDB_type) ;
	    if ((sv = readHash(hash, "Compare")) && sv != &PL_sv_undef) {
		Trace(("    Parsed Compare callback\n"));
		info.bt_compare = btree_compare ;
		db->compare = newSVsv(sv) ;
	    }
	    /* DB_DUPSORT was introduced in DB 2.5.9 */
	    if ((sv = readHash(hash, "DupCompare")) && sv != &PL_sv_undef) {
#ifdef DB_DUPSORT
		Trace(("    Parsed DupCompare callback\n"));
		info.dup_compare = dup_compare ;
		db->dup_compare = newSVsv(sv) ;
		info.flags |= DB_DUP|DB_DUPSORT ;
#else
	        softCrash("DupCompare needs Berkeley DB 2.5.9 or later") ;
#endif
	    }
	    if ((sv = readHash(hash, "Prefix")) && sv != &PL_sv_undef) {
		Trace(("    Parsed Prefix callback\n"));
		info.bt_prefix = btree_prefix ;
		db->prefix = newSVsv(sv) ;
	    }

	    RETVAL = my_db_open(db, ref, ref_dbenv, dbenv, txn, file, subname, DB_BTREE, flags, mode, &info, enc_passwd, enc_flags) ;
	}
#line 3591 "BerkeleyDB.c"
	XSprePUSH; PUSHi(PTR2IV(RETVAL));
    }
    XSRETURN(1);
}


XS(XS_BerkeleyDB__Btree_db_stat); /* prototype to pass -Wmissing-prototypes */
XS(XS_BerkeleyDB__Btree_db_stat)
{
    dXSARGS;
    if (items < 1 || items > 2)
	Perl_croak(aTHX_ "Usage: BerkeleyDB::Btree::db_stat(db, flags=0)");
    PERL_UNUSED_VAR(cv); /* -W */
    {
	int	flags;
	BerkeleyDB__Common	db;
	HV *	RETVAL = NULL ;

	if (items < 2)
	    flags = 0;
	else {
	    flags = (int)SvIV(ST(1));
	}

        if (ST(0) == &PL_sv_undef || ST(0) == NULL)
            db = NULL ;
        else if (sv_derived_from(ST(0), "BerkeleyDB::Common")) {
            IV tmp = SvIV(getInnerObject(ST(0))) ;
            db = INT2PTR(BerkeleyDB__Common, tmp);
        }
        else
            croak("db is not of type BerkeleyDB::Common");
#line 2760 "BerkeleyDB.xs"
	  ckActive_Database(db->active) ;
#line 3626 "BerkeleyDB.c"
#line 2762 "BerkeleyDB.xs"
	{
	    DB_BTREE_STAT *	stat ;
#ifdef AT_LEAST_DB_4_3
	    db->Status = ((db->dbp)->stat)(db->dbp, db->txn, &stat, flags) ;
#else        
#ifdef AT_LEAST_DB_3_3
	    db->Status = ((db->dbp)->stat)(db->dbp, &stat, flags) ;
#else
	    db->Status = ((db->dbp)->stat)(db->dbp, &stat, safemalloc, flags) ;
#endif
#endif
	    if (db->Status == 0) {
	    	RETVAL = (HV*)sv_2mortal((SV*)newHV()) ;
		hv_store_iv(RETVAL, "bt_magic", stat->bt_magic);
		hv_store_iv(RETVAL, "bt_version", stat->bt_version);
#if DB_VERSION_MAJOR > 2
		hv_store_iv(RETVAL, "bt_metaflags", stat->bt_metaflags) ;
		hv_store_iv(RETVAL, "bt_flags", stat->bt_metaflags) ;
#else
		hv_store_iv(RETVAL, "bt_flags", stat->bt_flags) ;
#endif
#ifndef AT_LEAST_DB_4_4
		hv_store_iv(RETVAL, "bt_maxkey", stat->bt_maxkey) ;
#endif
		hv_store_iv(RETVAL, "bt_minkey", stat->bt_minkey);
		hv_store_iv(RETVAL, "bt_re_len", stat->bt_re_len);
		hv_store_iv(RETVAL, "bt_re_pad", stat->bt_re_pad);
		hv_store_iv(RETVAL, "bt_pagesize", stat->bt_pagesize);
		hv_store_iv(RETVAL, "bt_levels", stat->bt_levels);
#ifdef AT_LEAST_DB_3_1
		hv_store_iv(RETVAL, "bt_nkeys", stat->bt_nkeys);
		hv_store_iv(RETVAL, "bt_ndata", stat->bt_ndata);
#else
		hv_store_iv(RETVAL, "bt_nrecs", stat->bt_nrecs);
#endif
		hv_store_iv(RETVAL, "bt_int_pg", stat->bt_int_pg);
		hv_store_iv(RETVAL, "bt_leaf_pg", stat->bt_leaf_pg);
		hv_store_iv(RETVAL, "bt_dup_pg", stat->bt_dup_pg);
		hv_store_iv(RETVAL, "bt_over_pg", stat->bt_over_pg);
		hv_store_iv(RETVAL, "bt_free", stat->bt_free);
#if DB_VERSION_MAJOR == 2 && DB_VERSION_MINOR < 5
		hv_store_iv(RETVAL, "bt_freed", stat->bt_freed);
		hv_store_iv(RETVAL, "bt_pfxsaved", stat->bt_pfxsaved);
		hv_store_iv(RETVAL, "bt_split", stat->bt_split);
		hv_store_iv(RETVAL, "bt_rootsplit", stat->bt_rootsplit);
		hv_store_iv(RETVAL, "bt_fastsplit", stat->bt_fastsplit);
		hv_store_iv(RETVAL, "bt_added", stat->bt_added);
		hv_store_iv(RETVAL, "bt_deleted", stat->bt_deleted);
		hv_store_iv(RETVAL, "bt_get", stat->bt_get);
		hv_store_iv(RETVAL, "bt_cache_hit", stat->bt_cache_hit);
		hv_store_iv(RETVAL, "bt_cache_miss", stat->bt_cache_miss);
#endif
		hv_store_iv(RETVAL, "bt_int_pgfree", stat->bt_int_pgfree);
		hv_store_iv(RETVAL, "bt_leaf_pgfree", stat->bt_leaf_pgfree);
		hv_store_iv(RETVAL, "bt_dup_pgfree", stat->bt_dup_pgfree);
		hv_store_iv(RETVAL, "bt_over_pgfree", stat->bt_over_pgfree);
		safefree(stat) ;
	    }
	}
#line 3687 "BerkeleyDB.c"
	ST(0) = newRV((SV*)RETVAL);
	sv_2mortal(ST(0));
    }
    XSRETURN(1);
}


XS(XS_BerkeleyDB__Recno__db_open_recno); /* prototype to pass -Wmissing-prototypes */
XS(XS_BerkeleyDB__Recno__db_open_recno)
{
    dXSARGS;
    if (items != 2)
	Perl_croak(aTHX_ "Usage: BerkeleyDB::Recno::_db_open_recno(self, ref)");
    PERL_UNUSED_VAR(cv); /* -W */
    {
	char *	self = (char *)SvPV_nolen(ST(0));
	SV *	ref = ST(1);
	BerkeleyDB__Recno__Raw	RETVAL;
	dXSTARG;
#line 2832 "BerkeleyDB.xs"
	{
	    HV *		hash ;
	    SV * 		sv ;
	    DB_INFO 		info ;
	    BerkeleyDB__Env	dbenv = NULL;
	    SV *		ref_dbenv = NULL;
	    const char *	file = NULL ;
	    const char *	subname = NULL ;
	    int			flags = 0 ;
	    int			mode = 0 ;
    	    BerkeleyDB 		db ;
    	    BerkeleyDB__Txn 	txn = NULL ;
	    char *	enc_passwd = NULL ;
	    int		enc_flags = 0 ;

	    hash = (HV*) SvRV(ref) ;
	    SetValue_pv(file, "Fname", char*) ;
	    SetValue_pv(subname, "Subname", char *) ;
	    SetValue_ov(dbenv, "Env", BerkeleyDB__Env) ;
	    ref_dbenv = sv ;
	    SetValue_ov(txn, "Txn", BerkeleyDB__Txn) ;
	    SetValue_iv(flags, "Flags") ;
	    SetValue_iv(mode, "Mode") ;
	    SetValue_pv(enc_passwd,"Enc_Passwd", char *) ;
	    SetValue_iv(enc_flags, "Enc_Flags") ;

       	    Zero(&info, 1, DB_INFO) ;
	    SetValue_iv(info.db_cachesize, "Cachesize") ;
	    SetValue_iv(info.db_lorder, "Lorder") ;
	    SetValue_iv(info.db_pagesize, "Pagesize") ;
	    SetValue_iv(info.bt_minkey, "Minkey") ;

	    SetValue_iv(info.flags, "Property") ;
	    SetValue_pv(info.re_source, "Source", char*) ;
	    if ((sv = readHash(hash, "Len")) && sv != &PL_sv_undef) {
		info.re_len = SvIV(sv) ; ;
		flagSet_DB2(info.flags, DB_FIXEDLEN) ;
	    }
	    if ((sv = readHash(hash, "Delim")) && sv != &PL_sv_undef) {
		info.re_delim = SvPOK(sv) ? *SvPV(sv,PL_na) : SvIV(sv) ; ;
		flagSet_DB2(info.flags, DB_DELIMITER) ;
	    }
	    if ((sv = readHash(hash, "Pad")) && sv != &PL_sv_undef) {
		info.re_pad = (u_int32_t)SvPOK(sv) ? *SvPV(sv,PL_na) : SvIV(sv) ; ;
		flagSet_DB2(info.flags, DB_PAD) ;
	    }
	    ZMALLOC(db, BerkeleyDB_type) ;
#ifdef ALLOW_RECNO_OFFSET
	    SetValue_iv(db->array_base, "ArrayBase") ;
	    db->array_base = (db->array_base == 0 ? 1 : 0) ;
#endif /* ALLOW_RECNO_OFFSET */

	    RETVAL = my_db_open(db, ref, ref_dbenv, dbenv, txn, file, subname, DB_RECNO, flags, mode, &info, enc_passwd, enc_flags) ;
	}
#line 3762 "BerkeleyDB.c"
	XSprePUSH; PUSHi(PTR2IV(RETVAL));
    }
    XSRETURN(1);
}


XS(XS_BerkeleyDB__Queue__db_open_queue); /* prototype to pass -Wmissing-prototypes */
XS(XS_BerkeleyDB__Queue__db_open_queue)
{
    dXSARGS;
    if (items != 2)
	Perl_croak(aTHX_ "Usage: BerkeleyDB::Queue::_db_open_queue(self, ref)");
    PERL_UNUSED_VAR(cv); /* -W */
    {
	char *	self = (char *)SvPV_nolen(ST(0));
	SV *	ref = ST(1);
	BerkeleyDB__Queue__Raw	RETVAL;
	dXSTARG;
#line 2897 "BerkeleyDB.xs"
	{
#ifndef AT_LEAST_DB_3
            softCrash("BerkeleyDB::Queue needs Berkeley DB 3.0.x or better");
#else
	    HV *		hash ;
	    SV * 		sv ;
	    DB_INFO 		info ;
	    BerkeleyDB__Env	dbenv = NULL;
	    SV *		ref_dbenv = NULL;
	    const char *	file = NULL ;
	    const char *	subname = NULL ;
	    int			flags = 0 ;
	    int			mode = 0 ;
    	    BerkeleyDB 		db ;
    	    BerkeleyDB__Txn 	txn = NULL ;
	    char *	enc_passwd = NULL ;
	    int		enc_flags = 0 ;

	    hash = (HV*) SvRV(ref) ;
	    SetValue_pv(file, "Fname", char*) ;
	    SetValue_pv(subname, "Subname", char *) ;
	    SetValue_ov(dbenv, "Env", BerkeleyDB__Env) ;
	    ref_dbenv = sv ;
	    SetValue_ov(txn, "Txn", BerkeleyDB__Txn) ;
	    SetValue_iv(flags, "Flags") ;
	    SetValue_iv(mode, "Mode") ;
	    SetValue_pv(enc_passwd,"Enc_Passwd", char *) ;
	    SetValue_iv(enc_flags, "Enc_Flags") ;

       	    Zero(&info, 1, DB_INFO) ;
	    SetValue_iv(info.db_cachesize, "Cachesize") ;
	    SetValue_iv(info.db_lorder, "Lorder") ;
	    SetValue_iv(info.db_pagesize, "Pagesize") ;
	    SetValue_iv(info.bt_minkey, "Minkey") ;
    	    SetValue_iv(info.q_extentsize, "ExtentSize") ;


	    SetValue_iv(info.flags, "Property") ;
	    if ((sv = readHash(hash, "Len")) && sv != &PL_sv_undef) {
		info.re_len = SvIV(sv) ; ;
		flagSet_DB2(info.flags, DB_FIXEDLEN) ;
	    }
	    if ((sv = readHash(hash, "Pad")) && sv != &PL_sv_undef) {
		info.re_pad = (u_int32_t)SvPOK(sv) ? *SvPV(sv,PL_na) : SvIV(sv) ; ;
		flagSet_DB2(info.flags, DB_PAD) ;
	    }
	    ZMALLOC(db, BerkeleyDB_type) ;
#ifdef ALLOW_RECNO_OFFSET
	    SetValue_iv(db->array_base, "ArrayBase") ;
	    db->array_base = (db->array_base == 0 ? 1 : 0) ;
#endif /* ALLOW_RECNO_OFFSET */

	    RETVAL = my_db_open(db, ref, ref_dbenv, dbenv, txn, file, subname, DB_QUEUE, flags, mode, &info, enc_passwd, enc_flags) ;
#endif
	}
#line 3837 "BerkeleyDB.c"
	XSprePUSH; PUSHi(PTR2IV(RETVAL));
    }
    XSRETURN(1);
}


XS(XS_BerkeleyDB__Queue_db_stat); /* prototype to pass -Wmissing-prototypes */
XS(XS_BerkeleyDB__Queue_db_stat)
{
    dXSARGS;
    if (items < 1 || items > 2)
	Perl_croak(aTHX_ "Usage: BerkeleyDB::Queue::db_stat(db, flags=0)");
    PERL_UNUSED_VAR(cv); /* -W */
    {
	int	flags;
	BerkeleyDB__Common	db;
	HV *	RETVAL = NULL ;

	if (items < 2)
	    flags = 0;
	else {
	    flags = (int)SvIV(ST(1));
	}

        if (ST(0) == &PL_sv_undef || ST(0) == NULL)
            db = NULL ;
        else if (sv_derived_from(ST(0), "BerkeleyDB::Common")) {
            IV tmp = SvIV(getInnerObject(ST(0))) ;
            db = INT2PTR(BerkeleyDB__Common, tmp);
        }
        else
            croak("db is not of type BerkeleyDB::Common");
#line 2961 "BerkeleyDB.xs"
	  ckActive_Database(db->active) ;
#line 3872 "BerkeleyDB.c"
#line 2963 "BerkeleyDB.xs"
	{
#if DB_VERSION_MAJOR == 2
	    softCrash("$db->db_stat for a Queue needs Berkeley DB 3.x or better") ;
#else /* Berkeley DB 3, or better */
	    DB_QUEUE_STAT *	stat ;
#ifdef AT_LEAST_DB_4_3
	    db->Status = ((db->dbp)->stat)(db->dbp, db->txn, &stat, flags) ;
#else        
#ifdef AT_LEAST_DB_3_3
	    db->Status = ((db->dbp)->stat)(db->dbp, &stat, flags) ;
#else
	    db->Status = ((db->dbp)->stat)(db->dbp, &stat, safemalloc, flags) ;
#endif
#endif
	    if (db->Status == 0) {
	    	RETVAL = (HV*)sv_2mortal((SV*)newHV()) ;
		hv_store_iv(RETVAL, "qs_magic", stat->qs_magic) ;
		hv_store_iv(RETVAL, "qs_version", stat->qs_version);
#ifdef AT_LEAST_DB_3_1
		hv_store_iv(RETVAL, "qs_nkeys", stat->qs_nkeys);
		hv_store_iv(RETVAL, "qs_ndata", stat->qs_ndata);
#else
		hv_store_iv(RETVAL, "qs_nrecs", stat->qs_nrecs);
#endif
		hv_store_iv(RETVAL, "qs_pages", stat->qs_pages);
		hv_store_iv(RETVAL, "qs_pagesize", stat->qs_pagesize);
		hv_store_iv(RETVAL, "qs_pgfree", stat->qs_pgfree);
		hv_store_iv(RETVAL, "qs_re_len", stat->qs_re_len);
		hv_store_iv(RETVAL, "qs_re_pad", stat->qs_re_pad);
#ifdef AT_LEAST_DB_3_2
#else
		hv_store_iv(RETVAL, "qs_start", stat->qs_start);
#endif
		hv_store_iv(RETVAL, "qs_first_recno", stat->qs_first_recno);
		hv_store_iv(RETVAL, "qs_cur_recno", stat->qs_cur_recno);
#if DB_VERSION_MAJOR >= 3
		hv_store_iv(RETVAL, "qs_metaflags", stat->qs_metaflags);
#endif
		safefree(stat) ;
	    }
#endif
	}
#line 3916 "BerkeleyDB.c"
	ST(0) = newRV((SV*)RETVAL);
	sv_2mortal(ST(0));
    }
    XSRETURN(1);
}


XS(XS_BerkeleyDB__Common_db_close); /* prototype to pass -Wmissing-prototypes */
XS(XS_BerkeleyDB__Common_db_close)
{
    dXSARGS;
    if (items < 1 || items > 2)
	Perl_croak(aTHX_ "Usage: BerkeleyDB::Common::db_close(db, flags=0)");
    PERL_UNUSED_VAR(cv); /* -W */
    {
	int	flags;
	BerkeleyDB__Common	db;
	DualType	RETVAL;

	if (items < 2)
	    flags = 0;
	else {
	    flags = (int)SvIV(ST(1));
	}

        if (ST(0) == &PL_sv_undef || ST(0) == NULL)
            db = NULL ;
        else if (sv_derived_from(ST(0), "BerkeleyDB::Common")) {
            IV tmp = SvIV(getInnerObject(ST(0))) ;
            db = INT2PTR(BerkeleyDB__Common, tmp);
        }
        else
            croak("db is not of type BerkeleyDB::Common");
#line 3017 "BerkeleyDB.xs"
	    ckActive_Database(db->active) ;
	    saveCurrentDB(db) ;
#line 3953 "BerkeleyDB.c"
#line 3020 "BerkeleyDB.xs"
	    Trace(("BerkeleyDB::Common::db_close %d\n", db));
#ifdef STRICT_CLOSE
	    if (db->txn)
		softCrash("attempted to close a database while a transaction was still open") ;
	    if (db->open_cursors)
		softCrash("attempted to close a database with %d open cursor(s)",
				db->open_cursors) ;
#endif /* STRICT_CLOSE */
	    RETVAL =  db->Status = ((db->dbp)->close)(db->dbp, flags) ;
	    if (db->parent_env && db->parent_env->open_dbs)
		-- db->parent_env->open_dbs ;
	    db->active = FALSE ;
	    hash_delete("BerkeleyDB::Term::Db", (char *)db) ;
	    -- db->open_cursors ;
	    Trace(("end of BerkeleyDB::Common::db_close\n"));
#line 3970 "BerkeleyDB.c"
	ST(0) = sv_newmortal();
	setDUALerrno(ST(0), RETVAL) ;

    }
    XSRETURN(1);
}


XS(XS_BerkeleyDB__Common__DESTROY); /* prototype to pass -Wmissing-prototypes */
XS(XS_BerkeleyDB__Common__DESTROY)
{
    dXSARGS;
    if (items != 1)
	Perl_croak(aTHX_ "Usage: BerkeleyDB::Common::_DESTROY(db)");
    PERL_UNUSED_VAR(cv); /* -W */
    {
	BerkeleyDB__Common	db;

        if (ST(0) == &PL_sv_undef || ST(0) == NULL)
            db = NULL ;
        else if (sv_derived_from(ST(0), "BerkeleyDB::Common")) {
            IV tmp = SvIV(getInnerObject(ST(0))) ;
            db = INT2PTR(BerkeleyDB__Common, tmp);
        }
        else
            croak("db is not of type BerkeleyDB::Common");
#line 3042 "BerkeleyDB.xs"
	  saveCurrentDB(db) ;
	  Trace(("In BerkeleyDB::Common::_DESTROY db %d dirty=%d\n", db, PL_dirty)) ;
	  destroyDB(db) ;
	  Trace(("End of BerkeleyDB::Common::DESTROY \n")) ;
#line 4002 "BerkeleyDB.c"
    }
    XSRETURN_EMPTY;
}

#if DB_VERSION_MAJOR == 2 && DB_VERSION_MINOR < 6
#define db_cursor(db, txn, cur,flags)  ((db->dbp)->cursor)(db->dbp, txn, cur)
#else
#define db_cursor(db, txn, cur,flags)  ((db->dbp)->cursor)(db->dbp, txn, cur,flags)
#endif

XS(XS_BerkeleyDB__Common__db_cursor); /* prototype to pass -Wmissing-prototypes */
XS(XS_BerkeleyDB__Common__db_cursor)
{
    dXSARGS;
    dXSI32;
    if (items < 1 || items > 2)
       Perl_croak(aTHX_ "Usage: %s(db, flags=0)", GvNAME(CvGV(cv)));
    PERL_UNUSED_VAR(cv); /* -W */
    {
	u_int32_t	flags;
	BerkeleyDB__Common	db;
	BerkeleyDB__Cursor	RETVAL = NULL ;
	dXSTARG;

	if (items < 2)
	    flags = 0;
	else {
	flags = SvUV(ST(1));
	}

        if (ST(0) == &PL_sv_undef || ST(0) == NULL)
            db = NULL ;
        else if (sv_derived_from(ST(0), "BerkeleyDB::Common")) {
            IV tmp = SvIV(getInnerObject(ST(0))) ;
            db = INT2PTR(BerkeleyDB__Common, tmp);
        }
        else
            croak("db is not of type BerkeleyDB::Common");
#line 3059 "BerkeleyDB.xs"
	    ckActive_Database(db->active) ;
#line 4043 "BerkeleyDB.c"
#line 3061 "BerkeleyDB.xs"
	{
	  DBC *	cursor ;
	  saveCurrentDB(db) ;
	  if (ix == 1 && db->cds_enabled) {
#ifdef AT_LEAST_DB_3
	      flags |= DB_WRITECURSOR;
#else	      
	      flags |= DB_RMW;
#endif	      
	  }
	  if ((db->Status = db_cursor(db, db->txn, &cursor, flags)) == 0){
	      ZMALLOC(RETVAL, BerkeleyDB__Cursor_type) ;
	      db->open_cursors ++ ;
	      RETVAL->parent_db  = db ;
	      RETVAL->cursor  = cursor ;
	      RETVAL->dbp     = db->dbp ;
	      RETVAL->txn     = db->txn ;
              RETVAL->type    = db->type ;
              RETVAL->recno_or_queue    = db->recno_or_queue ;
              RETVAL->cds_enabled    = db->cds_enabled ;
              RETVAL->filename    = my_strdup(db->filename) ;
              RETVAL->compare = db->compare ;
              RETVAL->dup_compare = db->dup_compare ;
#ifdef AT_LEAST_DB_3_3
              RETVAL->associated = db->associated ;
	      RETVAL->secondary_db  = db->secondary_db;
              RETVAL->primary_recno_or_queue = db->primary_recno_or_queue ;
#endif
              RETVAL->prefix  = db->prefix ;
              RETVAL->hash    = db->hash ;
	      RETVAL->partial = db->partial ;
	      RETVAL->doff    = db->doff ;
	      RETVAL->dlen    = db->dlen ;
	      RETVAL->active  = TRUE ;
#ifdef ALLOW_RECNO_OFFSET
	      RETVAL->array_base  = db->array_base ;
#endif /* ALLOW_RECNO_OFFSET */
#ifdef DBM_FILTERING
	      RETVAL->filtering   = FALSE ;
	      RETVAL->filter_fetch_key    = db->filter_fetch_key ;
	      RETVAL->filter_store_key    = db->filter_store_key ;
	      RETVAL->filter_fetch_value  = db->filter_fetch_value ;
	      RETVAL->filter_store_value  = db->filter_store_value ;
#endif
              /* RETVAL->info ; */
	      hash_store_iv("BerkeleyDB::Term::Cursor", (char *)RETVAL, 1) ;
	  }
	}
#line 4093 "BerkeleyDB.c"
	XSprePUSH; PUSHi(PTR2IV(RETVAL));
    }
    XSRETURN(1);
}


XS(XS_BerkeleyDB__Common__db_join); /* prototype to pass -Wmissing-prototypes */
XS(XS_BerkeleyDB__Common__db_join)
{
    dXSARGS;
    if (items < 2 || items > 3)
	Perl_croak(aTHX_ "Usage: BerkeleyDB::Common::_db_join(db, cursors, flags=0)");
    PERL_UNUSED_VAR(cv); /* -W */
    {
	u_int32_t	flags;
	BerkeleyDB__Common	db;
	AV *	cursors;
	BerkeleyDB__Cursor	RETVAL = NULL ;
	dXSTARG;

	if (items < 3)
	    flags = 0;
	else {
	flags = SvUV(ST(2));
	}

        if (ST(0) == &PL_sv_undef || ST(0) == NULL)
            db = NULL ;
        else if (sv_derived_from(ST(0), "BerkeleyDB::Common")) {
            IV tmp = SvIV(getInnerObject(ST(0))) ;
            db = INT2PTR(BerkeleyDB__Common, tmp);
        }
        else
            croak("db is not of type BerkeleyDB::Common");

	if (SvROK(ST(1)) && SvTYPE(SvRV(ST(1))) == SVt_PVAV)
        /* if (sv_isa(ST(1), "AVPtr")) */
            cursors = (AV*)SvRV(ST(1));
        else
            croak("cursors is not an array reference");
#line 3119 "BerkeleyDB.xs"
	    ckActive_Database(db->active) ;
#line 4136 "BerkeleyDB.c"
#line 3121 "BerkeleyDB.xs"
	{
#if DB_VERSION_MAJOR == 2 && (DB_VERSION_MINOR < 5 || (DB_VERSION_MINOR == 5 && DB_VERSION_PATCH < 2))
	    softCrash("join needs Berkeley DB 2.5.2 or later") ;
#else /* Berkeley DB >= 2.5.2 */
	  DBC *		join_cursor ;
	  DBC **	cursor_list ;
	  I32		count = av_len(cursors) + 1 ;
	  int		i ;
	  saveCurrentDB(db) ;
	  if (count < 1 )
	      softCrash("db_join: No cursors in parameter list") ;
	  cursor_list = (DBC **)safemalloc(sizeof(DBC*) * (count + 1));
	  for (i = 0 ; i < count ; ++i) {
	      SV * obj = (SV*) * av_fetch(cursors, i, FALSE) ;
	      IV tmp = SvIV(getInnerObject(obj)) ;
	      BerkeleyDB__Cursor cur = INT2PTR(BerkeleyDB__Cursor, tmp);
	      if (cur->dbp == db->dbp)
	          softCrash("attempted to do a self-join");
	      cursor_list[i] = cur->cursor ;
	  }
	  cursor_list[i] = NULL ;
#if DB_VERSION_MAJOR == 2
	  if ((db->Status = ((db->dbp)->join)(db->dbp, cursor_list, flags, &join_cursor)) == 0){
#else
	  if ((db->Status = ((db->dbp)->join)(db->dbp, cursor_list, &join_cursor, flags)) == 0){
#endif
	      ZMALLOC(RETVAL, BerkeleyDB__Cursor_type) ;
	      db->open_cursors ++ ;
	      RETVAL->parent_db  = db ;
	      RETVAL->cursor  = join_cursor ;
	      RETVAL->dbp     = db->dbp ;
              RETVAL->type    = db->type ;
              RETVAL->filename    = my_strdup(db->filename) ;
              RETVAL->compare = db->compare ;
              RETVAL->dup_compare = db->dup_compare ;
#ifdef AT_LEAST_DB_3_3
              RETVAL->associated = db->associated ;
	      RETVAL->secondary_db  = db->secondary_db;
              RETVAL->primary_recno_or_queue = db->primary_recno_or_queue ;
#endif
              RETVAL->prefix  = db->prefix ;
              RETVAL->hash    = db->hash ;
	      RETVAL->partial = db->partial ;
	      RETVAL->doff    = db->doff ;
	      RETVAL->dlen    = db->dlen ;
	      RETVAL->active  = TRUE ;
#ifdef ALLOW_RECNO_OFFSET
	      RETVAL->array_base  = db->array_base ;
#endif /* ALLOW_RECNO_OFFSET */
#ifdef DBM_FILTERING
	      RETVAL->filtering   = FALSE ;
	      RETVAL->filter_fetch_key    = db->filter_fetch_key ;
	      RETVAL->filter_store_key    = db->filter_store_key ;
	      RETVAL->filter_fetch_value  = db->filter_fetch_value ;
	      RETVAL->filter_store_value  = db->filter_store_value ;
#endif
              /* RETVAL->info ; */
	      hash_store_iv("BerkeleyDB::Term::Cursor", (char *)RETVAL, 1) ;
	  }
	  safefree(cursor_list) ;
#endif /* Berkeley DB >= 2.5.2 */
	}
#line 4200 "BerkeleyDB.c"
	XSprePUSH; PUSHi(PTR2IV(RETVAL));
    }
    XSRETURN(1);
}


XS(XS_BerkeleyDB__Common_ArrayOffset); /* prototype to pass -Wmissing-prototypes */
XS(XS_BerkeleyDB__Common_ArrayOffset)
{
    dXSARGS;
    if (items != 1)
	Perl_croak(aTHX_ "Usage: BerkeleyDB::Common::ArrayOffset(db)");
    PERL_UNUSED_VAR(cv); /* -W */
    {
	BerkeleyDB__Common	db;
	int	RETVAL;
	dXSTARG;

        if (ST(0) == &PL_sv_undef || ST(0) == NULL)
            db = NULL ;
        else if (sv_derived_from(ST(0), "BerkeleyDB::Common")) {
            IV tmp = SvIV(getInnerObject(ST(0))) ;
            db = INT2PTR(BerkeleyDB__Common, tmp);
        }
        else
            croak("db is not of type BerkeleyDB::Common");
#line 3190 "BerkeleyDB.xs"
	    ckActive_Database(db->active) ;
#line 4229 "BerkeleyDB.c"
#line 3192 "BerkeleyDB.xs"
#ifdef ALLOW_RECNO_OFFSET
	    RETVAL = db->array_base ? 0 : 1 ;
#else
	    RETVAL = 0 ;
#endif /* ALLOW_RECNO_OFFSET */
#line 4236 "BerkeleyDB.c"
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS(XS_BerkeleyDB__Common_cds_enabled); /* prototype to pass -Wmissing-prototypes */
XS(XS_BerkeleyDB__Common_cds_enabled)
{
    dXSARGS;
    if (items != 1)
	Perl_croak(aTHX_ "Usage: BerkeleyDB::Common::cds_enabled(db)");
    PERL_UNUSED_VAR(cv); /* -W */
    {
	BerkeleyDB__Common	db;
	bool	RETVAL;

        if (ST(0) == &PL_sv_undef || ST(0) == NULL)
            db = NULL ;
        else if (sv_derived_from(ST(0), "BerkeleyDB::Common")) {
            IV tmp = SvIV(getInnerObject(ST(0))) ;
            db = INT2PTR(BerkeleyDB__Common, tmp);
        }
        else
            croak("db is not of type BerkeleyDB::Common");
#line 3205 "BerkeleyDB.xs"
	    ckActive_Database(db->active) ;
#line 4264 "BerkeleyDB.c"
#line 3207 "BerkeleyDB.xs"
	    RETVAL = db->cds_enabled ;
#line 4267 "BerkeleyDB.c"
	ST(0) = boolSV(RETVAL);
	sv_2mortal(ST(0));
    }
    XSRETURN(1);
}


XS(XS_BerkeleyDB__Common_type); /* prototype to pass -Wmissing-prototypes */
XS(XS_BerkeleyDB__Common_type)
{
    dXSARGS;
    if (items != 1)
	Perl_croak(aTHX_ "Usage: BerkeleyDB::Common::type(db)");
    PERL_UNUSED_VAR(cv); /* -W */
    {
	BerkeleyDB__Common	db;
	int	RETVAL;
	dXSTARG;

        if (ST(0) == &PL_sv_undef || ST(0) == NULL)
            db = NULL ;
        else if (sv_derived_from(ST(0), "BerkeleyDB::Common")) {
            IV tmp = SvIV(getInnerObject(ST(0))) ;
            db = INT2PTR(BerkeleyDB__Common, tmp);
        }
        else
            croak("db is not of type BerkeleyDB::Common");
#line 3217 "BerkeleyDB.xs"
	    ckActive_Database(db->active) ;
#line 4297 "BerkeleyDB.c"
#line 3219 "BerkeleyDB.xs"
	    RETVAL = db->type ;
#line 4300 "BerkeleyDB.c"
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS(XS_BerkeleyDB__Common_byteswapped); /* prototype to pass -Wmissing-prototypes */
XS(XS_BerkeleyDB__Common_byteswapped)
{
    dXSARGS;
    if (items != 1)
	Perl_croak(aTHX_ "Usage: BerkeleyDB::Common::byteswapped(db)");
    PERL_UNUSED_VAR(cv); /* -W */
    {
	BerkeleyDB__Common	db;
	int	RETVAL;
	dXSTARG;

        if (ST(0) == &PL_sv_undef || ST(0) == NULL)
            db = NULL ;
        else if (sv_derived_from(ST(0), "BerkeleyDB::Common")) {
            IV tmp = SvIV(getInnerObject(ST(0))) ;
            db = INT2PTR(BerkeleyDB__Common, tmp);
        }
        else
            croak("db is not of type BerkeleyDB::Common");
#line 3227 "BerkeleyDB.xs"
	    ckActive_Database(db->active) ;
#line 4329 "BerkeleyDB.c"
#line 3229 "BerkeleyDB.xs"
#if DB_VERSION_MAJOR == 2 && DB_VERSION_MINOR < 5
	    softCrash("byteswapped needs Berkeley DB 2.5 or later") ;
#else
#if DB_VERSION_MAJOR == 2
	    RETVAL = db->dbp->byteswapped ;
#else
#ifdef AT_LEAST_DB_3_3
	    db->dbp->get_byteswapped(db->dbp, &RETVAL) ;
#else
	    RETVAL = db->dbp->get_byteswapped(db->dbp) ;
#endif
#endif
#endif
#line 4344 "BerkeleyDB.c"
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS(XS_BerkeleyDB__Common_status); /* prototype to pass -Wmissing-prototypes */
XS(XS_BerkeleyDB__Common_status)
{
    dXSARGS;
    if (items != 1)
	Perl_croak(aTHX_ "Usage: BerkeleyDB::Common::status(db)");
    PERL_UNUSED_VAR(cv); /* -W */
    {
	BerkeleyDB__Common	db;
	DualType	RETVAL;

        if (ST(0) == &PL_sv_undef || ST(0) == NULL)
            db = NULL ;
        else if (sv_derived_from(ST(0), "BerkeleyDB::Common")) {
            IV tmp = SvIV(getInnerObject(ST(0))) ;
            db = INT2PTR(BerkeleyDB__Common, tmp);
        }
        else
            croak("db is not of type BerkeleyDB::Common");
#line 3249 "BerkeleyDB.xs"
	    RETVAL =  db->Status ;
#line 4372 "BerkeleyDB.c"
	ST(0) = sv_newmortal();
	setDUALerrno(ST(0), RETVAL) ;

    }
    XSRETURN(1);
}

#ifdef DBM_FILTERING
#define setFilter(ftype)				\
	{						\
	    if (db->ftype)				\
	        RETVAL = sv_mortalcopy(db->ftype) ;	\
	    ST(0) = RETVAL ;				\
	    if (db->ftype && (code == &PL_sv_undef)) {	\
                SvREFCNT_dec(db->ftype) ;		\
	        db->ftype = NULL ;			\
	    }						\
	    else if (code) {				\
	        if (db->ftype)				\
	            sv_setsv(db->ftype, code) ;		\
	        else					\
	            db->ftype = newSVsv(code) ;		\
	    }	    					\
	}
#define XSubPPtmpAAAA 1


XS(XS_BerkeleyDB__Common_filter_fetch_key); /* prototype to pass -Wmissing-prototypes */
XS(XS_BerkeleyDB__Common_filter_fetch_key)
{
    dXSARGS;
    if (items != 2)
	Perl_croak(aTHX_ "Usage: BerkeleyDB::Common::filter_fetch_key(db, code)");
    PERL_UNUSED_VAR(cv); /* -W */
    {
	BerkeleyDB__Common	db;
	SV *	code = ST(1);
	SV *	RETVAL = &PL_sv_undef ;

        if (ST(0) == &PL_sv_undef || ST(0) == NULL)
            db = NULL ;
        else if (sv_derived_from(ST(0), "BerkeleyDB::Common")) {
            IV tmp = SvIV(getInnerObject(ST(0))) ;
            db = INT2PTR(BerkeleyDB__Common, tmp);
        }
        else
            croak("db is not of type BerkeleyDB::Common");
#line 3279 "BerkeleyDB.xs"
	    DBM_setFilter(db->filter_fetch_key, code) ;
#line 4422 "BerkeleyDB.c"
    }
    XSRETURN(1);
}


XS(XS_BerkeleyDB__Common_filter_store_key); /* prototype to pass -Wmissing-prototypes */
XS(XS_BerkeleyDB__Common_filter_store_key)
{
    dXSARGS;
    if (items != 2)
	Perl_croak(aTHX_ "Usage: BerkeleyDB::Common::filter_store_key(db, code)");
    PERL_UNUSED_VAR(cv); /* -W */
    {
	BerkeleyDB__Common	db;
	SV *	code = ST(1);
	SV *	RETVAL = &PL_sv_undef ;

        if (ST(0) == &PL_sv_undef || ST(0) == NULL)
            db = NULL ;
        else if (sv_derived_from(ST(0), "BerkeleyDB::Common")) {
            IV tmp = SvIV(getInnerObject(ST(0))) ;
            db = INT2PTR(BerkeleyDB__Common, tmp);
        }
        else
            croak("db is not of type BerkeleyDB::Common");
#line 3287 "BerkeleyDB.xs"
	    DBM_setFilter(db->filter_store_key, code) ;
#line 4450 "BerkeleyDB.c"
    }
    XSRETURN(1);
}


XS(XS_BerkeleyDB__Common_filter_fetch_value); /* prototype to pass -Wmissing-prototypes */
XS(XS_BerkeleyDB__Common_filter_fetch_value)
{
    dXSARGS;
    if (items != 2)
	Perl_croak(aTHX_ "Usage: BerkeleyDB::Common::filter_fetch_value(db, code)");
    PERL_UNUSED_VAR(cv); /* -W */
    {
	BerkeleyDB__Common	db;
	SV *	code = ST(1);
	SV *	RETVAL = &PL_sv_undef ;

        if (ST(0) == &PL_sv_undef || ST(0) == NULL)
            db = NULL ;
        else if (sv_derived_from(ST(0), "BerkeleyDB::Common")) {
            IV tmp = SvIV(getInnerObject(ST(0))) ;
            db = INT2PTR(BerkeleyDB__Common, tmp);
        }
        else
            croak("db is not of type BerkeleyDB::Common");
#line 3295 "BerkeleyDB.xs"
	    DBM_setFilter(db->filter_fetch_value, code) ;
#line 4478 "BerkeleyDB.c"
    }
    XSRETURN(1);
}


XS(XS_BerkeleyDB__Common_filter_store_value); /* prototype to pass -Wmissing-prototypes */
XS(XS_BerkeleyDB__Common_filter_store_value)
{
    dXSARGS;
    if (items != 2)
	Perl_croak(aTHX_ "Usage: BerkeleyDB::Common::filter_store_value(db, code)");
    PERL_UNUSED_VAR(cv); /* -W */
    {
	BerkeleyDB__Common	db;
	SV *	code = ST(1);
	SV *	RETVAL = &PL_sv_undef ;

        if (ST(0) == &PL_sv_undef || ST(0) == NULL)
            db = NULL ;
        else if (sv_derived_from(ST(0), "BerkeleyDB::Common")) {
            IV tmp = SvIV(getInnerObject(ST(0))) ;
            db = INT2PTR(BerkeleyDB__Common, tmp);
        }
        else
            croak("db is not of type BerkeleyDB::Common");
#line 3303 "BerkeleyDB.xs"
	    DBM_setFilter(db->filter_store_value, code) ;
#line 4506 "BerkeleyDB.c"
    }
    XSRETURN(1);
}

#endif /* DBM_FILTERING */

XS(XS_BerkeleyDB__Common_partial_set); /* prototype to pass -Wmissing-prototypes */
XS(XS_BerkeleyDB__Common_partial_set)
{
    dXSARGS;
    if (items != 3)
	Perl_croak(aTHX_ "Usage: BerkeleyDB::Common::partial_set(db, offset, length)");
    PERL_UNUSED_VAR(cv); /* -W */
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	BerkeleyDB__Common	db;
	u_int32_t        offset = SvUV(ST(1));
	u_int32_t        length = SvUV(ST(2));

        if (ST(0) == &PL_sv_undef || ST(0) == NULL)
            db = NULL ;
        else if (sv_derived_from(ST(0), "BerkeleyDB::Common")) {
            IV tmp = SvIV(getInnerObject(ST(0))) ;
            db = INT2PTR(BerkeleyDB__Common, tmp);
        }
        else
            croak("db is not of type BerkeleyDB::Common");
#line 3313 "BerkeleyDB.xs"
	    ckActive_Database(db->active) ;
#line 4537 "BerkeleyDB.c"
#line 3315 "BerkeleyDB.xs"
	    if (GIMME == G_ARRAY) {
		XPUSHs(sv_2mortal(newSViv(db->partial == DB_DBT_PARTIAL))) ;
		XPUSHs(sv_2mortal(newSViv(db->doff))) ;
		XPUSHs(sv_2mortal(newSViv(db->dlen))) ;
	    }
	    db->partial = DB_DBT_PARTIAL ;
	    db->doff    = offset ;
	    db->dlen    = length ;
#line 4547 "BerkeleyDB.c"
	PUTBACK;
	return;
    }
}


XS(XS_BerkeleyDB__Common_partial_clear); /* prototype to pass -Wmissing-prototypes */
XS(XS_BerkeleyDB__Common_partial_clear)
{
    dXSARGS;
    if (items != 1)
	Perl_croak(aTHX_ "Usage: BerkeleyDB::Common::partial_clear(db)");
    PERL_UNUSED_VAR(cv); /* -W */
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	BerkeleyDB__Common	db;

        if (ST(0) == &PL_sv_undef || ST(0) == NULL)
            db = NULL ;
        else if (sv_derived_from(ST(0), "BerkeleyDB::Common")) {
            IV tmp = SvIV(getInnerObject(ST(0))) ;
            db = INT2PTR(BerkeleyDB__Common, tmp);
        }
        else
            croak("db is not of type BerkeleyDB::Common");
#line 3329 "BerkeleyDB.xs"
	    ckActive_Database(db->active) ;
#line 4576 "BerkeleyDB.c"
#line 3331 "BerkeleyDB.xs"
	    if (GIMME == G_ARRAY) {
		XPUSHs(sv_2mortal(newSViv(db->partial == DB_DBT_PARTIAL))) ;
		XPUSHs(sv_2mortal(newSViv(db->doff))) ;
		XPUSHs(sv_2mortal(newSViv(db->dlen))) ;
	    }
	    db->partial =
	    db->doff    =
	    db->dlen    = 0 ;
#line 4586 "BerkeleyDB.c"
	PUTBACK;
	return;
    }
}

#define db_del(db, key, flags)  \
	(db->Status = ((db->dbp)->del)(db->dbp, db->txn, &key, flags))

XS(XS_BerkeleyDB__Common_db_del); /* prototype to pass -Wmissing-prototypes */
XS(XS_BerkeleyDB__Common_db_del)
{
    dXSARGS;
    if (items < 2 || items > 3)
	Perl_croak(aTHX_ "Usage: BerkeleyDB::Common::db_del(db, key, flags=0)");
    PERL_UNUSED_VAR(cv); /* -W */
    {
	u_int	flags;
	BerkeleyDB__Common	db;
	DBTKEY	key;
	DualType	RETVAL;

	if (items < 3)
	    flags = 0;
	else {
	flags = SvUV(ST(2));
	}

        if (ST(0) == &PL_sv_undef || ST(0) == NULL)
            db = NULL ;
        else if (sv_derived_from(ST(0), "BerkeleyDB::Common")) {
            IV tmp = SvIV(getInnerObject(ST(0))) ;
            db = INT2PTR(BerkeleyDB__Common, tmp);
        }
        else
            croak("db is not of type BerkeleyDB::Common");

	{
	    SV* my_sv = ST(1) ;
	    DBM_ckFilter(my_sv, filter_store_key, "filter_store_key");
	    DBT_clear(key) ;
            SvGETMAGIC(ST(1)) ;
	    if (db->recno_or_queue) {
	        Value = GetRecnoKey(db, SvIV(my_sv)) ; 
	        key.data = & Value; 
	        key.size = (int)sizeof(db_recno_t);
	    }
	    else {
	        key.data = SvPV(my_sv, PL_na);
	        key.size = (int)PL_na;
	    }
	};
#line 3349 "BerkeleyDB.xs"
	    Trace(("db_del db[%p] in [%p] txn[%p] key[%.*s] flags[%d]\n", db->dbp, db, db->txn, key.size, key.data, flags)) ;
	    ckActive_Database(db->active) ;
	    saveCurrentDB(db) ;
#line 4642 "BerkeleyDB.c"

	RETVAL = db_del(db, key, flags);
	ST(0) = sv_newmortal();
	setDUALerrno(ST(0), RETVAL) ;

    }
    XSRETURN(1);
}

#ifdef AT_LEAST_DB_3
#  ifdef AT_LEAST_DB_3_2
#    define writeToKey() (flagSet(DB_CONSUME)||flagSet(DB_CONSUME_WAIT)||flagSet(DB_GET_BOTH)||flagSet(DB_SET_RECNO))
#  else
#    define writeToKey() (flagSet(DB_CONSUME)||flagSet(DB_GET_BOTH)||flagSet(DB_SET_RECNO))
#  endif
#else
#define writeToKey() (flagSet(DB_GET_BOTH)||flagSet(DB_SET_RECNO))
#endif
#define db_get(db, key, data, flags)   \
	(db->Status = ((db->dbp)->get)(db->dbp, db->txn, &key, &data, flags))

XS(XS_BerkeleyDB__Common_db_get); /* prototype to pass -Wmissing-prototypes */
XS(XS_BerkeleyDB__Common_db_get)
{
    dXSARGS;
    if (items < 3 || items > 4)
	Perl_croak(aTHX_ "Usage: BerkeleyDB::Common::db_get(db, key, data, flags=0)");
    PERL_UNUSED_VAR(cv); /* -W */
    {
	u_int	flags;
	BerkeleyDB__Common	db;
	DBTKEY_B	key;
	DBT_OPT	data;
	DualType	RETVAL;

	if (items < 4)
	    flags = 0;
	else {
	flags = SvUV(ST(3));
	}

        if (ST(0) == &PL_sv_undef || ST(0) == NULL)
            db = NULL ;
        else if (sv_derived_from(ST(0), "BerkeleyDB::Common")) {
            IV tmp = SvIV(getInnerObject(ST(0))) ;
            db = INT2PTR(BerkeleyDB__Common, tmp);
        }
        else
            croak("db is not of type BerkeleyDB::Common");

	{
	    SV* my_sv = ST(1) ;
	    DBM_ckFilter(my_sv, filter_store_key, "filter_store_key");
	    DBT_clear(key) ;
            SvGETMAGIC(ST(1)) ;
	    if (db->recno_or_queue ||
		    (db->type == DB_BTREE && flagSet(DB_SET_RECNO))) {
	        Value = GetRecnoKey(db, SvIV(my_sv)) ; 
	        key.data = & Value; 
	        key.size = (int)sizeof(db_recno_t);
	    }
	    else {
	        key.data = SvPV(my_sv, PL_na);
	        key.size = (int)PL_na;
	    }
	};

	DBT_clear(data) ;
	if (flagSet(DB_GET_BOTH)|| flagSet(DB_GET_BOTH)) {
	   SV* my_sv = ST(2) ;
	   DBM_ckFilter(my_sv, filter_store_value, "filter_store_value");
           SvGETMAGIC(ST(2)) ;
	   data.data = SvPV(my_sv, PL_na);
	   data.size = (int)PL_na;
  	   data.flags = db->partial ;
    	   data.dlen  = db->dlen ;
	   data.doff  = db->doff ;
	};
#line 3372 "BerkeleyDB.xs"
	  ckActive_Database(db->active) ;
	  saveCurrentDB(db) ;
	  SetPartial(data,db) ;
	  Trace(("db_get db[%p] in [%p] txn[%p] key [%.*s] flags[%d]\n", db->dbp, db, db->txn, key.size, key.data, flags)) ;
	  RETVAL = db_get(db, key, data, flags);
	  Trace(("  RETVAL %d\n", RETVAL));
#line 4728 "BerkeleyDB.c"
	if (writeToKey()) OutputKey(ST(1), key) ;
	SvSETMAGIC(ST(1));
	OutputValue(ST(2), data)
	SvSETMAGIC(ST(2));
	ST(0) = sv_newmortal();
	setDUALerrno(ST(0), RETVAL) ;

    }
    XSRETURN(1);
}

#define db_pget(db, key, pkey, data, flags)   \
	(db->Status = ((db->dbp)->pget)(db->dbp, db->txn, &key, &pkey, &data, flags))

XS(XS_BerkeleyDB__Common_db_pget); /* prototype to pass -Wmissing-prototypes */
XS(XS_BerkeleyDB__Common_db_pget)
{
    dXSARGS;
    if (items < 4 || items > 5)
	Perl_croak(aTHX_ "Usage: BerkeleyDB::Common::db_pget(db, key, pkey, data, flags=0)");
    PERL_UNUSED_VAR(cv); /* -W */
    {
	u_int	flags;
	BerkeleyDB__Common	db;
	DBTKEY_B	key;
	DBTKEY_Bpr	pkey;
	DBT_OPT	data;
	DualType	RETVAL;

	if (items < 5)
	    flags = 0;
	else {
	flags = SvUV(ST(4));
	}

        if (ST(0) == &PL_sv_undef || ST(0) == NULL)
            db = NULL ;
        else if (sv_derived_from(ST(0), "BerkeleyDB::Common")) {
            IV tmp = SvIV(getInnerObject(ST(0))) ;
            db = INT2PTR(BerkeleyDB__Common, tmp);
        }
        else
            croak("db is not of type BerkeleyDB::Common");

	{
	    SV* my_sv = ST(1) ;
	    DBM_ckFilter(my_sv, filter_store_key, "filter_store_key");
	    DBT_clear(key) ;
            SvGETMAGIC(ST(1)) ;
	    if (db->recno_or_queue ||
		    (db->type == DB_BTREE && flagSet(DB_SET_RECNO))) {
	        Value = GetRecnoKey(db, SvIV(my_sv)) ; 
	        key.data = & Value; 
	        key.size = (int)sizeof(db_recno_t);
	    }
	    else {
	        key.data = SvPV(my_sv, PL_na);
	        key.size = (int)PL_na;
	    }
	};

	DBT_clear(data) ;
	if (flagSet(DB_GET_BOTH)|| flagSet(DB_GET_BOTH)) {
	   SV* my_sv = ST(3) ;
	   DBM_ckFilter(my_sv, filter_store_value, "filter_store_value");
           SvGETMAGIC(ST(3)) ;
	   data.data = SvPV(my_sv, PL_na);
	   data.size = (int)PL_na;
  	   data.flags = db->partial ;
    	   data.dlen  = db->dlen ;
	   data.doff  = db->doff ;
	};
#line 3393 "BerkeleyDB.xs"
#ifndef AT_LEAST_DB_3_3
          softCrash("db_pget needs at least Berkeley DB 3.3");
#else
	  Trace(("db_pget db [%p] in [%p] txn [%p] flags [%d]\n", db->dbp, db, db->txn, flags)) ;
	  ckActive_Database(db->active) ;
	  saveCurrentDB(db) ;
	  SetPartial(data,db) ;
	  DBT_clear(pkey);
	  RETVAL = db_pget(db, key, pkey, data, flags);
	  Trace(("  RETVAL %d\n", RETVAL));
#endif
#line 4813 "BerkeleyDB.c"
	if (writeToKey()) OutputKey(ST(1), key) ;
	SvSETMAGIC(ST(1));
	OutputKey_Bpr(ST(2), pkey)
	SvSETMAGIC(ST(2));
	OutputValue(ST(3), data)
	SvSETMAGIC(ST(3));
	ST(0) = sv_newmortal();
	setDUALerrno(ST(0), RETVAL) ;

    }
    XSRETURN(1);
}

#define db_put(db,key,data,flag)	\
		(db->Status = (db->dbp->put)(db->dbp,db->txn,&key,&data,flag))

XS(XS_BerkeleyDB__Common_db_put); /* prototype to pass -Wmissing-prototypes */
XS(XS_BerkeleyDB__Common_db_put)
{
    dXSARGS;
    if (items < 3 || items > 4)
	Perl_croak(aTHX_ "Usage: BerkeleyDB::Common::db_put(db, key, data, flags=0)");
    PERL_UNUSED_VAR(cv); /* -W */
    {
	u_int	flags;
	BerkeleyDB__Common	db;
	DBTKEY	key;
	DBT	data;
	DualType	RETVAL;

	if (items < 4)
	    flags = 0;
	else {
	flags = SvUV(ST(3));
	}

        if (ST(0) == &PL_sv_undef || ST(0) == NULL)
            db = NULL ;
        else if (sv_derived_from(ST(0), "BerkeleyDB::Common")) {
            IV tmp = SvIV(getInnerObject(ST(0))) ;
            db = INT2PTR(BerkeleyDB__Common, tmp);
        }
        else
            croak("db is not of type BerkeleyDB::Common");

	{
	    SV* my_sv = ST(1) ;
	    DBM_ckFilter(my_sv, filter_store_key, "filter_store_key");
	    DBT_clear(key) ;
            SvGETMAGIC(ST(1)) ;
	    if (db->recno_or_queue) {
	        Value = GetRecnoKey(db, SvIV(my_sv)) ; 
	        key.data = & Value; 
	        key.size = (int)sizeof(db_recno_t);
	    }
	    else {
	        key.data = SvPV(my_sv, PL_na);
	        key.size = (int)PL_na;
	    }
	};

	{
	    SV* my_sv = ST(2) ;
	    DBM_ckFilter(my_sv, filter_store_value, "filter_store_value");
	    DBT_clear(data) ;
            SvGETMAGIC(ST(2)) ;
	    data.data = SvPV(my_sv, PL_na);
	    data.size = (int)PL_na;
  	    data.flags = db->partial ;
    	    data.dlen  = db->dlen ;
	    data.doff  = db->doff ;
	};
#line 3419 "BerkeleyDB.xs"
	  ckActive_Database(db->active) ;
	  saveCurrentDB(db) ;
	  /* SetPartial(data,db) ; */
	  Trace(("db_put db[%p] in [%p] txn[%p] key[%.*s] data [%.*s] flags[%d]\n", db->dbp, db, db->txn, key.size, key.data, data.size, data.data, flags)) ;
	  RETVAL = db_put(db, key, data, flags);
	  Trace(("  RETVAL %d\n", RETVAL));
#line 4893 "BerkeleyDB.c"
	if (flagSet(DB_APPEND)) OutputKey(ST(1), key) ;
	SvSETMAGIC(ST(1));
	ST(0) = sv_newmortal();
	setDUALerrno(ST(0), RETVAL) ;

    }
    XSRETURN(1);
}

#define db_key_range(db, key, range, flags)   \
	(db->Status = ((db->dbp)->key_range)(db->dbp, db->txn, &key, &range, flags))

XS(XS_BerkeleyDB__Common_db_key_range); /* prototype to pass -Wmissing-prototypes */
XS(XS_BerkeleyDB__Common_db_key_range)
{
    dXSARGS;
    if (items < 5 || items > 6)
	Perl_croak(aTHX_ "Usage: BerkeleyDB::Common::db_key_range(db, key, less, equal, greater, flags=0)");
    PERL_UNUSED_VAR(cv); /* -W */
    {
	u_int32_t	flags;
	BerkeleyDB__Common	db;
	DBTKEY_B	key;
	double	less = 0.0 ;
	double	equal = 0.0 ;
	double	greater = 0.0 ;
	DualType	RETVAL;

	if (items < 6)
	    flags = 0;
	else {
	flags = SvUV(ST(5));
	}

        if (ST(0) == &PL_sv_undef || ST(0) == NULL)
            db = NULL ;
        else if (sv_derived_from(ST(0), "BerkeleyDB::Common")) {
            IV tmp = SvIV(getInnerObject(ST(0))) ;
            db = INT2PTR(BerkeleyDB__Common, tmp);
        }
        else
            croak("db is not of type BerkeleyDB::Common");

	{
	    SV* my_sv = ST(1) ;
	    DBM_ckFilter(my_sv, filter_store_key, "filter_store_key");
	    DBT_clear(key) ;
            SvGETMAGIC(ST(1)) ;
	    if (db->recno_or_queue ||
		    (db->type == DB_BTREE && flagSet(DB_SET_RECNO))) {
	        Value = GetRecnoKey(db, SvIV(my_sv)) ; 
	        key.data = & Value; 
	        key.size = (int)sizeof(db_recno_t);
	    }
	    else {
	        key.data = SvPV(my_sv, PL_na);
	        key.size = (int)PL_na;
	    }
	};
#line 3440 "BerkeleyDB.xs"
	{
#ifndef AT_LEAST_DB_3_1
          softCrash("key_range needs Berkeley DB 3.1.x or later") ;
#else
          DB_KEY_RANGE range ;
          range.less = range.equal = range.greater = 0.0 ;
	  ckActive_Database(db->active) ;
	  saveCurrentDB(db) ;
	  RETVAL = db_key_range(db, key, range, flags);
	  if (RETVAL == 0) {
	        less = range.less ;
	        equal = range.equal;
	        greater = range.greater;
	  }
#endif
	}
#line 4970 "BerkeleyDB.c"
	sv_setnv(ST(2), (double)less);
	SvSETMAGIC(ST(2));
	sv_setnv(ST(3), (double)equal);
	SvSETMAGIC(ST(3));
	sv_setnv(ST(4), (double)greater);
	SvSETMAGIC(ST(4));
	ST(0) = sv_newmortal();
	setDUALerrno(ST(0), RETVAL) ;

    }
    XSRETURN(1);
}

#define db_fd(d, x)	(db->Status = (db->dbp->fd)(db->dbp, &x))

XS(XS_BerkeleyDB__Common_db_fd); /* prototype to pass -Wmissing-prototypes */
XS(XS_BerkeleyDB__Common_db_fd)
{
    dXSARGS;
    if (items != 1)
	Perl_croak(aTHX_ "Usage: BerkeleyDB::Common::db_fd(db)");
    PERL_UNUSED_VAR(cv); /* -W */
    {
	BerkeleyDB__Common	db;
	int	RETVAL;
	dXSTARG;

        if (ST(0) == &PL_sv_undef || ST(0) == NULL)
            db = NULL ;
        else if (sv_derived_from(ST(0), "BerkeleyDB::Common")) {
            IV tmp = SvIV(getInnerObject(ST(0))) ;
            db = INT2PTR(BerkeleyDB__Common, tmp);
        }
        else
            croak("db is not of type BerkeleyDB::Common");
#line 3468 "BerkeleyDB.xs"
	  ckActive_Database(db->active) ;
#line 5008 "BerkeleyDB.c"
#line 3470 "BerkeleyDB.xs"
	  saveCurrentDB(db) ;
	  db_fd(db, RETVAL) ;
#line 5012 "BerkeleyDB.c"
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}

#define db_sync(db, fl)	(db->Status = (db->dbp->sync)(db->dbp, fl))

XS(XS_BerkeleyDB__Common_db_sync); /* prototype to pass -Wmissing-prototypes */
XS(XS_BerkeleyDB__Common_db_sync)
{
    dXSARGS;
    if (items < 1 || items > 2)
	Perl_croak(aTHX_ "Usage: BerkeleyDB::Common::db_sync(db, flags=0)");
    PERL_UNUSED_VAR(cv); /* -W */
    {
	u_int	flags;
	BerkeleyDB__Common	db;
	DualType	RETVAL;

	if (items < 2)
	    flags = 0;
	else {
	flags = SvUV(ST(1));
	}

        if (ST(0) == &PL_sv_undef || ST(0) == NULL)
            db = NULL ;
        else if (sv_derived_from(ST(0), "BerkeleyDB::Common")) {
            IV tmp = SvIV(getInnerObject(ST(0))) ;
            db = INT2PTR(BerkeleyDB__Common, tmp);
        }
        else
            croak("db is not of type BerkeleyDB::Common");
#line 3482 "BerkeleyDB.xs"
	  ckActive_Database(db->active) ;
	  saveCurrentDB(db) ;
#line 5049 "BerkeleyDB.c"

	RETVAL = db_sync(db, flags);
	ST(0) = sv_newmortal();
	setDUALerrno(ST(0), RETVAL) ;

    }
    XSRETURN(1);
}


XS(XS_BerkeleyDB__Common__Txn); /* prototype to pass -Wmissing-prototypes */
XS(XS_BerkeleyDB__Common__Txn)
{
    dXSARGS;
    if (items < 1 || items > 2)
	Perl_croak(aTHX_ "Usage: BerkeleyDB::Common::_Txn(db, txn=NULL)");
    PERL_UNUSED_VAR(cv); /* -W */
    {
	BerkeleyDB__Common	db;
	BerkeleyDB__Txn	txn;

        if (ST(0) == &PL_sv_undef || ST(0) == NULL)
            db = NULL ;
        else if (sv_derived_from(ST(0), "BerkeleyDB::Common")) {
            IV tmp = SvIV(getInnerObject(ST(0))) ;
            db = INT2PTR(BerkeleyDB__Common, tmp);
        }
        else
            croak("db is not of type BerkeleyDB::Common");

	if (items < 2)
	    txn = NULL;
	else {
	if (ST(1) == &PL_sv_undef || ST(1) == NULL)
	    txn = NULL ;
	else if (sv_derived_from(ST(1), "BerkeleyDB::Txn")) {
	    IV tmp = SvIV(getInnerObject(ST(1))) ;
	    txn = INT2PTR(BerkeleyDB__Txn, tmp);
	}
	else
	    croak("txn is not of type BerkeleyDB::Txn");
	}
#line 3490 "BerkeleyDB.xs"
	  ckActive_Database(db->active) ;
#line 5094 "BerkeleyDB.c"
#line 3492 "BerkeleyDB.xs"
	   if (txn) {
	       Trace(("_Txn[%p] in[%p] active [%d]\n", txn->txn, txn, txn->active));
	       ckActive_Transaction(txn->active) ;
	       db->txn = txn->txn ;
	   }
	   else {
	       Trace(("_Txn[undef] \n"));
	       db->txn = NULL ;
	   }
#line 5105 "BerkeleyDB.c"
    }
    XSRETURN_EMPTY;
}

#define db_truncate(db, countp, flags)  \
	(db->Status = ((db->dbp)->truncate)(db->dbp, db->txn, &countp, flags))

XS(XS_BerkeleyDB__Common_truncate); /* prototype to pass -Wmissing-prototypes */
XS(XS_BerkeleyDB__Common_truncate)
{
    dXSARGS;
    if (items < 2 || items > 3)
	Perl_croak(aTHX_ "Usage: BerkeleyDB::Common::truncate(db, countp, flags=0)");
    PERL_UNUSED_VAR(cv); /* -W */
    {
	BerkeleyDB__Common	db;
	u_int32_t        countp = SvUV(ST(1));
	u_int32_t	flags;
	DualType	RETVAL;

        if (ST(0) == &PL_sv_undef || ST(0) == NULL)
            db = NULL ;
        else if (sv_derived_from(ST(0), "BerkeleyDB::Common")) {
            IV tmp = SvIV(getInnerObject(ST(0))) ;
            db = INT2PTR(BerkeleyDB__Common, tmp);
        }
        else
            croak("db is not of type BerkeleyDB::Common");

	if (items < 3)
	    flags = 0;
	else {
	flags = SvUV(ST(2));
	}
#line 3511 "BerkeleyDB.xs"
	  ckActive_Database(db->active) ;
#line 5142 "BerkeleyDB.c"
#line 3513 "BerkeleyDB.xs"
#ifndef AT_LEAST_DB_3_3
          softCrash("truncate needs Berkeley DB 3.3 or later") ;
#else
	  saveCurrentDB(db) ;
	  RETVAL = db_truncate(db, countp, flags);
#endif
#line 5150 "BerkeleyDB.c"
        sv_setuv(ST(1), (UV)countp);

	SvSETMAGIC(ST(1));
	ST(0) = sv_newmortal();
	setDUALerrno(ST(0), RETVAL) ;

    }
    XSRETURN(1);
}

#ifdef AT_LEAST_DB_4_1
#  define db_associate(db, sec, cb, flags)\
	(db->Status = ((db->dbp)->associate)(db->dbp, NULL, sec->dbp, &cb, flags))
#else
#  define db_associate(db, sec, cb, flags)\
	(db->Status = ((db->dbp)->associate)(db->dbp, sec->dbp, &cb, flags))
#endif

XS(XS_BerkeleyDB__Common_associate); /* prototype to pass -Wmissing-prototypes */
XS(XS_BerkeleyDB__Common_associate)
{
    dXSARGS;
    if (items < 3 || items > 4)
	Perl_croak(aTHX_ "Usage: BerkeleyDB::Common::associate(db, secondary, callback, flags=0)");
    PERL_UNUSED_VAR(cv); /* -W */
    {
	BerkeleyDB__Common	db;
	BerkeleyDB__Common	secondary;
	SV*	callback = ST(2);
	u_int32_t	flags;
	DualType	RETVAL;

        if (ST(0) == &PL_sv_undef || ST(0) == NULL)
            db = NULL ;
        else if (sv_derived_from(ST(0), "BerkeleyDB::Common")) {
            IV tmp = SvIV(getInnerObject(ST(0))) ;
            db = INT2PTR(BerkeleyDB__Common, tmp);
        }
        else
            croak("db is not of type BerkeleyDB::Common");

        if (ST(1) == &PL_sv_undef || ST(1) == NULL)
            secondary = NULL ;
        else if (sv_derived_from(ST(1), "BerkeleyDB::Common")) {
            IV tmp = SvIV(getInnerObject(ST(1))) ;
            secondary = INT2PTR(BerkeleyDB__Common, tmp);
        }
        else
            croak("secondary is not of type BerkeleyDB::Common");

	if (items < 4)
	    flags = 0;
	else {
	flags = SvUV(ST(3));
	}
#line 3537 "BerkeleyDB.xs"
	  ckActive_Database(db->active) ;
#line 5208 "BerkeleyDB.c"
#line 3539 "BerkeleyDB.xs"
#ifndef AT_LEAST_DB_3_3
          softCrash("associate needs Berkeley DB 3.3 or later") ;
#else
	  saveCurrentDB(db) ;
	  /* db->associated = newSVsv(callback) ; */
	  secondary->associated = newSVsv(callback) ;
	  secondary->primary_recno_or_queue = db->recno_or_queue ;
	  /* secondary->dbp->app_private = secondary->associated ; */
	  secondary->secondary_db = TRUE;
      if (secondary->recno_or_queue)
          RETVAL = db_associate(db, secondary, associate_cb_recno, flags);
      else
          RETVAL = db_associate(db, secondary, associate_cb, flags);
#endif
#line 5224 "BerkeleyDB.c"
	ST(0) = sv_newmortal();
	setDUALerrno(ST(0), RETVAL) ;

    }
    XSRETURN(1);
}


XS(XS_BerkeleyDB__Common_compact); /* prototype to pass -Wmissing-prototypes */
XS(XS_BerkeleyDB__Common_compact)
{
    dXSARGS;
    if (items < 1 || items > 6)
	Perl_croak(aTHX_ "Usage: BerkeleyDB::Common::compact(db, start=NULL, stop=NULL, c_data=NULL, flags=0, end=NULL)");
    PERL_UNUSED_VAR(cv); /* -W */
    {
	BerkeleyDB__Common	db;
	SVnull*	start;
	SVnull*	stop;
	SVnull*	c_data;
	u_int32_t	flags;
	SVnull*	end;
	DualType	RETVAL;

        if (ST(0) == &PL_sv_undef || ST(0) == NULL)
            db = NULL ;
        else if (sv_derived_from(ST(0), "BerkeleyDB::Common")) {
            IV tmp = SvIV(getInnerObject(ST(0))) ;
            db = INT2PTR(BerkeleyDB__Common, tmp);
        }
        else
            croak("db is not of type BerkeleyDB::Common");

	if (items < 2)
	    start = NULL;
	else {
	    if (ST(1) == NULL || ST(1) == &PL_sv_undef)
		start = NULL ;
	    else
		start = ST(1) ;
	}

	if (items < 3)
	    stop = NULL;
	else {
	    if (ST(2) == NULL || ST(2) == &PL_sv_undef)
		stop = NULL ;
	    else
		stop = ST(2) ;
	}

	if (items < 4)
	    c_data = NULL;
	else {
	    if (ST(3) == NULL || ST(3) == &PL_sv_undef)
		c_data = NULL ;
	    else
		c_data = ST(3) ;
	}

	if (items < 5)
	    flags = 0;
	else {
	flags = SvUV(ST(4));
	}

	if (items < 6)
	    end = NULL;
	else {
	    if (ST(5) == NULL || ST(5) == &PL_sv_undef)
		end = NULL ;
	    else
		end = ST(5) ;
	}
#line 3565 "BerkeleyDB.xs"
        DBTKEY	    end_key;
#line 5301 "BerkeleyDB.c"
#line 3567 "BerkeleyDB.xs"
    {
#ifndef AT_LEAST_DB_4_4
          softCrash("compact needs Berkeley DB 4.4 or later") ;
#else
        DBTKEY	    start_key;
        DBTKEY	    stop_key;
        DBTKEY*	    start_p = NULL;
        DBTKEY*	    stop_p = NULL;
        DBTKEY*	    end_p = NULL;
	    DB_COMPACT cmpt;
	    DB_COMPACT* cmpt_p = NULL;
	    SV * sv;
        HV* hash = NULL;

        DBT_clear(start_key);
        DBT_clear(stop_key);
        DBT_clear(end_key);
        Zero(&cmpt, 1, DB_COMPACT) ;
        ckActive_Database(db->active) ;
        saveCurrentDB(db) ;
        if (start && SvOK(start)) {
            start_p = &start_key;
            DBM_ckFilter(start, filter_store_key, "filter_store_key");
            GetKey(db, start, start_p);
        }
        if (stop && SvOK(stop)) {
            stop_p = &stop_key;
            DBM_ckFilter(stop, filter_store_key, "filter_store_key");
            GetKey(db, stop, stop_p);
        }
        if (end) {
            end_p = &end_key;
        }
        if (c_data && SvOK(c_data)) {
            hash = (HV*) SvRV(c_data) ;
            cmpt_p = & cmpt;
            cmpt.compact_fillpercent = GetValue_iv(hash,"compact_fillpercent") ;
            cmpt.compact_timeout = (db_timeout_t) GetValue_iv(hash, "compact_timeout"); 
        }
        RETVAL = (db->dbp)->compact(db->dbp, db->txn, start_p, stop_p, cmpt_p, flags, end_p);
        if (RETVAL == 0 && hash) {
            hv_store_iv(hash, "compact_deadlock", cmpt.compact_deadlock) ;
            hv_store_iv(hash, "compact_levels",   cmpt.compact_levels) ;
            hv_store_iv(hash, "compact_pages_free", cmpt.compact_pages_free) ;
            hv_store_iv(hash, "compact_pages_examine", cmpt.compact_pages_examine) ;
            hv_store_iv(hash, "compact_pages_truncated", cmpt.compact_pages_truncated) ;
        }
#endif
    }
#line 5352 "BerkeleyDB.c"
	if (RETVAL == 0 && end) OutputValue_B(ST(5), end_key) ;
	SvSETMAGIC(ST(5));
	ST(0) = sv_newmortal();
	setDUALerrno(ST(0), RETVAL) ;

    }
    XSRETURN(1);
}


XS(XS_BerkeleyDB__Cursor__c_dup); /* prototype to pass -Wmissing-prototypes */
XS(XS_BerkeleyDB__Cursor__c_dup)
{
    dXSARGS;
    if (items < 1 || items > 2)
	Perl_croak(aTHX_ "Usage: BerkeleyDB::Cursor::_c_dup(db, flags=0)");
    PERL_UNUSED_VAR(cv); /* -W */
    {
	u_int32_t	flags;
	BerkeleyDB__Cursor	db;
	BerkeleyDB__Cursor	RETVAL = NULL ;
	dXSTARG;

	if (items < 2)
	    flags = 0;
	else {
	flags = SvUV(ST(1));
	}

        if (ST(0) == &PL_sv_undef || ST(0) == NULL)
            db = NULL ;
        else if (sv_derived_from(ST(0), "BerkeleyDB::Cursor")) {
            IV tmp = SvIV(getInnerObject(ST(0))) ;
            db = INT2PTR(BerkeleyDB__Cursor, tmp);
        }
        else
            croak("db is not of type BerkeleyDB::Cursor");
#line 3629 "BerkeleyDB.xs"
	    saveCurrentDB(db->parent_db);
	    ckActive_Database(db->active) ;
#line 5393 "BerkeleyDB.c"
#line 3632 "BerkeleyDB.xs"
	{
#ifndef AT_LEAST_DB_3
          softCrash("c_dup needs at least Berkeley DB 3.0.x");
#else
	  DBC *		newcursor ;
	  db->Status = ((db->cursor)->c_dup)(db->cursor, &newcursor, flags) ;
	  if (db->Status == 0){
	      ZMALLOC(RETVAL, BerkeleyDB__Cursor_type) ;
	      db->parent_db->open_cursors ++ ;
	      RETVAL->parent_db  = db->parent_db ;
	      RETVAL->cursor  = newcursor ;
	      RETVAL->dbp     = db->dbp ;
              RETVAL->type    = db->type ;
              RETVAL->recno_or_queue    = db->recno_or_queue ;
              RETVAL->primary_recno_or_queue    = db->primary_recno_or_queue ;
              RETVAL->cds_enabled    = db->cds_enabled ;
              RETVAL->filename    = my_strdup(db->filename) ;
              RETVAL->compare = db->compare ;
              RETVAL->dup_compare = db->dup_compare ;
#ifdef AT_LEAST_DB_3_3
              RETVAL->associated = db->associated ;
#endif
              RETVAL->prefix  = db->prefix ;
              RETVAL->hash    = db->hash ;
	      RETVAL->partial = db->partial ;
	      RETVAL->doff    = db->doff ;
	      RETVAL->dlen    = db->dlen ;
	      RETVAL->active  = TRUE ;
#ifdef ALLOW_RECNO_OFFSET
	      RETVAL->array_base  = db->array_base ;
#endif /* ALLOW_RECNO_OFFSET */
#ifdef DBM_FILTERING
	      RETVAL->filtering   = FALSE ;
	      RETVAL->filter_fetch_key    = db->filter_fetch_key ;
	      RETVAL->filter_store_key    = db->filter_store_key ;
	      RETVAL->filter_fetch_value  = db->filter_fetch_value ;
	      RETVAL->filter_store_value  = db->filter_store_value ;
#endif /* DBM_FILTERING */
              /* RETVAL->info ; */
	      hash_store_iv("BerkeleyDB::Term::Cursor", (char *)RETVAL, 1) ;
	  }
#endif	
	}
#line 5438 "BerkeleyDB.c"
	XSprePUSH; PUSHi(PTR2IV(RETVAL));
    }
    XSRETURN(1);
}


XS(XS_BerkeleyDB__Cursor__c_close); /* prototype to pass -Wmissing-prototypes */
XS(XS_BerkeleyDB__Cursor__c_close)
{
    dXSARGS;
    if (items != 1)
	Perl_croak(aTHX_ "Usage: BerkeleyDB::Cursor::_c_close(db)");
    PERL_UNUSED_VAR(cv); /* -W */
    {
	BerkeleyDB__Cursor	db;
	DualType	RETVAL;

        if (ST(0) == &PL_sv_undef || ST(0) == NULL)
            db = NULL ;
        else if (sv_derived_from(ST(0), "BerkeleyDB::Cursor")) {
            IV tmp = SvIV(getInnerObject(ST(0))) ;
            db = INT2PTR(BerkeleyDB__Cursor, tmp);
        }
        else
            croak("db is not of type BerkeleyDB::Cursor");
#line 3682 "BerkeleyDB.xs"
	  saveCurrentDB(db->parent_db);
	  ckActive_Cursor(db->active) ;
	  hash_delete("BerkeleyDB::Term::Cursor", (char *)db) ;
#line 5468 "BerkeleyDB.c"
#line 3686 "BerkeleyDB.xs"
	  RETVAL =  db->Status =
    	          ((db->cursor)->c_close)(db->cursor) ;
	  db->active = FALSE ;
	  if (db->parent_db->open_cursors)
	      -- db->parent_db->open_cursors ;
#line 5475 "BerkeleyDB.c"
	ST(0) = sv_newmortal();
	setDUALerrno(ST(0), RETVAL) ;

    }
    XSRETURN(1);
}


XS(XS_BerkeleyDB__Cursor__DESTROY); /* prototype to pass -Wmissing-prototypes */
XS(XS_BerkeleyDB__Cursor__DESTROY)
{
    dXSARGS;
    if (items != 1)
	Perl_croak(aTHX_ "Usage: BerkeleyDB::Cursor::_DESTROY(db)");
    PERL_UNUSED_VAR(cv); /* -W */
    {
	BerkeleyDB__Cursor	db;

        if (ST(0) == &PL_sv_undef || ST(0) == NULL)
            db = NULL ;
        else if (sv_derived_from(ST(0), "BerkeleyDB::Cursor")) {
            IV tmp = SvIV(getInnerObject(ST(0))) ;
            db = INT2PTR(BerkeleyDB__Cursor, tmp);
        }
        else
            croak("db is not of type BerkeleyDB::Cursor");
#line 3698 "BerkeleyDB.xs"
	  saveCurrentDB(db->parent_db);
	  Trace(("In BerkeleyDB::Cursor::_DESTROY db %d dirty=%d active=%d\n", db, PL_dirty, db->active));
	  hash_delete("BerkeleyDB::Term::Cursor", (char *)db) ;
	  if (db->active)
    	      ((db->cursor)->c_close)(db->cursor) ;
	  if (db->parent_db->open_cursors)
	      -- db->parent_db->open_cursors ;
          Safefree(db->filename) ;
          Safefree(db) ;
	  Trace(("End of BerkeleyDB::Cursor::_DESTROY\n")) ;
#line 5513 "BerkeleyDB.c"
    }
    XSRETURN_EMPTY;
}


XS(XS_BerkeleyDB__Cursor_status); /* prototype to pass -Wmissing-prototypes */
XS(XS_BerkeleyDB__Cursor_status)
{
    dXSARGS;
    if (items != 1)
	Perl_croak(aTHX_ "Usage: BerkeleyDB::Cursor::status(db)");
    PERL_UNUSED_VAR(cv); /* -W */
    {
	BerkeleyDB__Cursor	db;
	DualType	RETVAL;

        if (ST(0) == &PL_sv_undef || ST(0) == NULL)
            db = NULL ;
        else if (sv_derived_from(ST(0), "BerkeleyDB::Cursor")) {
            IV tmp = SvIV(getInnerObject(ST(0))) ;
            db = INT2PTR(BerkeleyDB__Cursor, tmp);
        }
        else
            croak("db is not of type BerkeleyDB::Cursor");
#line 3713 "BerkeleyDB.xs"
	    RETVAL =  db->Status ;
#line 5540 "BerkeleyDB.c"
	ST(0) = sv_newmortal();
	setDUALerrno(ST(0), RETVAL) ;

    }
    XSRETURN(1);
}

#define cu_c_del(c,f)	(c->Status = ((c->cursor)->c_del)(c->cursor,f))

XS(XS_BerkeleyDB__Cursor_c_del); /* prototype to pass -Wmissing-prototypes */
XS(XS_BerkeleyDB__Cursor_c_del)
{
    dXSARGS;
    if (items < 1 || items > 2)
	Perl_croak(aTHX_ "Usage: BerkeleyDB::Cursor::c_del(db, flags=0)");
    PERL_UNUSED_VAR(cv); /* -W */
    {
	int	flags;
	BerkeleyDB__Cursor	db;
	DualType	RETVAL;

	if (items < 2)
	    flags = 0;
	else {
	    flags = (int)SvIV(ST(1));
	}

        if (ST(0) == &PL_sv_undef || ST(0) == NULL)
            db = NULL ;
        else if (sv_derived_from(ST(0), "BerkeleyDB::Cursor")) {
            IV tmp = SvIV(getInnerObject(ST(0))) ;
            db = INT2PTR(BerkeleyDB__Cursor, tmp);
        }
        else
            croak("db is not of type BerkeleyDB::Cursor");
#line 3724 "BerkeleyDB.xs"
	  saveCurrentDB(db->parent_db);
	  ckActive_Cursor(db->active) ;
#line 5579 "BerkeleyDB.c"

	RETVAL = cu_c_del(db, flags);
	ST(0) = sv_newmortal();
	setDUALerrno(ST(0), RETVAL) ;

    }
    XSRETURN(1);
}

#define cu_c_get(c,k,d,f) (c->Status = (c->cursor->c_get)(c->cursor,&k,&d,f))

XS(XS_BerkeleyDB__Cursor_c_get); /* prototype to pass -Wmissing-prototypes */
XS(XS_BerkeleyDB__Cursor_c_get)
{
    dXSARGS;
    if (items < 3 || items > 4)
	Perl_croak(aTHX_ "Usage: BerkeleyDB::Cursor::c_get(db, key, data, flags=0)");
    PERL_UNUSED_VAR(cv); /* -W */
    {
	int	flags;
	BerkeleyDB__Cursor	db;
	DBTKEY_B	key;
	DBT_B	data;
	DualType	RETVAL;

	if (items < 4)
	    flags = 0;
	else {
	    flags = (int)SvIV(ST(3));
	}

        if (ST(0) == &PL_sv_undef || ST(0) == NULL)
            db = NULL ;
        else if (sv_derived_from(ST(0), "BerkeleyDB::Cursor")) {
            IV tmp = SvIV(getInnerObject(ST(0))) ;
            db = INT2PTR(BerkeleyDB__Cursor, tmp);
        }
        else
            croak("db is not of type BerkeleyDB::Cursor");

	{
	    SV* my_sv = ST(1) ;
	    DBM_ckFilter(my_sv, filter_store_key, "filter_store_key");
	    DBT_clear(key) ;
            SvGETMAGIC(ST(1)) ;
	    if (db->recno_or_queue ||
		    (db->type == DB_BTREE && flagSet(DB_SET_RECNO))) {
	        Value = GetRecnoKey(db, SvIV(my_sv)) ; 
	        key.data = & Value; 
	        key.size = (int)sizeof(db_recno_t);
	    }
	    else {
	        key.data = SvPV(my_sv, PL_na);
	        key.size = (int)PL_na;
	    }
	};

	DBT_clear(data) ;
	if (flagSet(DB_GET_BOTH)|| flagSet(DB_GET_BOTH)) {
	    SV* my_sv = ST(2) ;
	    DBM_ckFilter(my_sv, filter_store_value, "filter_store_value");
            SvGETMAGIC(ST(2)) ;
	    data.data = SvPV(my_sv, PL_na);
	    data.size = (int)PL_na;
  	    data.flags = db->partial ;
    	    data.dlen  = db->dlen ;
	    data.doff  = db->doff ;
	};
#line 3738 "BerkeleyDB.xs"
	  Trace(("c_get db [%p] in [%p] flags [%d]\n", db->dbp, db, flags)) ;
	  saveCurrentDB(db->parent_db);
	  ckActive_Cursor(db->active) ;
	  /* DBT_clear(key); */
	  /* DBT_clear(data); */
	  SetPartial(data,db) ;
	  Trace(("c_get end\n")) ;
#line 5656 "BerkeleyDB.c"

	RETVAL = cu_c_get(db, key, data, flags);
	OutputKey_B(ST(1), key)
	SvSETMAGIC(ST(1));
	if (! flagSet(DB_JOIN_ITEM)) OutputValue_B(ST(2), data) ;
	SvSETMAGIC(ST(2));
	ST(0) = sv_newmortal();
	setDUALerrno(ST(0), RETVAL) ;

    }
    XSRETURN(1);
}

#define cu_c_pget(c,k,p,d,f) (c->Status = (c->secondary_db ? (c->cursor->c_pget)(c->cursor,&k,&p,&d,f) : EINVAL))

XS(XS_BerkeleyDB__Cursor_c_pget); /* prototype to pass -Wmissing-prototypes */
XS(XS_BerkeleyDB__Cursor_c_pget)
{
    dXSARGS;
    if (items < 4 || items > 5)
	Perl_croak(aTHX_ "Usage: BerkeleyDB::Cursor::c_pget(db, key, pkey, data, flags=0)");
    PERL_UNUSED_VAR(cv); /* -W */
    {
	int	flags;
	BerkeleyDB__Cursor	db;
	DBTKEY_B	key;
	DBTKEY_Bpr	pkey;
	DBT_B	data;
	DualType	RETVAL;

	if (items < 5)
	    flags = 0;
	else {
	    flags = (int)SvIV(ST(4));
	}

        if (ST(0) == &PL_sv_undef || ST(0) == NULL)
            db = NULL ;
        else if (sv_derived_from(ST(0), "BerkeleyDB::Cursor")) {
            IV tmp = SvIV(getInnerObject(ST(0))) ;
            db = INT2PTR(BerkeleyDB__Cursor, tmp);
        }
        else
            croak("db is not of type BerkeleyDB::Cursor");

	{
	    SV* my_sv = ST(1) ;
	    DBM_ckFilter(my_sv, filter_store_key, "filter_store_key");
	    DBT_clear(key) ;
            SvGETMAGIC(ST(1)) ;
	    if (db->recno_or_queue ||
		    (db->type == DB_BTREE && flagSet(DB_SET_RECNO))) {
	        Value = GetRecnoKey(db, SvIV(my_sv)) ; 
	        key.data = & Value; 
	        key.size = (int)sizeof(db_recno_t);
	    }
	    else {
	        key.data = SvPV(my_sv, PL_na);
	        key.size = (int)PL_na;
	    }
	};

	DBT_clear(data) ;
	if (flagSet(DB_GET_BOTH)|| flagSet(DB_GET_BOTH)) {
	    SV* my_sv = ST(3) ;
	    DBM_ckFilter(my_sv, filter_store_value, "filter_store_value");
            SvGETMAGIC(ST(3)) ;
	    data.data = SvPV(my_sv, PL_na);
	    data.size = (int)PL_na;
  	    data.flags = db->partial ;
    	    data.dlen  = db->dlen ;
	    data.doff  = db->doff ;
	};
#line 3759 "BerkeleyDB.xs"
#ifndef AT_LEAST_DB_3_3
          softCrash("db_c_pget needs at least Berkeley DB 3.3");
#else
	  Trace(("c_pget db [%d] flags [%d]\n", db, flags)) ;
	  saveCurrentDB(db->parent_db);
	  ckActive_Cursor(db->active) ;
	  SetPartial(data,db) ;
	  DBT_clear(pkey);
	  RETVAL = cu_c_pget(db, key, pkey, data, flags);
	  Trace(("c_pget end\n")) ;
#endif
#line 5742 "BerkeleyDB.c"
	OutputKey_B(ST(1), key)
	SvSETMAGIC(ST(1));
	OutputKey_Bpr(ST(2), pkey)
	SvSETMAGIC(ST(2));
	OutputValue_B(ST(3), data)

	SvSETMAGIC(ST(3));
	ST(0) = sv_newmortal();
	setDUALerrno(ST(0), RETVAL) ;

    }
    XSRETURN(1);
}

#define cu_c_put(c,k,d,f)  (c->Status = (c->cursor->c_put)(c->cursor,&k,&d,f))

XS(XS_BerkeleyDB__Cursor_c_put); /* prototype to pass -Wmissing-prototypes */
XS(XS_BerkeleyDB__Cursor_c_put)
{
    dXSARGS;
    if (items < 3 || items > 4)
	Perl_croak(aTHX_ "Usage: BerkeleyDB::Cursor::c_put(db, key, data, flags=0)");
    PERL_UNUSED_VAR(cv); /* -W */
    {
	int	flags;
	BerkeleyDB__Cursor	db;
	DBTKEY	key;
	DBT	data;
	DualType	RETVAL;

	if (items < 4)
	    flags = 0;
	else {
	    flags = (int)SvIV(ST(3));
	}

        if (ST(0) == &PL_sv_undef || ST(0) == NULL)
            db = NULL ;
        else if (sv_derived_from(ST(0), "BerkeleyDB::Cursor")) {
            IV tmp = SvIV(getInnerObject(ST(0))) ;
            db = INT2PTR(BerkeleyDB__Cursor, tmp);
        }
        else
            croak("db is not of type BerkeleyDB::Cursor");

	{
	    SV* my_sv = ST(1) ;
	    DBM_ckFilter(my_sv, filter_store_key, "filter_store_key");
	    DBT_clear(key) ;
            SvGETMAGIC(ST(1)) ;
	    if (db->recno_or_queue) {
	        Value = GetRecnoKey(db, SvIV(my_sv)) ; 
	        key.data = & Value; 
	        key.size = (int)sizeof(db_recno_t);
	    }
	    else {
	        key.data = SvPV(my_sv, PL_na);
	        key.size = (int)PL_na;
	    }
	};

	{
	    SV* my_sv = ST(2) ;
	    DBM_ckFilter(my_sv, filter_store_value, "filter_store_value");
	    DBT_clear(data) ;
            SvGETMAGIC(ST(2)) ;
	    data.data = SvPV(my_sv, PL_na);
	    data.size = (int)PL_na;
  	    data.flags = db->partial ;
    	    data.dlen  = db->dlen ;
	    data.doff  = db->doff ;
	};
#line 3786 "BerkeleyDB.xs"
	  saveCurrentDB(db->parent_db);
	  ckActive_Cursor(db->active) ;
	  /* SetPartial(data,db) ; */
#line 5819 "BerkeleyDB.c"

	RETVAL = cu_c_put(db, key, data, flags);
	ST(0) = sv_newmortal();
	setDUALerrno(ST(0), RETVAL) ;

    }
    XSRETURN(1);
}

#define cu_c_count(c,p,f) (c->Status = (c->cursor->c_count)(c->cursor,&p,f))

XS(XS_BerkeleyDB__Cursor_c_count); /* prototype to pass -Wmissing-prototypes */
XS(XS_BerkeleyDB__Cursor_c_count)
{
    dXSARGS;
    if (items < 2 || items > 3)
	Perl_croak(aTHX_ "Usage: BerkeleyDB::Cursor::c_count(db, count, flags=0)");
    PERL_UNUSED_VAR(cv); /* -W */
    {
	int	flags;
	BerkeleyDB__Cursor	db;
	u_int32_t	count;
	DualType	RETVAL;

	if (items < 3)
	    flags = 0;
	else {
	    flags = (int)SvIV(ST(2));
	}

        if (ST(0) == &PL_sv_undef || ST(0) == NULL)
            db = NULL ;
        else if (sv_derived_from(ST(0), "BerkeleyDB::Cursor")) {
            IV tmp = SvIV(getInnerObject(ST(0))) ;
            db = INT2PTR(BerkeleyDB__Cursor, tmp);
        }
        else
            croak("db is not of type BerkeleyDB::Cursor");
#line 3799 "BerkeleyDB.xs"
#ifndef AT_LEAST_DB_3_1
          softCrash("c_count needs at least Berkeley DB 3.1.x");
#else
	  Trace(("c_get count [%d] flags [%d]\n", db, flags)) ;
	  saveCurrentDB(db->parent_db);
	  ckActive_Cursor(db->active) ;
	  RETVAL = cu_c_count(db, count, flags) ;
	  Trace(("    c_count got %d duplicates\n", count)) ;
#endif
#line 5868 "BerkeleyDB.c"
        sv_setuv(ST(1), (UV)count);

	SvSETMAGIC(ST(1));
	ST(0) = sv_newmortal();
	setDUALerrno(ST(0), RETVAL) ;

    }
    XSRETURN(1);
}


XS(XS_BerkeleyDB__TxnMgr__txn_begin); /* prototype to pass -Wmissing-prototypes */
XS(XS_BerkeleyDB__TxnMgr__txn_begin)
{
    dXSARGS;
    if (items < 1 || items > 3)
	Perl_croak(aTHX_ "Usage: BerkeleyDB::TxnMgr::_txn_begin(txnmgr, pid=NULL, flags=0)");
    PERL_UNUSED_VAR(cv); /* -W */
    {
	u_int32_t	flags;
	BerkeleyDB__TxnMgr	txnmgr;
	BerkeleyDB__Txn	pid;
	BerkeleyDB__Txn__Raw	RETVAL;
	dXSTARG;

	if (items < 3)
	    flags = 0;
	else {
	flags = SvUV(ST(2));
	}

        if (ST(0) == &PL_sv_undef || ST(0) == NULL)
            txnmgr = NULL ;
        else if (sv_derived_from(ST(0), "BerkeleyDB::TxnMgr")) {
            IV tmp = SvIV(getInnerObject(ST(0))) ;
            txnmgr = INT2PTR(BerkeleyDB__TxnMgr, tmp);
        }
        else
            croak("txnmgr is not of type BerkeleyDB::TxnMgr");

	if (items < 2)
	    pid = NULL;
	else {
	if (ST(1) == &PL_sv_undef || ST(1) == NULL)
	    pid = NULL ;
	else if (sv_derived_from(ST(1), "BerkeleyDB::Txn")) {
	    IV tmp = SvIV(getInnerObject(ST(1))) ;
	    pid = INT2PTR(BerkeleyDB__Txn, tmp);
	}
	else
	    croak("pid is not of type BerkeleyDB::Txn");
	}
#line 3820 "BerkeleyDB.xs"
	{
	    DB_TXN *txn ;
	    DB_TXN *p_id = NULL ;
#if DB_VERSION_MAJOR == 2
	    if (txnmgr->env->Env->tx_info == NULL)
		softCrash("Transaction Manager not enabled") ;
#endif
	    if (pid)
		p_id = pid->txn ;
	    txnmgr->env->TxnMgrStatus =
#if DB_VERSION_MAJOR == 2
	    	txn_begin(txnmgr->env->Env->tx_info, p_id, &txn) ;
#else
#  ifdef AT_LEAST_DB_4
	    	txnmgr->env->Env->txn_begin(txnmgr->env->Env, p_id, &txn, flags) ;
#  else
	    	txn_begin(txnmgr->env->Env, p_id, &txn, flags) ;
#  endif
#endif
	    if (txnmgr->env->TxnMgrStatus == 0) {
	      ZMALLOC(RETVAL, BerkeleyDB_Txn_type) ;
	      RETVAL->txn  = txn ;
	      RETVAL->active = TRUE ;
	      Trace(("_txn_begin created txn [%d] in [%d]\n", txn, RETVAL));
	      hash_store_iv("BerkeleyDB::Term::Txn", (char *)RETVAL, 1) ;
	    }
	    else
		RETVAL = NULL ;
	}
#line 5951 "BerkeleyDB.c"
	XSprePUSH; PUSHi(PTR2IV(RETVAL));
    }
    XSRETURN(1);
}


XS(XS_BerkeleyDB__TxnMgr_status); /* prototype to pass -Wmissing-prototypes */
XS(XS_BerkeleyDB__TxnMgr_status)
{
    dXSARGS;
    if (items != 1)
	Perl_croak(aTHX_ "Usage: BerkeleyDB::TxnMgr::status(mgr)");
    PERL_UNUSED_VAR(cv); /* -W */
    {
	BerkeleyDB__TxnMgr	mgr;
	DualType	RETVAL;

        if (ST(0) == &PL_sv_undef || ST(0) == NULL)
            mgr = NULL ;
        else if (sv_derived_from(ST(0), "BerkeleyDB::TxnMgr")) {
            IV tmp = SvIV(getInnerObject(ST(0))) ;
            mgr = INT2PTR(BerkeleyDB__TxnMgr, tmp);
        }
        else
            croak("mgr is not of type BerkeleyDB::TxnMgr");
#line 3857 "BerkeleyDB.xs"
	    RETVAL =  mgr->env->TxnMgrStatus ;
#line 5979 "BerkeleyDB.c"
	ST(0) = sv_newmortal();
	setDUALerrno(ST(0), RETVAL) ;

    }
    XSRETURN(1);
}


XS(XS_BerkeleyDB__TxnMgr__DESTROY); /* prototype to pass -Wmissing-prototypes */
XS(XS_BerkeleyDB__TxnMgr__DESTROY)
{
    dXSARGS;
    if (items != 1)
	Perl_croak(aTHX_ "Usage: BerkeleyDB::TxnMgr::_DESTROY(mgr)");
    PERL_UNUSED_VAR(cv); /* -W */
    {
	BerkeleyDB__TxnMgr	mgr;

        if (ST(0) == &PL_sv_undef || ST(0) == NULL)
            mgr = NULL ;
        else if (sv_derived_from(ST(0), "BerkeleyDB::TxnMgr")) {
            IV tmp = SvIV(getInnerObject(ST(0))) ;
            mgr = INT2PTR(BerkeleyDB__TxnMgr, tmp);
        }
        else
            croak("mgr is not of type BerkeleyDB::TxnMgr");
#line 3866 "BerkeleyDB.xs"
	  Trace(("In BerkeleyDB::TxnMgr::DESTROY dirty=%d\n", PL_dirty)) ;
          Safefree(mgr) ;
	  Trace(("End of BerkeleyDB::TxnMgr::DESTROY\n")) ;
#line 6010 "BerkeleyDB.c"
    }
    XSRETURN_EMPTY;
}


XS(XS_BerkeleyDB__TxnMgr_txn_close); /* prototype to pass -Wmissing-prototypes */
XS(XS_BerkeleyDB__TxnMgr_txn_close)
{
    dXSARGS;
    if (items != 1)
	Perl_croak(aTHX_ "Usage: BerkeleyDB::TxnMgr::txn_close(txnp)");
    PERL_UNUSED_VAR(cv); /* -W */
    {
	BerkeleyDB__TxnMgr	txnp;

	Perl_croak(aTHX_ "BerkeleyDB::TxnMgr::txn_close: not implemented yet");
    }
    XSRETURN(1);
}

#if DB_VERSION_MAJOR == 2
#  define xx_txn_checkpoint(t,k,m,f) txn_checkpoint(t->env->Env->tx_info, k, m)
#else
#  ifdef AT_LEAST_DB_4 
#    define xx_txn_checkpoint(e,k,m,f) e->env->Env->txn_checkpoint(e->env->Env, k, m, f)
#  else
#    ifdef AT_LEAST_DB_3_1
#      define xx_txn_checkpoint(t,k,m,f) txn_checkpoint(t->env->Env, k, m, 0)
#    else
#      define xx_txn_checkpoint(t,k,m,f) txn_checkpoint(t->env->Env, k, m)
#    endif
#  endif
#endif

XS(XS_BerkeleyDB__TxnMgr_txn_checkpoint); /* prototype to pass -Wmissing-prototypes */
XS(XS_BerkeleyDB__TxnMgr_txn_checkpoint)
{
    dXSARGS;
    if (items < 3 || items > 4)
	Perl_croak(aTHX_ "Usage: BerkeleyDB::TxnMgr::txn_checkpoint(txnp, kbyte, min, flags=0)");
    PERL_UNUSED_VAR(cv); /* -W */
    {
	BerkeleyDB__TxnMgr	txnp;
	long	kbyte = (long)SvIV(ST(1));
	long	min = (long)SvIV(ST(2));
	u_int32_t	flags;
	DualType	RETVAL;

        if (ST(0) == &PL_sv_undef || ST(0) == NULL)
            txnp = NULL ;
        else if (sv_derived_from(ST(0), "BerkeleyDB::TxnMgr")) {
            IV tmp = SvIV(getInnerObject(ST(0))) ;
            txnp = INT2PTR(BerkeleyDB__TxnMgr, tmp);
        }
        else
            croak("txnp is not of type BerkeleyDB::TxnMgr");

	if (items < 4)
	    flags = 0;
	else {
	flags = SvUV(ST(3));
	}

	RETVAL = xx_txn_checkpoint(txnp, kbyte, min, flags);
	ST(0) = sv_newmortal();
	setDUALerrno(ST(0), RETVAL) ;

    }
    XSRETURN(1);
}


XS(XS_BerkeleyDB__TxnMgr_txn_stat); /* prototype to pass -Wmissing-prototypes */
XS(XS_BerkeleyDB__TxnMgr_txn_stat)
{
    dXSARGS;
    if (items != 1)
	Perl_croak(aTHX_ "Usage: BerkeleyDB::TxnMgr::txn_stat(txnp)");
    PERL_UNUSED_VAR(cv); /* -W */
    {
	BerkeleyDB__TxnMgr	txnp;
	HV *	RETVAL = NULL ;

        if (ST(0) == &PL_sv_undef || ST(0) == NULL)
            txnp = NULL ;
        else if (sv_derived_from(ST(0), "BerkeleyDB::TxnMgr")) {
            IV tmp = SvIV(getInnerObject(ST(0))) ;
            txnp = INT2PTR(BerkeleyDB__TxnMgr, tmp);
        }
        else
            croak("txnp is not of type BerkeleyDB::TxnMgr");
#line 3901 "BerkeleyDB.xs"
	{
	    DB_TXN_STAT *	stat ;
#ifdef AT_LEAST_DB_4
	    if(txnp->env->Env->txn_stat(txnp->env->Env, &stat, 0) == 0) {
#else
#  ifdef AT_LEAST_DB_3_3
	    if(txn_stat(txnp->env->Env, &stat) == 0) {
#  else
#    if DB_VERSION_MAJOR == 2
	    if(txn_stat(txnp->env->Env->tx_info, &stat, safemalloc) == 0) {
#    else
	    if(txn_stat(txnp->env->Env, &stat, safemalloc) == 0) {
#    endif
#  endif
#endif
	    	RETVAL = (HV*)sv_2mortal((SV*)newHV()) ;
		hv_store_iv(RETVAL, "st_time_ckp", stat->st_time_ckp) ;
		hv_store_iv(RETVAL, "st_last_txnid", stat->st_last_txnid) ;
		hv_store_iv(RETVAL, "st_maxtxns", stat->st_maxtxns) ;
		hv_store_iv(RETVAL, "st_naborts", stat->st_naborts) ;
		hv_store_iv(RETVAL, "st_nbegins", stat->st_nbegins) ;
		hv_store_iv(RETVAL, "st_ncommits", stat->st_ncommits) ;
		hv_store_iv(RETVAL, "st_nactive", stat->st_nactive) ;
#if DB_VERSION_MAJOR > 2
		hv_store_iv(RETVAL, "st_maxnactive", stat->st_maxnactive) ;
		hv_store_iv(RETVAL, "st_regsize", stat->st_regsize) ;
		hv_store_iv(RETVAL, "st_region_wait", stat->st_region_wait) ;
		hv_store_iv(RETVAL, "st_region_nowait", stat->st_region_nowait) ;
#endif
		safefree(stat) ;
	    }
	}
#line 6135 "BerkeleyDB.c"
	ST(0) = newRV((SV*)RETVAL);
	sv_2mortal(ST(0));
    }
    XSRETURN(1);
}


XS(XS_BerkeleyDB__TxnMgr_txn_open); /* prototype to pass -Wmissing-prototypes */
XS(XS_BerkeleyDB__TxnMgr_txn_open)
{
    dXSARGS;
    if (items != 4)
	Perl_croak(aTHX_ "Usage: BerkeleyDB::TxnMgr::txn_open(dir, flags, mode, dbenv)");
    PERL_UNUSED_VAR(cv); /* -W */
    {
	int	flags = (int)SvIV(ST(1));
	const char *	dir;
	int	mode = (int)SvIV(ST(2));
	BerkeleyDB__Env	dbenv;

	Perl_croak(aTHX_ "BerkeleyDB::TxnMgr::txn_open: not implemented yet");
    }
    XSRETURN(1);
}


XS(XS_BerkeleyDB__Txn_status); /* prototype to pass -Wmissing-prototypes */
XS(XS_BerkeleyDB__Txn_status)
{
    dXSARGS;
    if (items != 1)
	Perl_croak(aTHX_ "Usage: BerkeleyDB::Txn::status(tid)");
    PERL_UNUSED_VAR(cv); /* -W */
    {
	BerkeleyDB__Txn	tid;
	DualType	RETVAL;

        if (ST(0) == &PL_sv_undef || ST(0) == NULL)
            tid = NULL ;
        else if (sv_derived_from(ST(0), "BerkeleyDB::Txn")) {
            IV tmp = SvIV(getInnerObject(ST(0))) ;
            tid = INT2PTR(BerkeleyDB__Txn, tmp);
        }
        else
            croak("tid is not of type BerkeleyDB::Txn");
#line 3952 "BerkeleyDB.xs"
	    RETVAL =  tid->Status ;
#line 6183 "BerkeleyDB.c"
	ST(0) = sv_newmortal();
	setDUALerrno(ST(0), RETVAL) ;

    }
    XSRETURN(1);
}


XS(XS_BerkeleyDB__Txn__DESTROY); /* prototype to pass -Wmissing-prototypes */
XS(XS_BerkeleyDB__Txn__DESTROY)
{
    dXSARGS;
    if (items != 1)
	Perl_croak(aTHX_ "Usage: BerkeleyDB::Txn::_DESTROY(tid)");
    PERL_UNUSED_VAR(cv); /* -W */
    {
	BerkeleyDB__Txn	tid;
	int	RETVAL;
	dXSTARG;

        if (ST(0) == &PL_sv_undef || ST(0) == NULL)
            tid = NULL ;
        else if (sv_derived_from(ST(0), "BerkeleyDB::Txn")) {
            IV tmp = SvIV(getInnerObject(ST(0))) ;
            tid = INT2PTR(BerkeleyDB__Txn, tmp);
        }
        else
            croak("tid is not of type BerkeleyDB::Txn");
#line 3960 "BerkeleyDB.xs"
	  Trace(("In BerkeleyDB::Txn::_DESTROY txn [%d] active [%d] dirty=%d\n", tid->txn, tid->active, PL_dirty)) ;
	  if (tid->active)
#ifdef AT_LEAST_DB_4
	    tid->txn->abort(tid->txn) ;
#else
	    txn_abort(tid->txn) ;
#endif
          RETVAL = (int)tid ;
	  hash_delete("BerkeleyDB::Term::Txn", (char *)tid) ;
          Safefree(tid) ;
	  Trace(("End of BerkeleyDB::Txn::DESTROY\n")) ;
#line 6224 "BerkeleyDB.c"
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}

#define xx_txn_unlink(d,f,e)	txn_unlink(d,f,&(e->Env))

XS(XS_BerkeleyDB__Txn_txn_unlink); /* prototype to pass -Wmissing-prototypes */
XS(XS_BerkeleyDB__Txn_txn_unlink)
{
    dXSARGS;
    if (items != 3)
	Perl_croak(aTHX_ "Usage: BerkeleyDB::Txn::txn_unlink(dir, force, dbenv)");
    PERL_UNUSED_VAR(cv); /* -W */
    {
	const char *	dir;
	int	force = (int)SvIV(ST(1));
	BerkeleyDB__Env	dbenv;

	Perl_croak(aTHX_ "BerkeleyDB::Txn::txn_unlink: not implemented yet");
    }
    XSRETURN(1);
}

#ifdef AT_LEAST_DB_4
#  define xx_txn_prepare(t) (t->Status = t->txn->prepare(t->txn, 0))
#else
#  ifdef AT_LEAST_DB_3_3
#    define xx_txn_prepare(t) (t->Status = txn_prepare(t->txn, 0))
#  else
#    define xx_txn_prepare(t) (t->Status = txn_prepare(t->txn))
#  endif
#endif

XS(XS_BerkeleyDB__Txn_txn_prepare); /* prototype to pass -Wmissing-prototypes */
XS(XS_BerkeleyDB__Txn_txn_prepare)
{
    dXSARGS;
    if (items != 1)
	Perl_croak(aTHX_ "Usage: BerkeleyDB::Txn::txn_prepare(tid)");
    PERL_UNUSED_VAR(cv); /* -W */
    {
	BerkeleyDB__Txn	tid;
	DualType	RETVAL;

        if (ST(0) == &PL_sv_undef || ST(0) == NULL)
            tid = NULL ;
        else if (sv_derived_from(ST(0), "BerkeleyDB::Txn")) {
            IV tmp = SvIV(getInnerObject(ST(0))) ;
            tid = INT2PTR(BerkeleyDB__Txn, tmp);
        }
        else
            croak("tid is not of type BerkeleyDB::Txn");
#line 3995 "BerkeleyDB.xs"
	    ckActive_Transaction(tid->active) ;
#line 6280 "BerkeleyDB.c"

	RETVAL = xx_txn_prepare(tid);
	ST(0) = sv_newmortal();
	setDUALerrno(ST(0), RETVAL) ;

    }
    XSRETURN(1);
}

#ifdef AT_LEAST_DB_4
#  define _txn_commit(t,flags) (t->Status = t->txn->commit(t->txn, flags))
#else
#  if DB_VERSION_MAJOR == 2
#    define _txn_commit(t,flags) (t->Status = txn_commit(t->txn))
#  else
#    define _txn_commit(t, flags) (t->Status = txn_commit(t->txn, flags))
#  endif
#endif

XS(XS_BerkeleyDB__Txn__txn_commit); /* prototype to pass -Wmissing-prototypes */
XS(XS_BerkeleyDB__Txn__txn_commit)
{
    dXSARGS;
    if (items < 1 || items > 2)
	Perl_croak(aTHX_ "Usage: BerkeleyDB::Txn::_txn_commit(tid, flags=0)");
    PERL_UNUSED_VAR(cv); /* -W */
    {
	u_int32_t	flags;
	BerkeleyDB__Txn	tid;
	DualType	RETVAL;

	if (items < 2)
	    flags = 0;
	else {
	flags = SvUV(ST(1));
	}

        if (ST(0) == &PL_sv_undef || ST(0) == NULL)
            tid = NULL ;
        else if (sv_derived_from(ST(0), "BerkeleyDB::Txn")) {
            IV tmp = SvIV(getInnerObject(ST(0))) ;
            tid = INT2PTR(BerkeleyDB__Txn, tmp);
        }
        else
            croak("tid is not of type BerkeleyDB::Txn");
#line 4011 "BerkeleyDB.xs"
	    ckActive_Transaction(tid->active) ;
	    hash_delete("BerkeleyDB::Term::Txn", (char *)tid) ;
	    tid->active = FALSE ;
#line 6330 "BerkeleyDB.c"

	RETVAL = _txn_commit(tid, flags);
	ST(0) = sv_newmortal();
	setDUALerrno(ST(0), RETVAL) ;

    }
    XSRETURN(1);
}

#ifdef AT_LEAST_DB_4
#  define _txn_abort(t) (t->Status = t->txn->abort(t->txn))
#else
#  define _txn_abort(t) (t->Status = txn_abort(t->txn))
#endif

XS(XS_BerkeleyDB__Txn__txn_abort); /* prototype to pass -Wmissing-prototypes */
XS(XS_BerkeleyDB__Txn__txn_abort)
{
    dXSARGS;
    if (items != 1)
	Perl_croak(aTHX_ "Usage: BerkeleyDB::Txn::_txn_abort(tid)");
    PERL_UNUSED_VAR(cv); /* -W */
    {
	BerkeleyDB__Txn	tid;
	DualType	RETVAL;

        if (ST(0) == &PL_sv_undef || ST(0) == NULL)
            tid = NULL ;
        else if (sv_derived_from(ST(0), "BerkeleyDB::Txn")) {
            IV tmp = SvIV(getInnerObject(ST(0))) ;
            tid = INT2PTR(BerkeleyDB__Txn, tmp);
        }
        else
            croak("tid is not of type BerkeleyDB::Txn");
#line 4024 "BerkeleyDB.xs"
	    ckActive_Transaction(tid->active) ;
	    hash_delete("BerkeleyDB::Term::Txn", (char *)tid) ;
	    tid->active = FALSE ;
#line 6369 "BerkeleyDB.c"

	RETVAL = _txn_abort(tid);
	ST(0) = sv_newmortal();
	setDUALerrno(ST(0), RETVAL) ;

    }
    XSRETURN(1);
}

#ifdef AT_LEAST_DB_4
#  define _txn_discard(t,f) (t->Status = t->txn->discard(t->txn, f))
#else
#  ifdef AT_LEAST_DB_3_3_4
#    define _txn_discard(t,f) (t->Status = txn_discard(t->txn, f))
#  else
#    define _txn_discard(t,f) (int)softCrash("txn_discard needs Berkeley DB 3.3.4 or better") ;
#  endif
#endif

XS(XS_BerkeleyDB__Txn__txn_discard); /* prototype to pass -Wmissing-prototypes */
XS(XS_BerkeleyDB__Txn__txn_discard)
{
    dXSARGS;
    if (items < 1 || items > 2)
	Perl_croak(aTHX_ "Usage: BerkeleyDB::Txn::_txn_discard(tid, flags=0)");
    PERL_UNUSED_VAR(cv); /* -W */
    {
	BerkeleyDB__Txn	tid;
	u_int32_t	flags;
	DualType	RETVAL;

        if (ST(0) == &PL_sv_undef || ST(0) == NULL)
            tid = NULL ;
        else if (sv_derived_from(ST(0), "BerkeleyDB::Txn")) {
            IV tmp = SvIV(getInnerObject(ST(0))) ;
            tid = INT2PTR(BerkeleyDB__Txn, tmp);
        }
        else
            croak("tid is not of type BerkeleyDB::Txn");

	if (items < 2)
	    flags = 0;
	else {
	flags = SvUV(ST(1));
	}
#line 4042 "BerkeleyDB.xs"
	    ckActive_Transaction(tid->active) ;
	    hash_delete("BerkeleyDB::Term::Txn", (char *)tid) ;
	    tid->active = FALSE ;
#line 6419 "BerkeleyDB.c"

	RETVAL = _txn_discard(tid, flags);
	ST(0) = sv_newmortal();
	setDUALerrno(ST(0), RETVAL) ;

    }
    XSRETURN(1);
}

#ifdef AT_LEAST_DB_4
#  define xx_txn_id(t) t->txn->id(t->txn)
#else
#  define xx_txn_id(t) txn_id(t->txn)
#endif

XS(XS_BerkeleyDB__Txn_txn_id); /* prototype to pass -Wmissing-prototypes */
XS(XS_BerkeleyDB__Txn_txn_id)
{
    dXSARGS;
    if (items != 1)
	Perl_croak(aTHX_ "Usage: BerkeleyDB::Txn::txn_id(tid)");
    PERL_UNUSED_VAR(cv); /* -W */
    {
	BerkeleyDB__Txn	tid;
	u_int32_t	RETVAL;
	dXSTARG;

        if (ST(0) == &PL_sv_undef || ST(0) == NULL)
            tid = NULL ;
        else if (sv_derived_from(ST(0), "BerkeleyDB::Txn")) {
            IV tmp = SvIV(getInnerObject(ST(0))) ;
            tid = INT2PTR(BerkeleyDB__Txn, tmp);
        }
        else
            croak("tid is not of type BerkeleyDB::Txn");

	RETVAL = xx_txn_id(tid);
	XSprePUSH; PUSHu((UV)RETVAL);
    }
    XSRETURN(1);
}


XS(XS_BerkeleyDB___tiedHash_FIRSTKEY); /* prototype to pass -Wmissing-prototypes */
XS(XS_BerkeleyDB___tiedHash_FIRSTKEY)
{
    dXSARGS;
    if (items != 1)
	Perl_croak(aTHX_ "Usage: BerkeleyDB::_tiedHash::FIRSTKEY(db)");
    PERL_UNUSED_VAR(cv); /* -W */
    {
	BerkeleyDB__Common	db;
	int	RETVAL;
	dXSTARG;

        if (ST(0) == &PL_sv_undef || ST(0) == NULL)
            db = NULL ;
        else if (sv_derived_from(ST(0), "BerkeleyDB::Common")) {
            IV tmp = SvIV(getInnerObject(ST(0))) ;
            db = INT2PTR(BerkeleyDB__Common, tmp);
        }
        else
            croak("db is not of type BerkeleyDB::Common");
#line 4061 "BerkeleyDB.xs"
        {
            DBTKEY      key ;
            DBT         value ;
	    DBC *	cursor ;

	    /*
		TODO!
		set partial value to 0 - to eliminate the retrieval of
		the value need to store any existing partial settings &
		restore at the end.

	     */
            saveCurrentDB(db) ;
	    DBT_clear(key) ;
	    DBT_clear(value) ;
	    /* If necessary create a cursor for FIRSTKEY/NEXTKEY use */
	    if (!db->cursor &&
		(db->Status = db_cursor(db, db->txn, &cursor, 0)) == 0 )
	            db->cursor  = cursor ;

	    if (db->cursor)
	        RETVAL = (db->Status) =
		    ((db->cursor)->c_get)(db->cursor, &key, &value, DB_FIRST);
	    else
		RETVAL = db->Status ;
	    /* check for end of cursor */
	    if (RETVAL == DB_NOTFOUND) {
	      ((db->cursor)->c_close)(db->cursor) ;
	      db->cursor = NULL ;
	    }
            ST(0) = sv_newmortal();
	    OutputKey(ST(0), key)
        }
#line 6517 "BerkeleyDB.c"
    }
    XSRETURN(1);
}


XS(XS_BerkeleyDB___tiedHash_NEXTKEY); /* prototype to pass -Wmissing-prototypes */
XS(XS_BerkeleyDB___tiedHash_NEXTKEY)
{
    dXSARGS;
    if (items != 2)
	Perl_croak(aTHX_ "Usage: BerkeleyDB::_tiedHash::NEXTKEY(db, key)");
    PERL_UNUSED_VAR(cv); /* -W */
    {
	BerkeleyDB__Common	db;
	DBTKEY	key;
	int	RETVAL;
	dXSTARG;

        if (ST(0) == &PL_sv_undef || ST(0) == NULL)
            db = NULL ;
        else if (sv_derived_from(ST(0), "BerkeleyDB::Common")) {
            IV tmp = SvIV(getInnerObject(ST(0))) ;
            db = INT2PTR(BerkeleyDB__Common, tmp);
        }
        else
            croak("db is not of type BerkeleyDB::Common");
#line 4102 "BerkeleyDB.xs"
        {
            DBT         value ;

            saveCurrentDB(db) ;
	    DBT_clear(key) ;
	    DBT_clear(value) ;
	    key.flags = 0 ;
	    RETVAL = (db->Status) =
		((db->cursor)->c_get)(db->cursor, &key, &value, DB_NEXT);

	    /* check for end of cursor */
	    if (RETVAL == DB_NOTFOUND) {
	      ((db->cursor)->c_close)(db->cursor) ;
	      db->cursor = NULL ;
	    }
            ST(0) = sv_newmortal();
	    OutputKey(ST(0), key)
        }
#line 6563 "BerkeleyDB.c"
    }
    XSRETURN(1);
}


XS(XS_BerkeleyDB___tiedArray_FETCHSIZE); /* prototype to pass -Wmissing-prototypes */
XS(XS_BerkeleyDB___tiedArray_FETCHSIZE)
{
    dXSARGS;
    if (items != 1)
	Perl_croak(aTHX_ "Usage: BerkeleyDB::_tiedArray::FETCHSIZE(db)");
    PERL_UNUSED_VAR(cv); /* -W */
    {
	BerkeleyDB__Common	db;
	I32	RETVAL;
	dXSTARG;

        if (ST(0) == &PL_sv_undef || ST(0) == NULL)
            db = NULL ;
        else if (sv_derived_from(ST(0), "BerkeleyDB::Common")) {
            IV tmp = SvIV(getInnerObject(ST(0))) ;
            db = INT2PTR(BerkeleyDB__Common, tmp);
        }
        else
            croak("db is not of type BerkeleyDB::Common");
#line 4127 "BerkeleyDB.xs"
            saveCurrentDB(db) ;
            RETVAL = GetArrayLength(db) ;
#line 6592 "BerkeleyDB.c"
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}

#ifdef __cplusplus
extern "C"
#endif
XS(boot_BerkeleyDB); /* prototype to pass -Wmissing-prototypes */
XS(boot_BerkeleyDB)
{
    dXSARGS;
    char* file = __FILE__;

    PERL_UNUSED_VAR(cv); /* -W */
    PERL_UNUSED_VAR(items); /* -W */
    XS_VERSION_BOOTCHECK ;

    {
        CV * cv ;

        newXS("BerkeleyDB::constant", XS_BerkeleyDB_constant, file);
        newXS("BerkeleyDB::db_version", XS_BerkeleyDB_db_version, file);
        newXS("BerkeleyDB::db_value_set", XS_BerkeleyDB_db_value_set, file);
        newXS("BerkeleyDB::_db_remove", XS_BerkeleyDB__db_remove, file);
        newXS("BerkeleyDB::_db_verify", XS_BerkeleyDB__db_verify, file);
        newXS("BerkeleyDB::_db_rename", XS_BerkeleyDB__db_rename, file);
        newXS("BerkeleyDB::Env::create", XS_BerkeleyDB__Env_create, file);
        newXS("BerkeleyDB::Env::open", XS_BerkeleyDB__Env_open, file);
        newXS("BerkeleyDB::Env::cds_enabled", XS_BerkeleyDB__Env_cds_enabled, file);
        newXS("BerkeleyDB::Env::set_encrypt", XS_BerkeleyDB__Env_set_encrypt, file);
        newXS("BerkeleyDB::Env::_db_appinit", XS_BerkeleyDB__Env__db_appinit, file);
        newXS("BerkeleyDB::Env::DB_ENV", XS_BerkeleyDB__Env_DB_ENV, file);
        newXS("BerkeleyDB::Env::log_archive", XS_BerkeleyDB__Env_log_archive, file);
        newXS("BerkeleyDB::Env::_txn_begin", XS_BerkeleyDB__Env__txn_begin, file);
        newXS("BerkeleyDB::Env::txn_checkpoint", XS_BerkeleyDB__Env_txn_checkpoint, file);
        newXS("BerkeleyDB::Env::txn_stat", XS_BerkeleyDB__Env_txn_stat, file);
        newXS("BerkeleyDB::Env::printEnv", XS_BerkeleyDB__Env_printEnv, file);
        newXS("BerkeleyDB::Env::errPrefix", XS_BerkeleyDB__Env_errPrefix, file);
        newXS("BerkeleyDB::Env::status", XS_BerkeleyDB__Env_status, file);
        cv = newXS("BerkeleyDB::Env::db_appexit", XS_BerkeleyDB__Env_db_appexit, file);
        XSANY.any_i32 = 0 ;
        cv = newXS("BerkeleyDB::Env::close", XS_BerkeleyDB__Env_db_appexit, file);
        XSANY.any_i32 = 1 ;
        newXS("BerkeleyDB::Env::_DESTROY", XS_BerkeleyDB__Env__DESTROY, file);
        newXS("BerkeleyDB::Env::_TxnMgr", XS_BerkeleyDB__Env__TxnMgr, file);
        newXS("BerkeleyDB::Env::get_shm_key", XS_BerkeleyDB__Env_get_shm_key, file);
        newXS("BerkeleyDB::Env::set_lg_dir", XS_BerkeleyDB__Env_set_lg_dir, file);
        newXS("BerkeleyDB::Env::set_lg_bsize", XS_BerkeleyDB__Env_set_lg_bsize, file);
        newXS("BerkeleyDB::Env::set_lg_max", XS_BerkeleyDB__Env_set_lg_max, file);
        newXS("BerkeleyDB::Env::set_data_dir", XS_BerkeleyDB__Env_set_data_dir, file);
        newXS("BerkeleyDB::Env::set_tmp_dir", XS_BerkeleyDB__Env_set_tmp_dir, file);
        newXS("BerkeleyDB::Env::set_mutexlocks", XS_BerkeleyDB__Env_set_mutexlocks, file);
        newXS("BerkeleyDB::Env::set_verbose", XS_BerkeleyDB__Env_set_verbose, file);
        newXS("BerkeleyDB::Env::set_flags", XS_BerkeleyDB__Env_set_flags, file);
        newXS("BerkeleyDB::Term::close_everything", XS_BerkeleyDB__Term_close_everything, file);
        newXS("BerkeleyDB::Term::safeCroak", XS_BerkeleyDB__Term_safeCroak, file);
        newXS("BerkeleyDB::Hash::_db_open_hash", XS_BerkeleyDB__Hash__db_open_hash, file);
        newXS("BerkeleyDB::Hash::db_stat", XS_BerkeleyDB__Hash_db_stat, file);
        newXS("BerkeleyDB::Unknown::_db_open_unknown", XS_BerkeleyDB__Unknown__db_open_unknown, file);
        newXS("BerkeleyDB::Btree::_db_open_btree", XS_BerkeleyDB__Btree__db_open_btree, file);
        newXS("BerkeleyDB::Btree::db_stat", XS_BerkeleyDB__Btree_db_stat, file);
        newXS("BerkeleyDB::Recno::_db_open_recno", XS_BerkeleyDB__Recno__db_open_recno, file);
        newXS("BerkeleyDB::Queue::_db_open_queue", XS_BerkeleyDB__Queue__db_open_queue, file);
        newXS("BerkeleyDB::Queue::db_stat", XS_BerkeleyDB__Queue_db_stat, file);
        newXS("BerkeleyDB::Common::db_close", XS_BerkeleyDB__Common_db_close, file);
        newXS("BerkeleyDB::Common::_DESTROY", XS_BerkeleyDB__Common__DESTROY, file);
        cv = newXS("BerkeleyDB::Common::__db_write_cursor", XS_BerkeleyDB__Common__db_cursor, file);
        XSANY.any_i32 = 1 ;
        cv = newXS("BerkeleyDB::Common::_db_cursor", XS_BerkeleyDB__Common__db_cursor, file);
        XSANY.any_i32 = 0 ;
        newXS("BerkeleyDB::Common::_db_join", XS_BerkeleyDB__Common__db_join, file);
        newXS("BerkeleyDB::Common::ArrayOffset", XS_BerkeleyDB__Common_ArrayOffset, file);
        newXS("BerkeleyDB::Common::cds_enabled", XS_BerkeleyDB__Common_cds_enabled, file);
        newXS("BerkeleyDB::Common::type", XS_BerkeleyDB__Common_type, file);
        newXS("BerkeleyDB::Common::byteswapped", XS_BerkeleyDB__Common_byteswapped, file);
        newXS("BerkeleyDB::Common::status", XS_BerkeleyDB__Common_status, file);
#if XSubPPtmpAAAA
        newXS("BerkeleyDB::Common::filter_fetch_key", XS_BerkeleyDB__Common_filter_fetch_key, file);
        newXS("BerkeleyDB::Common::filter_store_key", XS_BerkeleyDB__Common_filter_store_key, file);
        newXS("BerkeleyDB::Common::filter_fetch_value", XS_BerkeleyDB__Common_filter_fetch_value, file);
        newXS("BerkeleyDB::Common::filter_store_value", XS_BerkeleyDB__Common_filter_store_value, file);
#endif
        newXS("BerkeleyDB::Common::partial_set", XS_BerkeleyDB__Common_partial_set, file);
        newXS("BerkeleyDB::Common::partial_clear", XS_BerkeleyDB__Common_partial_clear, file);
        newXS("BerkeleyDB::Common::db_del", XS_BerkeleyDB__Common_db_del, file);
        newXS("BerkeleyDB::Common::db_get", XS_BerkeleyDB__Common_db_get, file);
        newXS("BerkeleyDB::Common::db_pget", XS_BerkeleyDB__Common_db_pget, file);
        newXS("BerkeleyDB::Common::db_put", XS_BerkeleyDB__Common_db_put, file);
        newXS("BerkeleyDB::Common::db_key_range", XS_BerkeleyDB__Common_db_key_range, file);
        newXS("BerkeleyDB::Common::db_fd", XS_BerkeleyDB__Common_db_fd, file);
        newXS("BerkeleyDB::Common::db_sync", XS_BerkeleyDB__Common_db_sync, file);
        newXS("BerkeleyDB::Common::_Txn", XS_BerkeleyDB__Common__Txn, file);
        newXS("BerkeleyDB::Common::truncate", XS_BerkeleyDB__Common_truncate, file);
        newXS("BerkeleyDB::Common::associate", XS_BerkeleyDB__Common_associate, file);
        newXS("BerkeleyDB::Common::compact", XS_BerkeleyDB__Common_compact, file);
        newXS("BerkeleyDB::Cursor::_c_dup", XS_BerkeleyDB__Cursor__c_dup, file);
        newXS("BerkeleyDB::Cursor::_c_close", XS_BerkeleyDB__Cursor__c_close, file);
        newXS("BerkeleyDB::Cursor::_DESTROY", XS_BerkeleyDB__Cursor__DESTROY, file);
        newXS("BerkeleyDB::Cursor::status", XS_BerkeleyDB__Cursor_status, file);
        newXS("BerkeleyDB::Cursor::c_del", XS_BerkeleyDB__Cursor_c_del, file);
        newXS("BerkeleyDB::Cursor::c_get", XS_BerkeleyDB__Cursor_c_get, file);
        newXS("BerkeleyDB::Cursor::c_pget", XS_BerkeleyDB__Cursor_c_pget, file);
        newXS("BerkeleyDB::Cursor::c_put", XS_BerkeleyDB__Cursor_c_put, file);
        newXS("BerkeleyDB::Cursor::c_count", XS_BerkeleyDB__Cursor_c_count, file);
        newXS("BerkeleyDB::TxnMgr::_txn_begin", XS_BerkeleyDB__TxnMgr__txn_begin, file);
        newXS("BerkeleyDB::TxnMgr::status", XS_BerkeleyDB__TxnMgr_status, file);
        newXS("BerkeleyDB::TxnMgr::_DESTROY", XS_BerkeleyDB__TxnMgr__DESTROY, file);
        newXS("BerkeleyDB::TxnMgr::txn_close", XS_BerkeleyDB__TxnMgr_txn_close, file);
        newXS("BerkeleyDB::TxnMgr::txn_checkpoint", XS_BerkeleyDB__TxnMgr_txn_checkpoint, file);
        newXS("BerkeleyDB::TxnMgr::txn_stat", XS_BerkeleyDB__TxnMgr_txn_stat, file);
        newXS("BerkeleyDB::TxnMgr::txn_open", XS_BerkeleyDB__TxnMgr_txn_open, file);
        newXS("BerkeleyDB::Txn::status", XS_BerkeleyDB__Txn_status, file);
        newXS("BerkeleyDB::Txn::_DESTROY", XS_BerkeleyDB__Txn__DESTROY, file);
        newXS("BerkeleyDB::Txn::txn_unlink", XS_BerkeleyDB__Txn_txn_unlink, file);
        newXS("BerkeleyDB::Txn::txn_prepare", XS_BerkeleyDB__Txn_txn_prepare, file);
        newXS("BerkeleyDB::Txn::_txn_commit", XS_BerkeleyDB__Txn__txn_commit, file);
        newXS("BerkeleyDB::Txn::_txn_abort", XS_BerkeleyDB__Txn__txn_abort, file);
        newXS("BerkeleyDB::Txn::_txn_discard", XS_BerkeleyDB__Txn__txn_discard, file);
        newXS("BerkeleyDB::Txn::txn_id", XS_BerkeleyDB__Txn_txn_id, file);
        newXS("BerkeleyDB::_tiedHash::FIRSTKEY", XS_BerkeleyDB___tiedHash_FIRSTKEY, file);
        newXS("BerkeleyDB::_tiedHash::NEXTKEY", XS_BerkeleyDB___tiedHash_NEXTKEY, file);
        newXS("BerkeleyDB::_tiedArray::FETCHSIZE", XS_BerkeleyDB___tiedArray_FETCHSIZE, file);
    }

    /* Initialisation Section */

#if XSubPPtmpAAAA
#endif
#line 4136 "BerkeleyDB.xs"
  {
    SV * sv_err = perl_get_sv(ERR_BUFF, GV_ADD|GV_ADDMULTI) ;
    SV * version_sv = perl_get_sv("BerkeleyDB::db_version", GV_ADD|GV_ADDMULTI) ;
    SV * ver_sv = perl_get_sv("BerkeleyDB::db_ver", GV_ADD|GV_ADDMULTI) ;
    int Major, Minor, Patch ;
    (void)db_version(&Major, &Minor, &Patch) ;
    /* Check that the versions of db.h and libdb.a are the same */
    if (Major != DB_VERSION_MAJOR || Minor != DB_VERSION_MINOR
                || Patch != DB_VERSION_PATCH)
        croak("\nBerkeleyDB needs compatible versions of libdb & db.h\n\tyou have db.h version %d.%d.%d and libdb version %d.%d.%d\n",
                DB_VERSION_MAJOR, DB_VERSION_MINOR, DB_VERSION_PATCH,
                Major, Minor, Patch) ;

    if (Major < 2 || (Major == 2 && Minor < 6))
    {
        croak("BerkeleyDB needs Berkeley DB 2.6 or greater. This is %d.%d.%d\n",
		Major, Minor, Patch) ;
    }
    sv_setpvf(version_sv, "%d.%d", Major, Minor) ;
    sv_setpvf(ver_sv, "%d.%03d%03d", Major, Minor, Patch) ;
    sv_setpv(sv_err, "");

    DBT_clear(empty) ;
    empty.data  = &zero ;
    empty.size  =  sizeof(db_recno_t) ;
    empty.flags = 0 ;

  }

#line 6752 "BerkeleyDB.c"

    /* End of Initialisation Section */

    XSRETURN_YES;
}

